*
* $Id: sfafg1.F,v 1.1.1.2 1996/10/30 08:32:30 cernlib Exp $
*
* $Log: sfafg1.F,v $
* Revision 1.1.1.2  1996/10/30 08:32:30  cernlib
* Version 7.04
*
* Revision 1.2  1996/10/28 15:05:02  pdflib
* PDFLIB new version 7.04
*
* Revision 1.1.1.1  1996/04/12 15:29:30  plothow
* Version 7.01
*
*
#include "pdf/pilot.h"
      SUBROUTINE SFAFG1(DX,DQ,DUV,DDV,DUB,DDB,DSB,DCB,DGL)
C
C**************************************************************************
C                       ( 1st of February 1994)
C     This is an interpolation program which reads the files GRPOL and
C     GRVDM and gives the quark and gluon distributions in real photon
C     as functions of x and Q**2.
C
C     The Q**2 evolution is a BLL evolution (MSbar scheme) with Nf=4
C     and LAMBDA(MSbar)=.200 Gev.
C
C     A massless charm distribution is generated for Q**2 > 2 Gev**2.
C
C     The distributions are the sum of a pointlike part (PL) and of a
C     Vdm part (VDM):
C                     dist=PL + KA*VDM
C     KA is a factor which can be adjusted ( the default value is KA=1.0).
C     The file GRPOL contains the pointlike part of the distributions.
C     The file GRVDM contains the vdm part (A precise definition of this
C     latter is given in the paper "PARTON DISTRIBUTIONS IN THE PHOTON",
C     Preprint LPTHE Orsay 93-37, by P.Aurenche,M.Fontannaz and J.Ph.Guillet).
C
C     The output of the program is written in the file GETOUT with the
C     following conventions
C                              UPLUS=x(u+ubar)
C                              DPLUS=x(d+dbar)
C                              SPLUS=x(s+sbar)
C                              CPLUS=x(c+cbar)
C                              SING =UPLUS+DPLUS+SPLUS+CPLUS
C                              GLU  =x*g
C
C      The interpolation is valid for     2. < Q**2 < 5.5E+5 Gev**2,
C                             and for   .0015<  x   < .99
C
C      The program also gives the structure function F2:
C                        F2 = q*Cq + g*Cg + Cgam
C      Cq and Cg are the Wilson coeficients and Cgam is the direct term.
C
C      Although the charm quark evolution is massless, the direct term
C      Cgam includes the effects due to the charm quark mass. The charm
C      quark threshold is therefore correctly described at the lowest
C      ordre in alphastrong (Details are given in the preprint).
C
C
C**************************************************************************
C
#include "pdf/expdp.inc"
     +       DX,DQ,DUV,DDV,DUB,DDB,DSB,DCB,DBB,DGL
      REAL    X, Q, UV, DV, UB, DB, SB, CB, BB, GL
      REAL       Q2
      DIMENSION XPDF(7)
      DIMENSION PAR(30), CALC(8,20,32),CALCO(8,20,32)
      DIMENSION PAR2(30),CELC(8,20,32),CELCO(8,20,32)
      COMMON/W5051IA/CALCO
      COMMON/W5051IB/CELCO
      EXTERNAL AFCPLU
      DATA ZERO/0.0/
C----------------------------------------------------------------------
        DATA (PAR(I),I=1,30) / 
     +       .2000E+00,      .4800E+00,      .8500E+00,      .1000E+01,
     +       .1000E+01,      .1000E+01,      .1200E+01,      .7500E+01,
     +       .1987E+01,      .1900E+01,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .1000E+01,
     +       .0000E+00,      .1000E+01,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .4000E+01,      .0000E+00,      .2000E+01,      .1000E+01,
     +       .8000E-01,      .2000E+01/
        DATA ((CALC(I,K,1 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .7046E-04,     -.1941E-04,
     +       .3163E-04,     -.1941E-04,      .2818E-03,      .1587E-02,
     +       .0000E+00,      .0000E+00,      .6989E-04,     -.1815E-04,
     +       .3360E-04,     -.1815E-04,      .4710E-03,      .2351E-02,
     +       .0000E+00,      .0000E+00,      .6919E-04,     -.1670E-04,
     +       .3579E-04,     -.1670E-04,      .7175E-03,      .3348E-02,
     +       .0000E+00,      .0000E+00,      .6833E-04,     -.1507E-04,
     +       .3820E-04,     -.1507E-04,      .1033E-02,      .4635E-02,
     +       .0000E+00,      .0000E+00,      .6730E-04,     -.1322E-04,
     +       .4085E-04,     -.1322E-04,      .1429E-02,      .6264E-02,
     +       .0000E+00,      .0000E+00,      .6607E-04,     -.1115E-04,
     +       .4378E-04,     -.1115E-04,      .1920E-02,      .8299E-02,
     +       .0000E+00,      .0000E+00,      .6463E-04,     -.8819E-05,
     +       .4699E-04,     -.8819E-05,      .2521E-02,      .1081E-01,
     +       .0000E+00,      .0000E+00,      .6295E-04,     -.6218E-05,
     +       .5052E-04,     -.6218E-05,      .3249E-02,      .1387E-01,
     +       .0000E+00,      .0000E+00,      .6102E-04,     -.3316E-05,
     +       .5439E-04,     -.3316E-05,      .4126E-02,      .1757E-01/
        DATA ((CALC(I,K,1 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .5879E-04,     -.8646E-07,
     +       .5862E-04,     -.8646E-07,      .5172E-02,      .2200E-01,
     +       .0000E+00,      .0000E+00,      .5624E-04,      .3500E-05,
     +       .6325E-04,      .3500E-05,      .6413E-02,      .2726E-01,
     +       .0000E+00,      .0000E+00,      .5335E-04,      .7477E-05,
     +       .6830E-04,      .7477E-05,      .7877E-02,      .3346E-01,
     +       .0000E+00,      .0000E+00,      .5007E-04,      .1188E-04,
     +       .7383E-04,      .1188E-04,      .9594E-02,      .4073E-01,
     +       .0000E+00,      .0000E+00,      .4636E-04,      .1675E-04,
     +       .7986E-04,      .1675E-04,      .1160E-01,      .4919E-01,
     +       .0000E+00,      .0000E+00,      .4220E-04,      .2212E-04,
     +       .8643E-04,      .2212E-04,      .1393E-01,      .5898E-01,
     +       .0000E+00,      .0000E+00,      .3752E-04,      .2804E-04,
     +       .9361E-04,      .2804E-04,      .1663E-01,      .7026E-01,
     +       .0000E+00,      .0000E+00,      .3228E-04,      .3457E-04,
     +       .1014E-03,      .3457E-04,      .1974E-01,      .8319E-01,
     +       .0000E+00,      .0000E+00,      .2644E-04,      .4175E-04,
     +       .1099E-03,      .4175E-04,      .2331E-01,      .9795E-01/
        DATA ((CALC(I,K,1 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .1992E-04,      .4964E-04,
     +       .1192E-03,      .4964E-04,      .2740E-01,      .1147E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,2 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .8644E-04,     -.1332E-04,
     +       .5980E-04,     -.1332E-04,      .3458E-03,      .1536E-02,
     +       .0000E+00,      .0000E+00,      .8349E-04,     -.8330E-05,
     +       .6683E-04,     -.8330E-05,      .5160E-03,      .2121E-02,
     +       .0000E+00,      .0000E+00,      .7998E-04,     -.2714E-05,
     +       .7455E-04,     -.2714E-05,      .7238E-03,      .2849E-02,
     +       .0000E+00,      .0000E+00,      .7586E-04,      .3591E-05,
     +       .8305E-04,      .3591E-05,      .9745E-03,      .3743E-02,
     +       .0000E+00,      .0000E+00,      .7107E-04,      .1064E-04,
     +       .9236E-04,      .1064E-04,      .1273E-02,      .4826E-02,
     +       .0000E+00,      .0000E+00,      .6553E-04,      .1851E-04,
     +       .1026E-03,      .1851E-04,      .1627E-02,      .6122E-02,
     +       .0000E+00,      .0000E+00,      .5919E-04,      .2727E-04,
     +       .1137E-03,      .2727E-04,      .2041E-02,      .7658E-02,
     +       .0000E+00,      .0000E+00,      .5194E-04,      .3699E-04,
     +       .1259E-03,      .3699E-04,      .2522E-02,      .9460E-02,
     +       .0000E+00,      .0000E+00,      .4373E-04,      .4776E-04,
     +       .1393E-03,      .4776E-04,      .3079E-02,      .1156E-01/
        DATA ((CALC(I,K,2 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .3444E-04,      .5968E-04,
     +       .1538E-03,      .5968E-04,      .3719E-02,      .1398E-01,
     +       .0000E+00,      .0000E+00,      .2398E-04,      .7284E-04,
     +       .1697E-03,      .7284E-04,      .4451E-02,      .1676E-01,
     +       .0000E+00,      .0000E+00,      .1224E-04,      .8735E-04,
     +       .1869E-03,      .8735E-04,      .5284E-02,      .1993E-01,
     +       .0000E+00,      .0000E+00,     -.8887E-06,      .1033E-03,
     +       .2058E-03,      .1033E-03,      .6227E-02,      .2353E-01,
     +       .0000E+00,      .0000E+00,     -.1555E-04,      .1209E-03,
     +       .2263E-03,      .1209E-03,      .7292E-02,      .2758E-01,
     +       .0000E+00,      .0000E+00,     -.3187E-04,      .1402E-03,
     +       .2486E-03,      .1402E-03,      .8489E-02,      .3213E-01,
     +       .0000E+00,      .0000E+00,     -.5001E-04,      .1614E-03,
     +       .2729E-03,      .1614E-03,      .9830E-02,      .3721E-01,
     +       .0000E+00,      .0000E+00,     -.7012E-04,      .1847E-03,
     +       .2993E-03,      .1847E-03,      .1133E-01,      .4287E-01,
     +       .0000E+00,      .0000E+00,     -.9240E-04,      .2102E-03,
     +       .3280E-03,      .2102E-03,      .1299E-01,      .4915E-01/
        DATA ((CALC(I,K,2 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.1170E-03,      .2381E-03,
     +       .3592E-03,      .2381E-03,      .1484E-01,      .5608E-01,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,3 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .9767E-04,     -.1471E-05,
     +       .9472E-04,     -.1471E-05,      .3907E-03,      .1317E-02,
     +       .0000E+00,      .0000E+00,      .9108E-04,      .8666E-05,
     +       .1084E-03,      .8666E-05,      .5631E-03,      .1782E-02,
     +       .0000E+00,      .0000E+00,      .8336E-04,      .2002E-04,
     +       .1234E-03,      .2002E-04,      .7670E-03,      .2352E-02,
     +       .0000E+00,      .0000E+00,      .7440E-04,      .3269E-04,
     +       .1398E-03,      .3269E-04,      .1006E-02,      .3044E-02,
     +       .0000E+00,      .0000E+00,      .6409E-04,      .4681E-04,
     +       .1577E-03,      .4681E-04,      .1286E-02,      .3872E-02,
     +       .0000E+00,      .0000E+00,      .5230E-04,      .6248E-04,
     +       .1773E-03,      .6248E-04,      .1609E-02,      .4853E-02,
     +       .0000E+00,      .0000E+00,      .3889E-04,      .7985E-04,
     +       .1986E-03,      .7985E-04,      .1982E-02,      .6003E-02,
     +       .0000E+00,      .0000E+00,      .2372E-04,      .9906E-04,
     +       .2218E-03,      .9906E-04,      .2410E-02,      .7340E-02,
     +       .0000E+00,      .0000E+00,      .6630E-05,      .1203E-03,
     +       .2472E-03,      .1203E-03,      .2898E-02,      .8883E-02/
        DATA ((CALC(I,K,3 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.1255E-04,      .1436E-03,
     +       .2747E-03,      .1436E-03,      .3453E-02,      .1065E-01,
     +       .0000E+00,      .0000E+00,     -.3400E-04,      .1694E-03,
     +       .3047E-03,      .1694E-03,      .4082E-02,      .1267E-01,
     +       .0000E+00,      .0000E+00,     -.5792E-04,      .1976E-03,
     +       .3373E-03,      .1976E-03,      .4793E-02,      .1496E-01,
     +       .0000E+00,      .0000E+00,     -.8455E-04,      .2286E-03,
     +       .3728E-03,      .2286E-03,      .5593E-02,      .1754E-01,
     +       .0000E+00,      .0000E+00,     -.1141E-03,      .2627E-03,
     +       .4113E-03,      .2627E-03,      .6491E-02,      .2044E-01,
     +       .0000E+00,      .0000E+00,     -.1468E-03,      .3000E-03,
     +       .4531E-03,      .3000E-03,      .7497E-02,      .2369E-01,
     +       .0000E+00,      .0000E+00,     -.1831E-03,      .3408E-03,
     +       .4985E-03,      .3408E-03,      .8621E-02,      .2732E-01,
     +       .0000E+00,      .0000E+00,     -.2230E-03,      .3854E-03,
     +       .5479E-03,      .3854E-03,      .9874E-02,      .3134E-01,
     +       .0000E+00,      .0000E+00,     -.2671E-03,      .4342E-03,
     +       .6014E-03,      .4342E-03,      .1127E-01,      .3581E-01/
        DATA ((CALC(I,K,3 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.3156E-03,      .4876E-03,
     +       .6595E-03,      .4876E-03,      .1281E-01,      .4075E-01,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,4 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1161E-03,      .1080E-04,
     +       .1377E-03,      .1080E-04,      .4642E-03,      .1155E-02,
     +       .0000E+00,      .0000E+00,      .1047E-03,      .2719E-04,
     +       .1591E-03,      .2719E-04,      .6584E-03,      .1543E-02,
     +       .0000E+00,      .0000E+00,      .9152E-04,      .4545E-04,
     +       .1824E-03,      .4545E-04,      .8823E-03,      .2014E-02,
     +       .0000E+00,      .0000E+00,      .7636E-04,      .6577E-04,
     +       .2079E-03,      .6577E-04,      .1140E-02,      .2580E-02,
     +       .0000E+00,      .0000E+00,      .5906E-04,      .8831E-04,
     +       .2357E-03,      .8831E-04,      .1434E-02,      .3252E-02,
     +       .0000E+00,      .0000E+00,      .3943E-04,      .1132E-03,
     +       .2659E-03,      .1132E-03,      .1769E-02,      .4039E-02,
     +       .0000E+00,      .0000E+00,      .1725E-04,      .1408E-03,
     +       .2989E-03,      .1408E-03,      .2149E-02,      .4953E-02,
     +       .0000E+00,      .0000E+00,     -.7685E-05,      .1712E-03,
     +       .3346E-03,      .1712E-03,      .2578E-02,      .6007E-02,
     +       .0000E+00,      .0000E+00,     -.3561E-04,      .2046E-03,
     +       .3736E-03,      .2046E-03,      .3061E-02,      .7212E-02/
        DATA ((CALC(I,K,4 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.6680E-04,      .2413E-03,
     +       .4158E-03,      .2413E-03,      .3603E-02,      .8581E-02,
     +       .0000E+00,      .0000E+00,     -.1015E-03,      .2816E-03,
     +       .4618E-03,      .2816E-03,      .4210E-02,      .1013E-01,
     +       .0000E+00,      .0000E+00,     -.1401E-03,      .3258E-03,
     +       .5116E-03,      .3258E-03,      .4889E-02,      .1187E-01,
     +       .0000E+00,      .0000E+00,     -.1828E-03,      .3742E-03,
     +       .5657E-03,      .3742E-03,      .5644E-02,      .1382E-01,
     +       .0000E+00,      .0000E+00,     -.2300E-03,      .4272E-03,
     +       .6244E-03,      .4272E-03,      .6483E-02,      .1599E-01,
     +       .0000E+00,      .0000E+00,     -.2821E-03,      .4851E-03,
     +       .6881E-03,      .4851E-03,      .7415E-02,      .1840E-01,
     +       .0000E+00,      .0000E+00,     -.3395E-03,      .5484E-03,
     +       .7572E-03,      .5484E-03,      .8446E-02,      .2108E-01,
     +       .0000E+00,      .0000E+00,     -.4028E-03,      .6174E-03,
     +       .8321E-03,      .6174E-03,      .9585E-02,      .2403E-01,
     +       .0000E+00,      .0000E+00,     -.4722E-03,      .6927E-03,
     +       .9133E-03,      .6927E-03,      .1084E-01,      .2728E-01/
        DATA ((CALC(I,K,4 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.5485E-03,      .7749E-03,
     +       .1001E-02,      .7749E-03,      .1223E-01,      .3085E-01,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,5 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1386E-03,      .2317E-04,
     +       .1850E-03,      .2317E-04,      .5544E-03,      .1024E-02,
     +       .0000E+00,      .0000E+00,      .1214E-03,      .4659E-04,
     +       .2146E-03,      .4659E-04,      .7810E-03,      .1353E-02,
     +       .0000E+00,      .0000E+00,      .1017E-03,      .7259E-04,
     +       .2469E-03,      .7259E-04,      .1038E-02,      .1751E-02,
     +       .0000E+00,      .0000E+00,      .7926E-04,      .1014E-03,
     +       .2821E-03,      .1014E-03,      .1328E-02,      .2226E-02,
     +       .0000E+00,      .0000E+00,      .5382E-04,      .1332E-03,
     +       .3203E-03,      .1332E-03,      .1656E-02,      .2786E-02,
     +       .0000E+00,      .0000E+00,      .2514E-04,      .1684E-03,
     +       .3619E-03,      .1684E-03,      .2023E-02,      .3437E-02,
     +       .0000E+00,      .0000E+00,     -.7055E-05,      .2071E-03,
     +       .4071E-03,      .2071E-03,      .2435E-02,      .4188E-02,
     +       .0000E+00,      .0000E+00,     -.4305E-04,      .2496E-03,
     +       .4561E-03,      .2496E-03,      .2894E-02,      .5047E-02,
     +       .0000E+00,      .0000E+00,     -.8316E-04,      .2962E-03,
     +       .5093E-03,      .2962E-03,      .3407E-02,      .6023E-02/
        DATA ((CALC(I,K,5 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.1277E-03,      .3474E-03,
     +       .5671E-03,      .3474E-03,      .3977E-02,      .7125E-02,
     +       .0000E+00,      .0000E+00,     -.1772E-03,      .4034E-03,
     +       .6297E-03,      .4034E-03,      .4609E-02,      .8363E-02,
     +       .0000E+00,      .0000E+00,     -.2318E-03,      .4647E-03,
     +       .6976E-03,      .4647E-03,      .5308E-02,      .9746E-02,
     +       .0000E+00,      .0000E+00,     -.2922E-03,      .5317E-03,
     +       .7712E-03,      .5317E-03,      .6082E-02,      .1129E-01,
     +       .0000E+00,      .0000E+00,     -.3586E-03,      .6048E-03,
     +       .8510E-03,      .6048E-03,      .6935E-02,      .1299E-01,
     +       .0000E+00,      .0000E+00,     -.4318E-03,      .6846E-03,
     +       .9375E-03,      .6846E-03,      .7875E-02,      .1488E-01,
     +       .0000E+00,      .0000E+00,     -.5122E-03,      .7717E-03,
     +       .1031E-02,      .7717E-03,      .8909E-02,      .1696E-01,
     +       .0000E+00,      .0000E+00,     -.6004E-03,      .8665E-03,
     +       .1133E-02,      .8665E-03,      .1005E-01,      .1924E-01,
     +       .0000E+00,      .0000E+00,     -.6971E-03,      .9698E-03,
     +       .1243E-02,      .9698E-03,      .1129E-01,      .2174E-01/
        DATA ((CALC(I,K,5 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.8030E-03,      .1082E-02,
     +       .1362E-02,      .1082E-02,      .1266E-01,      .2448E-01,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,6 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1628E-03,      .3519E-04,
     +       .2333E-03,      .3519E-04,      .6514E-03,      .9133E-03,
     +       .0000E+00,      .0000E+00,      .1392E-03,      .6607E-04,
     +       .2714E-03,      .6607E-04,      .9167E-03,      .1195E-02,
     +       .0000E+00,      .0000E+00,      .1123E-03,      .1002E-03,
     +       .3128E-03,      .1002E-03,      .1214E-02,      .1535E-02,
     +       .0000E+00,      .0000E+00,      .8187E-04,      .1379E-03,
     +       .3578E-03,      .1379E-03,      .1546E-02,      .1939E-02,
     +       .0000E+00,      .0000E+00,      .4764E-04,      .1795E-03,
     +       .4067E-03,      .1795E-03,      .1916E-02,      .2412E-02,
     +       .0000E+00,      .0000E+00,      .9280E-05,      .2252E-03,
     +       .4597E-03,      .2252E-03,      .2328E-02,      .2960E-02,
     +       .0000E+00,      .0000E+00,     -.3354E-04,      .2754E-03,
     +       .5172E-03,      .2754E-03,      .2785E-02,      .3588E-02,
     +       .0000E+00,      .0000E+00,     -.8119E-04,      .3304E-03,
     +       .5796E-03,      .3304E-03,      .3291E-02,      .4303E-02,
     +       .0000E+00,      .0000E+00,     -.1341E-03,      .3906E-03,
     +       .6472E-03,      .3906E-03,      .3851E-02,      .5111E-02/
        DATA ((CALC(I,K,6 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.1926E-03,      .4565E-03,
     +       .7205E-03,      .4565E-03,      .4469E-02,      .6018E-02,
     +       .0000E+00,      .0000E+00,     -.2573E-03,      .5286E-03,
     +       .7999E-03,      .5286E-03,      .5151E-02,      .7031E-02,
     +       .0000E+00,      .0000E+00,     -.3286E-03,      .6072E-03,
     +       .8859E-03,      .6072E-03,      .5901E-02,      .8158E-02,
     +       .0000E+00,      .0000E+00,     -.4070E-03,      .6930E-03,
     +       .9790E-03,      .6930E-03,      .6725E-02,      .9406E-02,
     +       .0000E+00,      .0000E+00,     -.4933E-03,      .7865E-03,
     +       .1080E-02,      .7865E-03,      .7629E-02,      .1078E-01,
     +       .0000E+00,      .0000E+00,     -.5879E-03,      .8884E-03,
     +       .1189E-02,      .8884E-03,      .8620E-02,      .1230E-01,
     +       .0000E+00,      .0000E+00,     -.6917E-03,      .9994E-03,
     +       .1307E-02,      .9994E-03,      .9705E-02,      .1396E-01,
     +       .0000E+00,      .0000E+00,     -.8053E-03,      .1120E-02,
     +       .1435E-02,      .1120E-02,      .1089E-01,      .1578E-01,
     +       .0000E+00,      .0000E+00,     -.9295E-03,      .1252E-02,
     +       .1574E-02,      .1252E-02,      .1219E-01,      .1777E-01/
        DATA ((CALC(I,K,6 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.1065E-02,      .1394E-02,
     +       .1723E-02,      .1394E-02,      .1360E-01,      .1994E-01,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,7 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1866E-03,      .4643E-04,
     +       .2795E-03,      .4643E-04,      .7463E-03,      .8158E-03,
     +       .0000E+00,      .0000E+00,      .1562E-03,      .8485E-04,
     +       .3260E-03,      .8485E-04,      .1053E-02,      .1058E-02,
     +       .0000E+00,      .0000E+00,      .1220E-03,      .1272E-03,
     +       .3764E-03,      .1272E-03,      .1394E-02,      .1350E-02,
     +       .0000E+00,      .0000E+00,      .8344E-04,      .1738E-03,
     +       .4311E-03,      .1738E-03,      .1771E-02,      .1696E-02,
     +       .0000E+00,      .0000E+00,      .4033E-04,      .2250E-03,
     +       .4904E-03,      .2250E-03,      .2189E-02,      .2099E-02,
     +       .0000E+00,      .0000E+00,     -.7743E-05,      .2812E-03,
     +       .5547E-03,      .2812E-03,      .2651E-02,      .2564E-02,
     +       .0000E+00,      .0000E+00,     -.6118E-04,      .3428E-03,
     +       .6244E-03,      .3428E-03,      .3160E-02,      .3095E-02,
     +       .0000E+00,      .0000E+00,     -.1204E-03,      .4101E-03,
     +       .6998E-03,      .4101E-03,      .3721E-02,      .3697E-02,
     +       .0000E+00,      .0000E+00,     -.1859E-03,      .4837E-03,
     +       .7815E-03,      .4837E-03,      .4338E-02,      .4373E-02/
        DATA ((CALC(I,K,7 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.2582E-03,      .5641E-03,
     +       .8699E-03,      .5641E-03,      .5015E-02,      .5130E-02,
     +       .0000E+00,      .0000E+00,     -.3379E-03,      .6517E-03,
     +       .9656E-03,      .6517E-03,      .5758E-02,      .5972E-02,
     +       .0000E+00,      .0000E+00,     -.4255E-03,      .7473E-03,
     +       .1069E-02,      .7473E-03,      .6572E-02,      .6904E-02,
     +       .0000E+00,      .0000E+00,     -.5217E-03,      .8514E-03,
     +       .1181E-02,      .8514E-03,      .7463E-02,      .7933E-02,
     +       .0000E+00,      .0000E+00,     -.6272E-03,      .9647E-03,
     +       .1302E-02,      .9647E-03,      .8436E-02,      .9064E-02,
     +       .0000E+00,      .0000E+00,     -.7428E-03,      .1088E-02,
     +       .1433E-02,      .1088E-02,      .9500E-02,      .1030E-01,
     +       .0000E+00,      .0000E+00,     -.8692E-03,      .1222E-02,
     +       .1575E-02,      .1222E-02,      .1066E-01,      .1166E-01,
     +       .0000E+00,      .0000E+00,     -.1007E-02,      .1368E-02,
     +       .1728E-02,      .1368E-02,      .1193E-01,      .1314E-01,
     +       .0000E+00,      .0000E+00,     -.1158E-02,      .1526E-02,
     +       .1894E-02,      .1526E-02,      .1331E-01,      .1475E-01/
        DATA ((CALC(I,K,7 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.1323E-02,      .1698E-02,
     +       .2074E-02,      .1698E-02,      .1481E-01,      .1651E-01,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,8 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .2084E-03,      .5650E-04,
     +       .3213E-03,      .5650E-04,      .8334E-03,      .7299E-03,
     +       .0000E+00,      .0000E+00,      .1715E-03,      .1022E-03,
     +       .3760E-03,      .1022E-03,      .1182E-02,      .9382E-03,
     +       .0000E+00,      .0000E+00,      .1301E-03,      .1525E-03,
     +       .4352E-03,      .1525E-03,      .1567E-02,      .1189E-02,
     +       .0000E+00,      .0000E+00,      .8388E-04,      .2077E-03,
     +       .4993E-03,      .2077E-03,      .1991E-02,      .1485E-02,
     +       .0000E+00,      .0000E+00,      .3231E-04,      .2682E-03,
     +       .5687E-03,      .2682E-03,      .2458E-02,      .1830E-02,
     +       .0000E+00,      .0000E+00,     -.2499E-04,      .3344E-03,
     +       .6438E-03,      .3344E-03,      .2971E-02,      .2227E-02,
     +       .0000E+00,      .0000E+00,     -.8849E-04,      .4068E-03,
     +       .7251E-03,      .4068E-03,      .3534E-02,      .2679E-02,
     +       .0000E+00,      .0000E+00,     -.1587E-03,      .4858E-03,
     +       .8130E-03,      .4858E-03,      .4152E-02,      .3189E-02,
     +       .0000E+00,      .0000E+00,     -.2361E-03,      .5721E-03,
     +       .9081E-03,      .5721E-03,      .4829E-02,      .3760E-02/
        DATA ((CALC(I,K,8 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.3214E-03,      .6662E-03,
     +       .1011E-02,      .6662E-03,      .5569E-02,      .4397E-02,
     +       .0000E+00,      .0000E+00,     -.4152E-03,      .7686E-03,
     +       .1122E-02,      .7686E-03,      .6378E-02,      .5103E-02,
     +       .0000E+00,      .0000E+00,     -.5181E-03,      .8801E-03,
     +       .1242E-02,      .8801E-03,      .7262E-02,      .5882E-02,
     +       .0000E+00,      .0000E+00,     -.6310E-03,      .1001E-02,
     +       .1372E-02,      .1001E-02,      .8226E-02,      .6738E-02,
     +       .0000E+00,      .0000E+00,     -.7545E-03,      .1133E-02,
     +       .1512E-02,      .1133E-02,      .9278E-02,      .7677E-02,
     +       .0000E+00,      .0000E+00,     -.8897E-03,      .1277E-02,
     +       .1664E-02,      .1277E-02,      .1042E-01,      .8703E-02,
     +       .0000E+00,      .0000E+00,     -.1037E-02,      .1433E-02,
     +       .1828E-02,      .1433E-02,      .1167E-01,      .9823E-02,
     +       .0000E+00,      .0000E+00,     -.1199E-02,      .1602E-02,
     +       .2005E-02,      .1602E-02,      .1303E-01,      .1104E-01,
     +       .0000E+00,      .0000E+00,     -.1375E-02,      .1786E-02,
     +       .2197E-02,      .1786E-02,      .1450E-01,      .1236E-01/
        DATA ((CALC(I,K,8 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.1567E-02,      .1985E-02,
     +       .2404E-02,      .1985E-02,      .1610E-01,      .1380E-01,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,9 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .2271E-03,      .6509E-04,
     +       .3574E-03,      .6509E-04,      .9085E-03,      .6523E-03,
     +       .0000E+00,      .0000E+00,      .1845E-03,      .1177E-03,
     +       .4200E-03,      .1177E-03,      .1298E-02,      .8308E-03,
     +       .0000E+00,      .0000E+00,      .1368E-03,      .1754E-03,
     +       .4876E-03,      .1754E-03,      .1726E-02,      .1046E-02,
     +       .0000E+00,      .0000E+00,      .8354E-04,      .2386E-03,
     +       .5608E-03,      .2386E-03,      .2195E-02,      .1300E-02,
     +       .0000E+00,      .0000E+00,      .2438E-04,      .3077E-03,
     +       .6399E-03,      .3077E-03,      .2710E-02,      .1596E-02,
     +       .0000E+00,      .0000E+00,     -.4122E-04,      .3832E-03,
     +       .7254E-03,      .3832E-03,      .3274E-02,      .1935E-02,
     +       .0000E+00,      .0000E+00,     -.1138E-03,      .4657E-03,
     +       .8177E-03,      .4657E-03,      .3890E-02,      .2321E-02,
     +       .0000E+00,      .0000E+00,     -.1938E-03,      .5556E-03,
     +       .9175E-03,      .5556E-03,      .4564E-02,      .2755E-02,
     +       .0000E+00,      .0000E+00,     -.2821E-03,      .6536E-03,
     +       .1025E-02,      .6536E-03,      .5301E-02,      .3239E-02/
        DATA ((CALC(I,K,9 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.3791E-03,      .7603E-03,
     +       .1142E-02,      .7603E-03,      .6104E-02,      .3778E-02,
     +       .0000E+00,      .0000E+00,     -.4857E-03,      .8765E-03,
     +       .1267E-02,      .8765E-03,      .6980E-02,      .4373E-02,
     +       .0000E+00,      .0000E+00,     -.6025E-03,      .1003E-02,
     +       .1403E-02,      .1003E-02,      .7934E-02,      .5028E-02,
     +       .0000E+00,      .0000E+00,     -.7305E-03,      .1140E-02,
     +       .1550E-02,      .1140E-02,      .8973E-02,      .5746E-02,
     +       .0000E+00,      .0000E+00,     -.8706E-03,      .1289E-02,
     +       .1708E-02,      .1289E-02,      .1010E-01,      .6531E-02,
     +       .0000E+00,      .0000E+00,     -.1024E-02,      .1451E-02,
     +       .1879E-02,      .1451E-02,      .1133E-01,      .7387E-02,
     +       .0000E+00,      .0000E+00,     -.1191E-02,      .1627E-02,
     +       .2063E-02,      .1627E-02,      .1267E-01,      .8318E-02,
     +       .0000E+00,      .0000E+00,     -.1373E-02,      .1818E-02,
     +       .2262E-02,      .1818E-02,      .1412E-01,      .9330E-02,
     +       .0000E+00,      .0000E+00,     -.1572E-02,      .2025E-02,
     +       .2477E-02,      .2025E-02,      .1569E-01,      .1043E-01/
        DATA ((CALC(I,K,9 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.1789E-02,      .2249E-02,
     +       .2710E-02,      .2249E-02,      .1740E-01,      .1161E-01,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,10),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .2428E-03,      .7234E-04,
     +       .3876E-03,      .7234E-04,      .9714E-03,      .5822E-03,
     +       .0000E+00,      .0000E+00,      .1954E-03,      .1312E-03,
     +       .4580E-03,      .1312E-03,      .1399E-02,      .7344E-03,
     +       .0000E+00,      .0000E+00,      .1425E-03,      .1957E-03,
     +       .5339E-03,      .1957E-03,      .1868E-02,      .9186E-03,
     +       .0000E+00,      .0000E+00,      .8346E-04,      .2661E-03,
     +       .6158E-03,      .2661E-03,      .2380E-02,      .1137E-02,
     +       .0000E+00,      .0000E+00,      .1789E-04,      .3432E-03,
     +       .7043E-03,      .3432E-03,      .2941E-02,      .1390E-02,
     +       .0000E+00,      .0000E+00,     -.5477E-04,      .4272E-03,
     +       .7997E-03,      .4272E-03,      .3553E-02,      .1680E-02,
     +       .0000E+00,      .0000E+00,     -.1351E-03,      .5189E-03,
     +       .9027E-03,      .5189E-03,      .4221E-02,      .2010E-02,
     +       .0000E+00,      .0000E+00,     -.2238E-03,      .6187E-03,
     +       .1014E-02,      .6187E-03,      .4949E-02,      .2380E-02,
     +       .0000E+00,      .0000E+00,     -.3214E-03,      .7274E-03,
     +       .1134E-02,      .7274E-03,      .5743E-02,      .2792E-02/
        DATA ((CALC(I,K,10),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.4288E-03,      .8457E-03,
     +       .1263E-02,      .8457E-03,      .6607E-02,      .3249E-02,
     +       .0000E+00,      .0000E+00,     -.5467E-03,      .9743E-03,
     +       .1402E-02,      .9743E-03,      .7548E-02,      .3753E-02,
     +       .0000E+00,      .0000E+00,     -.6759E-03,      .1114E-02,
     +       .1552E-02,      .1114E-02,      .8571E-02,      .4306E-02,
     +       .0000E+00,      .0000E+00,     -.8175E-03,      .1266E-02,
     +       .1714E-02,      .1266E-02,      .9682E-02,      .4911E-02,
     +       .0000E+00,      .0000E+00,     -.9724E-03,      .1431E-02,
     +       .1889E-02,      .1431E-02,      .1089E-01,      .5570E-02,
     +       .0000E+00,      .0000E+00,     -.1142E-02,      .1610E-02,
     +       .2077E-02,      .1610E-02,      .1220E-01,      .6288E-02,
     +       .0000E+00,      .0000E+00,     -.1327E-02,      .1804E-02,
     +       .2281E-02,      .1804E-02,      .1363E-01,      .7067E-02,
     +       .0000E+00,      .0000E+00,     -.1528E-02,      .2014E-02,
     +       .2500E-02,      .2014E-02,      .1517E-01,      .7911E-02,
     +       .0000E+00,      .0000E+00,     -.1748E-02,      .2242E-02,
     +       .2737E-02,      .2242E-02,      .1684E-01,      .8824E-02/
        DATA ((CALC(I,K,10),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.1987E-02,      .2490E-02,
     +       .2992E-02,      .2490E-02,      .1866E-01,      .9812E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,11),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .2563E-03,      .7857E-04,
     +       .4134E-03,      .7857E-04,      .1025E-02,      .5194E-03,
     +       .0000E+00,      .0000E+00,      .2055E-03,      .1431E-03,
     +       .4916E-03,      .1431E-03,      .1490E-02,      .6484E-03,
     +       .0000E+00,      .0000E+00,      .1486E-03,      .2136E-03,
     +       .5758E-03,      .2136E-03,      .1997E-02,      .8056E-03,
     +       .0000E+00,      .0000E+00,      .8512E-04,      .2907E-03,
     +       .6665E-03,      .2907E-03,      .2550E-02,      .9920E-03,
     +       .0000E+00,      .0000E+00,      .1446E-04,      .3749E-03,
     +       .7642E-03,      .3749E-03,      .3154E-02,      .1209E-02,
     +       .0000E+00,      .0000E+00,     -.6396E-04,      .4667E-03,
     +       .8693E-03,      .4667E-03,      .3812E-02,      .1457E-02,
     +       .0000E+00,      .0000E+00,     -.1508E-03,      .5667E-03,
     +       .9826E-03,      .5667E-03,      .4529E-02,      .1739E-02,
     +       .0000E+00,      .0000E+00,     -.2467E-03,      .6756E-03,
     +       .1105E-02,      .6756E-03,      .5309E-02,      .2055E-02,
     +       .0000E+00,      .0000E+00,     -.3524E-03,      .7942E-03,
     +       .1236E-02,      .7942E-03,      .6158E-02,      .2406E-02/
        DATA ((CALC(I,K,11),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.4688E-03,      .9230E-03,
     +       .1377E-02,      .9230E-03,      .7081E-02,      .2794E-02,
     +       .0000E+00,      .0000E+00,     -.5967E-03,      .1063E-02,
     +       .1529E-02,      .1063E-02,      .8085E-02,      .3222E-02,
     +       .0000E+00,      .0000E+00,     -.7371E-03,      .1215E-02,
     +       .1693E-02,      .1215E-02,      .9174E-02,      .3690E-02,
     +       .0000E+00,      .0000E+00,     -.8909E-03,      .1380E-02,
     +       .1870E-02,      .1380E-02,      .1036E-01,      .4200E-02,
     +       .0000E+00,      .0000E+00,     -.1059E-02,      .1560E-02,
     +       .2060E-02,      .1560E-02,      .1164E-01,      .4756E-02,
     +       .0000E+00,      .0000E+00,     -.1243E-02,      .1754E-02,
     +       .2265E-02,      .1754E-02,      .1303E-01,      .5360E-02,
     +       .0000E+00,      .0000E+00,     -.1444E-02,      .1965E-02,
     +       .2486E-02,      .1965E-02,      .1454E-01,      .6013E-02,
     +       .0000E+00,      .0000E+00,     -.1663E-02,      .2193E-02,
     +       .2723E-02,      .2193E-02,      .1618E-01,      .6721E-02,
     +       .0000E+00,      .0000E+00,     -.1902E-02,      .2441E-02,
     +       .2980E-02,      .2441E-02,      .1795E-01,      .7484E-02/
        DATA ((CALC(I,K,11),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.2163E-02,      .2710E-02,
     +       .3256E-02,      .2710E-02,      .1987E-01,      .8309E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,12),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .2693E-03,      .8426E-04,
     +       .4380E-03,      .8426E-04,      .1077E-02,      .4633E-03,
     +       .0000E+00,      .0000E+00,      .2165E-03,      .1539E-03,
     +       .5243E-03,      .1539E-03,      .1576E-02,      .5719E-03,
     +       .0000E+00,      .0000E+00,      .1571E-03,      .2300E-03,
     +       .6171E-03,      .2300E-03,      .2120E-02,      .7054E-03,
     +       .0000E+00,      .0000E+00,      .9040E-04,      .3131E-03,
     +       .7167E-03,      .3131E-03,      .2713E-02,      .8644E-03,
     +       .0000E+00,      .0000E+00,      .1590E-04,      .4039E-03,
     +       .8238E-03,      .4039E-03,      .3359E-02,      .1050E-02,
     +       .0000E+00,      .0000E+00,     -.6708E-04,      .5029E-03,
     +       .9387E-03,      .5029E-03,      .4062E-02,      .1262E-02,
     +       .0000E+00,      .0000E+00,     -.1592E-03,      .6107E-03,
     +       .1062E-02,      .6107E-03,      .4827E-02,      .1503E-02,
     +       .0000E+00,      .0000E+00,     -.2614E-03,      .7281E-03,
     +       .1195E-02,      .7281E-03,      .5658E-02,      .1772E-02,
     +       .0000E+00,      .0000E+00,     -.3742E-03,      .8558E-03,
     +       .1337E-02,      .8558E-03,      .6561E-02,      .2071E-02/
        DATA ((CALC(I,K,12),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.4986E-03,      .9946E-03,
     +       .1491E-02,      .9946E-03,      .7542E-02,      .2402E-02,
     +       .0000E+00,      .0000E+00,     -.6356E-03,      .1145E-02,
     +       .1655E-02,      .1145E-02,      .8607E-02,      .2765E-02,
     +       .0000E+00,      .0000E+00,     -.7862E-03,      .1309E-02,
     +       .1832E-02,      .1309E-02,      .9762E-02,      .3161E-02,
     +       .0000E+00,      .0000E+00,     -.9513E-03,      .1487E-02,
     +       .2022E-02,      .1487E-02,      .1101E-01,      .3593E-02,
     +       .0000E+00,      .0000E+00,     -.1132E-02,      .1680E-02,
     +       .2227E-02,      .1680E-02,      .1237E-01,      .4062E-02,
     +       .0000E+00,      .0000E+00,     -.1330E-02,      .1889E-02,
     +       .2447E-02,      .1889E-02,      .1384E-01,      .4571E-02,
     +       .0000E+00,      .0000E+00,     -.1546E-02,      .2115E-02,
     +       .2684E-02,      .2115E-02,      .1544E-01,      .5120E-02,
     +       .0000E+00,      .0000E+00,     -.1782E-02,      .2361E-02,
     +       .2939E-02,      .2361E-02,      .1716E-01,      .5714E-02,
     +       .0000E+00,      .0000E+00,     -.2039E-02,      .2627E-02,
     +       .3214E-02,      .2627E-02,      .1903E-01,      .6354E-02/
        DATA ((CALC(I,K,12),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.2320E-02,      .2915E-02,
     +       .3510E-02,      .2915E-02,      .2106E-01,      .7044E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,13),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .2847E-03,      .9072E-04,
     +       .4660E-03,      .9072E-04,      .1139E-02,      .4132E-03,
     +       .0000E+00,      .0000E+00,      .2312E-03,      .1651E-03,
     +       .5612E-03,      .1651E-03,      .1672E-02,      .5041E-03,
     +       .0000E+00,      .0000E+00,      .1705E-03,      .2464E-03,
     +       .6631E-03,      .2464E-03,      .2253E-02,      .6168E-03,
     +       .0000E+00,      .0000E+00,      .1017E-03,      .3353E-03,
     +       .7722E-03,      .3353E-03,      .2885E-02,      .7519E-03,
     +       .0000E+00,      .0000E+00,      .2433E-04,      .4324E-03,
     +       .8890E-03,      .4324E-03,      .3574E-02,      .9099E-03,
     +       .0000E+00,      .0000E+00,     -.6240E-04,      .5383E-03,
     +       .1014E-02,      .5383E-03,      .4322E-02,      .1091E-02,
     +       .0000E+00,      .0000E+00,     -.1592E-03,      .6537E-03,
     +       .1148E-02,      .6537E-03,      .5135E-02,      .1296E-02,
     +       .0000E+00,      .0000E+00,     -.2669E-03,      .7793E-03,
     +       .1292E-02,      .7793E-03,      .6018E-02,      .1526E-02,
     +       .0000E+00,      .0000E+00,     -.3864E-03,      .9159E-03,
     +       .1445E-02,      .9159E-03,      .6977E-02,      .1781E-02/
        DATA ((CALC(I,K,13),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.5186E-03,      .1064E-02,
     +       .1610E-02,      .1064E-02,      .8017E-02,      .2062E-02,
     +       .0000E+00,      .0000E+00,     -.6644E-03,      .1226E-02,
     +       .1787E-02,      .1226E-02,      .9144E-02,      .2370E-02,
     +       .0000E+00,      .0000E+00,     -.8250E-03,      .1401E-02,
     +       .1977E-02,      .1401E-02,      .1037E-01,      .2707E-02,
     +       .0000E+00,      .0000E+00,     -.1001E-02,      .1591E-02,
     +       .2180E-02,      .1591E-02,      .1169E-01,      .3072E-02,
     +       .0000E+00,      .0000E+00,     -.1195E-02,      .1797E-02,
     +       .2399E-02,      .1797E-02,      .1312E-01,      .3468E-02,
     +       .0000E+00,      .0000E+00,     -.1407E-02,      .2020E-02,
     +       .2634E-02,      .2020E-02,      .1468E-01,      .3897E-02,
     +       .0000E+00,      .0000E+00,     -.1638E-02,      .2262E-02,
     +       .2886E-02,      .2262E-02,      .1636E-01,      .4359E-02,
     +       .0000E+00,      .0000E+00,     -.1891E-02,      .2524E-02,
     +       .3157E-02,      .2524E-02,      .1817E-01,      .4858E-02,
     +       .0000E+00,      .0000E+00,     -.2166E-02,      .2808E-02,
     +       .3449E-02,      .2808E-02,      .2014E-01,      .5394E-02/
        DATA ((CALC(I,K,13),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.2466E-02,      .3115E-02,
     +       .3764E-02,      .3115E-02,      .2227E-01,      .5972E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,14),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .3067E-03,      .9883E-04,
     +       .5044E-03,      .9883E-04,      .1227E-02,      .3693E-03,
     +       .0000E+00,      .0000E+00,      .2536E-03,      .1779E-03,
     +       .6094E-03,      .1779E-03,      .1796E-02,      .4446E-03,
     +       .0000E+00,      .0000E+00,      .1922E-03,      .2645E-03,
     +       .7213E-03,      .2645E-03,      .2416E-02,      .5393E-03,
     +       .0000E+00,      .0000E+00,      .1219E-03,      .3593E-03,
     +       .8405E-03,      .3593E-03,      .3090E-02,      .6537E-03,
     +       .0000E+00,      .0000E+00,      .4200E-04,      .4629E-03,
     +       .9677E-03,      .4629E-03,      .3823E-02,      .7880E-03,
     +       .0000E+00,      .0000E+00,     -.4833E-04,      .5759E-03,
     +       .1103E-02,      .5759E-03,      .4619E-02,      .9425E-03,
     +       .0000E+00,      .0000E+00,     -.1499E-03,      .6991E-03,
     +       .1248E-02,      .6991E-03,      .5484E-02,      .1117E-02,
     +       .0000E+00,      .0000E+00,     -.2634E-03,      .8332E-03,
     +       .1403E-02,      .8332E-03,      .6422E-02,      .1313E-02,
     +       .0000E+00,      .0000E+00,     -.3900E-03,      .9790E-03,
     +       .1568E-02,      .9790E-03,      .7439E-02,      .1530E-02/
        DATA ((CALC(I,K,14),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.5304E-03,      .1138E-02,
     +       .1745E-02,      .1138E-02,      .8541E-02,      .1769E-02,
     +       .0000E+00,      .0000E+00,     -.6857E-03,      .1310E-02,
     +       .1934E-02,      .1310E-02,      .9735E-02,      .2030E-02,
     +       .0000E+00,      .0000E+00,     -.8570E-03,      .1496E-02,
     +       .2136E-02,      .1496E-02,      .1103E-01,      .2315E-02,
     +       .0000E+00,      .0000E+00,     -.1046E-02,      .1699E-02,
     +       .2352E-02,      .1699E-02,      .1243E-01,      .2624E-02,
     +       .0000E+00,      .0000E+00,     -.1252E-02,      .1919E-02,
     +       .2585E-02,      .1919E-02,      .1394E-01,      .2958E-02,
     +       .0000E+00,      .0000E+00,     -.1479E-02,      .2156E-02,
     +       .2834E-02,      .2156E-02,      .1558E-01,      .3319E-02,
     +       .0000E+00,      .0000E+00,     -.1727E-02,      .2414E-02,
     +       .3101E-02,      .2414E-02,      .1735E-01,      .3707E-02,
     +       .0000E+00,      .0000E+00,     -.1998E-02,      .2693E-02,
     +       .3388E-02,      .2693E-02,      .1926E-01,      .4126E-02,
     +       .0000E+00,      .0000E+00,     -.2293E-02,      .2995E-02,
     +       .3697E-02,      .2995E-02,      .2133E-01,      .4576E-02/
        DATA ((CALC(I,K,14),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.2614E-02,      .3321E-02,
     +       .4029E-02,      .3321E-02,      .2357E-01,      .5059E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,15),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .3396E-03,      .1106E-03,
     +       .5609E-03,      .1106E-03,      .1359E-02,      .3308E-03,
     +       .0000E+00,      .0000E+00,      .2872E-03,      .1948E-03,
     +       .6768E-03,      .1948E-03,      .1968E-02,      .3925E-03,
     +       .0000E+00,      .0000E+00,      .2254E-03,      .2871E-03,
     +       .7996E-03,      .2871E-03,      .2631E-02,      .4717E-03,
     +       .0000E+00,      .0000E+00,      .1533E-03,      .3883E-03,
     +       .9299E-03,      .3883E-03,      .3351E-02,      .5682E-03,
     +       .0000E+00,      .0000E+00,      .7039E-04,      .4989E-03,
     +       .1068E-02,      .4989E-03,      .4134E-02,      .6820E-03,
     +       .0000E+00,      .0000E+00,     -.2425E-04,      .6197E-03,
     +       .1215E-02,      .6197E-03,      .4983E-02,      .8132E-03,
     +       .0000E+00,      .0000E+00,     -.1314E-03,      .7513E-03,
     +       .1371E-02,      .7513E-03,      .5905E-02,      .9619E-03,
     +       .0000E+00,      .0000E+00,     -.2520E-03,      .8947E-03,
     +       .1537E-02,      .8947E-03,      .6903E-02,      .1128E-02,
     +       .0000E+00,      .0000E+00,     -.3868E-03,      .1051E-02,
     +       .1714E-02,      .1051E-02,      .7984E-02,      .1313E-02/
        DATA ((CALC(I,K,15),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.5370E-03,      .1220E-02,
     +       .1903E-02,      .1220E-02,      .9155E-02,      .1515E-02,
     +       .0000E+00,      .0000E+00,     -.7034E-03,      .1404E-02,
     +       .2104E-02,      .1404E-02,      .1042E-01,      .1736E-02,
     +       .0000E+00,      .0000E+00,     -.8874E-03,      .1603E-02,
     +       .2319E-02,      .1603E-02,      .1179E-01,      .1977E-02,
     +       .0000E+00,      .0000E+00,     -.1090E-02,      .1819E-02,
     +       .2548E-02,      .1819E-02,      .1327E-01,      .2237E-02,
     +       .0000E+00,      .0000E+00,     -.1312E-02,      .2053E-02,
     +       .2794E-02,      .2053E-02,      .1487E-01,      .2518E-02,
     +       .0000E+00,      .0000E+00,     -.1556E-02,      .2307E-02,
     +       .3057E-02,      .2307E-02,      .1660E-01,      .2822E-02,
     +       .0000E+00,      .0000E+00,     -.1822E-02,      .2581E-02,
     +       .3339E-02,      .2581E-02,      .1847E-01,      .3148E-02,
     +       .0000E+00,      .0000E+00,     -.2113E-02,      .2878E-02,
     +       .3642E-02,      .2878E-02,      .2049E-01,      .3498E-02,
     +       .0000E+00,      .0000E+00,     -.2430E-02,      .3198E-02,
     +       .3967E-02,      .3198E-02,      .2267E-01,      .3874E-02/
        DATA ((CALC(I,K,15),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.2774E-02,      .3545E-02,
     +       .4316E-02,      .3545E-02,      .2503E-01,      .4278E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,16),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .3890E-03,      .1278E-03,
     +       .6446E-03,      .1278E-03,      .1556E-02,      .2970E-03,
     +       .0000E+00,      .0000E+00,      .3368E-03,      .2178E-03,
     +       .7725E-03,      .2178E-03,      .2212E-02,      .3471E-03,
     +       .0000E+00,      .0000E+00,      .2736E-03,      .3168E-03,
     +       .9072E-03,      .3168E-03,      .2924E-02,      .4127E-03,
     +       .0000E+00,      .0000E+00,      .1986E-03,      .4253E-03,
     +       .1049E-02,      .4253E-03,      .3698E-02,      .4937E-03,
     +       .0000E+00,      .0000E+00,      .1112E-03,      .5441E-03,
     +       .1199E-02,      .5441E-03,      .4537E-02,      .5898E-03,
     +       .0000E+00,      .0000E+00,      .1045E-04,      .6737E-03,
     +       .1358E-02,      .6737E-03,      .5447E-02,      .7009E-03,
     +       .0000E+00,      .0000E+00,     -.1044E-03,      .8150E-03,
     +       .1526E-02,      .8150E-03,      .6433E-02,      .8269E-03,
     +       .0000E+00,      .0000E+00,     -.2341E-03,      .9689E-03,
     +       .1704E-02,      .9689E-03,      .7500E-02,      .9678E-03,
     +       .0000E+00,      .0000E+00,     -.3798E-03,      .1136E-02,
     +       .1892E-02,      .1136E-02,      .8654E-02,      .1124E-02/
        DATA ((CALC(I,K,16),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.5422E-03,      .1318E-02,
     +       .2093E-02,      .1318E-02,      .9902E-02,      .1295E-02,
     +       .0000E+00,      .0000E+00,     -.7226E-03,      .1514E-02,
     +       .2306E-02,      .1514E-02,      .1125E-01,      .1482E-02,
     +       .0000E+00,      .0000E+00,     -.9219E-03,      .1728E-02,
     +       .2534E-02,      .1728E-02,      .1271E-01,      .1684E-02,
     +       .0000E+00,      .0000E+00,     -.1141E-02,      .1959E-02,
     +       .2776E-02,      .1959E-02,      .1428E-01,      .1903E-02,
     +       .0000E+00,      .0000E+00,     -.1382E-02,      .2209E-02,
     +       .3035E-02,      .2209E-02,      .1598E-01,      .2139E-02,
     +       .0000E+00,      .0000E+00,     -.1646E-02,      .2479E-02,
     +       .3313E-02,      .2479E-02,      .1781E-01,      .2393E-02,
     +       .0000E+00,      .0000E+00,     -.1934E-02,      .2772E-02,
     +       .3609E-02,      .2772E-02,      .1979E-01,      .2665E-02,
     +       .0000E+00,      .0000E+00,     -.2248E-02,      .3088E-02,
     +       .3928E-02,      .3088E-02,      .2192E-01,      .2957E-02,
     +       .0000E+00,      .0000E+00,     -.2589E-02,      .3429E-02,
     +       .4269E-02,      .3429E-02,      .2422E-01,      .3271E-02/
        DATA ((CALC(I,K,16),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.2960E-02,      .3798E-02,
     +       .4636E-02,      .3798E-02,      .2671E-01,      .3607E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,17),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .4607E-03,      .1520E-03,
     +       .7648E-03,      .1520E-03,      .1843E-02,      .2671E-03,
     +       .0000E+00,      .0000E+00,      .4070E-03,      .2493E-03,
     +       .9056E-03,      .2493E-03,      .2553E-02,      .3071E-03,
     +       .0000E+00,      .0000E+00,      .3403E-03,      .3563E-03,
     +       .1053E-02,      .3563E-03,      .3323E-02,      .3611E-03,
     +       .0000E+00,      .0000E+00,      .2600E-03,      .4736E-03,
     +       .1207E-02,      .4736E-03,      .4159E-02,      .4286E-03,
     +       .0000E+00,      .0000E+00,      .1653E-03,      .6020E-03,
     +       .1369E-02,      .6020E-03,      .5064E-02,      .5093E-03,
     +       .0000E+00,      .0000E+00,      .5554E-04,      .7421E-03,
     +       .1540E-02,      .7421E-03,      .6043E-02,      .6029E-03,
     +       .0000E+00,      .0000E+00,     -.7012E-04,      .8947E-03,
     +       .1719E-02,      .8947E-03,      .7103E-02,      .7092E-03,
     +       .0000E+00,      .0000E+00,     -.2125E-03,      .1061E-02,
     +       .1909E-02,      .1061E-02,      .8248E-02,      .8281E-03,
     +       .0000E+00,      .0000E+00,     -.3724E-03,      .1241E-02,
     +       .2109E-02,      .1241E-02,      .9484E-02,      .9595E-03/
        DATA ((CALC(I,K,17),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.5509E-03,      .1436E-02,
     +       .2322E-02,      .1436E-02,      .1082E-01,      .1103E-02,
     +       .0000E+00,      .0000E+00,     -.7488E-03,      .1648E-02,
     +       .2547E-02,      .1648E-02,      .1226E-01,      .1260E-02,
     +       .0000E+00,      .0000E+00,     -.9673E-03,      .1877E-02,
     +       .2787E-02,      .1877E-02,      .1381E-01,      .1430E-02,
     +       .0000E+00,      .0000E+00,     -.1208E-02,      .2125E-02,
     +       .3042E-02,      .2125E-02,      .1548E-01,      .1613E-02,
     +       .0000E+00,      .0000E+00,     -.1471E-02,      .2393E-02,
     +       .3314E-02,      .2393E-02,      .1729E-01,      .1810E-02,
     +       .0000E+00,      .0000E+00,     -.1758E-02,      .2682E-02,
     +       .3605E-02,      .2682E-02,      .1924E-01,      .2021E-02,
     +       .0000E+00,      .0000E+00,     -.2072E-02,      .2994E-02,
     +       .3917E-02,      .2994E-02,      .2133E-01,      .2247E-02,
     +       .0000E+00,      .0000E+00,     -.2412E-02,      .3331E-02,
     +       .4250E-02,      .3331E-02,      .2360E-01,      .2490E-02,
     +       .0000E+00,      .0000E+00,     -.2782E-02,      .3695E-02,
     +       .4608E-02,      .3695E-02,      .2603E-01,      .2750E-02/
        DATA ((CALC(I,K,17),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.3183E-02,      .4088E-02,
     +       .4993E-02,      .4088E-02,      .2866E-01,      .3028E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,18),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .5599E-03,      .1856E-03,
     +       .9310E-03,      .1856E-03,      .2240E-02,      .2405E-03,
     +       .0000E+00,      .0000E+00,      .5015E-03,      .2917E-03,
     +       .1085E-02,      .2917E-03,      .3014E-02,      .2720E-03,
     +       .0000E+00,      .0000E+00,      .4279E-03,      .4085E-03,
     +       .1245E-02,      .4085E-03,      .3852E-02,      .3160E-03,
     +       .0000E+00,      .0000E+00,      .3385E-03,      .5364E-03,
     +       .1411E-02,      .5364E-03,      .4760E-02,      .3719E-03,
     +       .0000E+00,      .0000E+00,      .2325E-03,      .6763E-03,
     +       .1585E-02,      .6763E-03,      .5741E-02,      .4393E-03,
     +       .0000E+00,      .0000E+00,      .1094E-03,      .8288E-03,
     +       .1767E-02,      .8288E-03,      .6800E-02,      .5177E-03,
     +       .0000E+00,      .0000E+00,     -.3146E-04,      .9946E-03,
     +       .1958E-02,      .9946E-03,      .7943E-02,      .6069E-03,
     +       .0000E+00,      .0000E+00,     -.1909E-03,      .1175E-02,
     +       .2158E-02,      .1175E-02,      .9176E-02,      .7066E-03,
     +       .0000E+00,      .0000E+00,     -.3697E-03,      .1370E-02,
     +       .2370E-02,      .1370E-02,      .1050E-01,      .8166E-03/
        DATA ((CALC(I,K,18),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.5687E-03,      .1581E-02,
     +       .2593E-02,      .1581E-02,      .1194E-01,      .9369E-03,
     +       .0000E+00,      .0000E+00,     -.7888E-03,      .1809E-02,
     +       .2830E-02,      .1809E-02,      .1348E-01,      .1068E-02,
     +       .0000E+00,      .0000E+00,     -.1031E-02,      .2056E-02,
     +       .3081E-02,      .2056E-02,      .1514E-01,      .1209E-02,
     +       .0000E+00,      .0000E+00,     -.1296E-02,      .2323E-02,
     +       .3349E-02,      .2323E-02,      .1692E-01,      .1361E-02,
     +       .0000E+00,      .0000E+00,     -.1586E-02,      .2610E-02,
     +       .3634E-02,      .2610E-02,      .1885E-01,      .1524E-02,
     +       .0000E+00,      .0000E+00,     -.1902E-02,      .2920E-02,
     +       .3938E-02,      .2920E-02,      .2092E-01,      .1698E-02,
     +       .0000E+00,      .0000E+00,     -.2245E-02,      .3254E-02,
     +       .4264E-02,      .3254E-02,      .2314E-01,      .1885E-02,
     +       .0000E+00,      .0000E+00,     -.2616E-02,      .3615E-02,
     +       .4613E-02,      .3615E-02,      .2554E-01,      .2085E-02,
     +       .0000E+00,      .0000E+00,     -.3018E-02,      .4003E-02,
     +       .4987E-02,      .4003E-02,      .2813E-01,      .2299E-02/
        DATA ((CALC(I,K,18),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.3453E-02,      .4421E-02,
     +       .5390E-02,      .4421E-02,      .3091E-01,      .2527E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,19),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .6921E-03,      .2299E-03,
     +       .1152E-02,      .2299E-03,      .2768E-02,      .2166E-03,
     +       .0000E+00,      .0000E+00,      .6242E-03,      .3471E-03,
     +       .1318E-02,      .3471E-03,      .3617E-02,      .2409E-03,
     +       .0000E+00,      .0000E+00,      .5385E-03,      .4757E-03,
     +       .1490E-02,      .4757E-03,      .4534E-02,      .2764E-03,
     +       .0000E+00,      .0000E+00,      .4345E-03,      .6165E-03,
     +       .1668E-02,      .6165E-03,      .5524E-02,      .3223E-03,
     +       .0000E+00,      .0000E+00,      .3119E-03,      .7700E-03,
     +       .1852E-02,      .7700E-03,      .6591E-02,      .3781E-03,
     +       .0000E+00,      .0000E+00,      .1699E-03,      .9370E-03,
     +       .2044E-02,      .9370E-03,      .7740E-02,      .4434E-03,
     +       .0000E+00,      .0000E+00,      .8262E-05,      .1118E-02,
     +       .2244E-02,      .1118E-02,      .8976E-02,      .5176E-03,
     +       .0000E+00,      .0000E+00,     -.1738E-03,      .1314E-02,
     +       .2455E-02,      .1314E-02,      .1031E-01,      .6005E-03,
     +       .0000E+00,      .0000E+00,     -.3768E-03,      .1526E-02,
     +       .2676E-02,      .1526E-02,      .1174E-01,      .6918E-03/
        DATA ((CALC(I,K,19),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.6016E-03,      .1755E-02,
     +       .2909E-02,      .1755E-02,      .1327E-01,      .7915E-03,
     +       .0000E+00,      .0000E+00,     -.8489E-03,      .2002E-02,
     +       .3156E-02,      .2002E-02,      .1492E-01,      .8995E-03,
     +       .0000E+00,      .0000E+00,     -.1120E-02,      .2269E-02,
     +       .3417E-02,      .2269E-02,      .1670E-01,      .1016E-02,
     +       .0000E+00,      .0000E+00,     -.1415E-02,      .2555E-02,
     +       .3696E-02,      .2555E-02,      .1861E-01,      .1141E-02,
     +       .0000E+00,      .0000E+00,     -.1736E-02,      .2864E-02,
     +       .3992E-02,      .2864E-02,      .2066E-01,      .1274E-02,
     +       .0000E+00,      .0000E+00,     -.2084E-02,      .3197E-02,
     +       .4309E-02,      .3197E-02,      .2286E-01,      .1417E-02,
     +       .0000E+00,      .0000E+00,     -.2460E-02,      .3554E-02,
     +       .4649E-02,      .3554E-02,      .2523E-01,      .1570E-02,
     +       .0000E+00,      .0000E+00,     -.2866E-02,      .3939E-02,
     +       .5013E-02,      .3939E-02,      .2778E-01,      .1733E-02,
     +       .0000E+00,      .0000E+00,     -.3303E-02,      .4353E-02,
     +       .5403E-02,      .4353E-02,      .3052E-01,      .1907E-02/
        DATA ((CALC(I,K,19),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.3775E-02,      .4799E-02,
     +       .5823E-02,      .4799E-02,      .3346E-01,      .2093E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,20),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .8612E-03,      .2864E-03,
     +       .1434E-02,      .2864E-03,      .3445E-02,      .1949E-03,
     +       .0000E+00,      .0000E+00,      .7771E-03,      .4171E-03,
     +       .1611E-02,      .4171E-03,      .4379E-02,      .2130E-03,
     +       .0000E+00,      .0000E+00,      .6725E-03,      .5601E-03,
     +       .1792E-02,      .5601E-03,      .5385E-02,      .2412E-03,
     +       .0000E+00,      .0000E+00,      .5472E-03,      .7160E-03,
     +       .1979E-02,      .7160E-03,      .6467E-02,      .2785E-03,
     +       .0000E+00,      .0000E+00,      .4010E-03,      .8854E-03,
     +       .2172E-02,      .8854E-03,      .7628E-02,      .3243E-03,
     +       .0000E+00,      .0000E+00,      .2335E-03,      .1069E-02,
     +       .2371E-02,      .1069E-02,      .8876E-02,      .3780E-03,
     +       .0000E+00,      .0000E+00,      .4458E-04,      .1267E-02,
     +       .2579E-02,      .1267E-02,      .1021E-01,      .4392E-03,
     +       .0000E+00,      .0000E+00,     -.1663E-03,      .1482E-02,
     +       .2797E-02,      .1482E-02,      .1165E-01,      .5074E-03,
     +       .0000E+00,      .0000E+00,     -.3995E-03,      .1712E-02,
     +       .3025E-02,      .1712E-02,      .1319E-01,      .5825E-03/
        DATA ((CALC(I,K,20),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.6557E-03,      .1961E-02,
     +       .3266E-02,      .1961E-02,      .1484E-01,      .6641E-03,
     +       .0000E+00,      .0000E+00,     -.9356E-03,      .2228E-02,
     +       .3520E-02,      .2228E-02,      .1660E-01,      .7523E-03,
     +       .0000E+00,      .0000E+00,     -.1240E-02,      .2515E-02,
     +       .3791E-02,      .2515E-02,      .1850E-01,      .8470E-03,
     +       .0000E+00,      .0000E+00,     -.1569E-02,      .2824E-02,
     +       .4078E-02,      .2824E-02,      .2053E-01,      .9485E-03,
     +       .0000E+00,      .0000E+00,     -.1925E-02,      .3155E-02,
     +       .4385E-02,      .3155E-02,      .2271E-01,      .1057E-02,
     +       .0000E+00,      .0000E+00,     -.2309E-02,      .3511E-02,
     +       .4713E-02,      .3511E-02,      .2505E-01,      .1172E-02,
     +       .0000E+00,      .0000E+00,     -.2722E-02,      .3893E-02,
     +       .5065E-02,      .3893E-02,      .2757E-01,      .1296E-02,
     +       .0000E+00,      .0000E+00,     -.3165E-02,      .4304E-02,
     +       .5442E-02,      .4304E-02,      .3027E-01,      .1427E-02,
     +       .0000E+00,      .0000E+00,     -.3641E-02,      .4745E-02,
     +       .5848E-02,      .4745E-02,      .3317E-01,      .1567E-02/
        DATA ((CALC(I,K,20),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.4152E-02,      .5219E-02,
     +       .6285E-02,      .5219E-02,      .3629E-01,      .1716E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,21),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1070E-02,      .3563E-03,
     +       .1782E-02,      .3563E-03,      .4279E-02,      .1745E-03,
     +       .0000E+00,      .0000E+00,      .9609E-03,      .5031E-03,
     +       .1967E-02,      .5031E-03,      .5309E-02,      .1877E-03,
     +       .0000E+00,      .0000E+00,      .8288E-03,      .6629E-03,
     +       .2154E-02,      .6629E-03,      .6413E-02,      .2097E-03,
     +       .0000E+00,      .0000E+00,      .6737E-03,      .8362E-03,
     +       .2346E-02,      .8362E-03,      .7594E-02,      .2396E-03,
     +       .0000E+00,      .0000E+00,      .4959E-03,      .1024E-02,
     +       .2543E-02,      .1024E-02,      .8857E-02,      .2767E-03,
     +       .0000E+00,      .0000E+00,      .2953E-03,      .1226E-02,
     +       .2747E-02,      .1226E-02,      .1021E-01,      .3204E-03,
     +       .0000E+00,      .0000E+00,      .7187E-04,      .1443E-02,
     +       .2959E-02,      .1443E-02,      .1165E-01,      .3702E-03,
     +       .0000E+00,      .0000E+00,     -.1745E-03,      .1677E-02,
     +       .3180E-02,      .1677E-02,      .1320E-01,      .4256E-03,
     +       .0000E+00,      .0000E+00,     -.4441E-03,      .1928E-02,
     +       .3412E-02,      .1928E-02,      .1485E-01,      .4864E-03/
        DATA ((CALC(I,K,21),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.7373E-03,      .2197E-02,
     +       .3657E-02,      .2197E-02,      .1661E-01,      .5523E-03,
     +       .0000E+00,      .0000E+00,     -.1055E-02,      .2486E-02,
     +       .3917E-02,      .2486E-02,      .1850E-01,      .6233E-03,
     +       .0000E+00,      .0000E+00,     -.1397E-02,      .2795E-02,
     +       .4192E-02,      .2795E-02,      .2051E-01,      .6993E-03,
     +       .0000E+00,      .0000E+00,     -.1764E-02,      .3126E-02,
     +       .4486E-02,      .3126E-02,      .2267E-01,      .7804E-03,
     +       .0000E+00,      .0000E+00,     -.2159E-02,      .3480E-02,
     +       .4801E-02,      .3480E-02,      .2499E-01,      .8669E-03,
     +       .0000E+00,      .0000E+00,     -.2581E-02,      .3860E-02,
     +       .5138E-02,      .3860E-02,      .2747E-01,      .9589E-03,
     +       .0000E+00,      .0000E+00,     -.3032E-02,      .4266E-02,
     +       .5500E-02,      .4266E-02,      .3012E-01,      .1057E-02,
     +       .0000E+00,      .0000E+00,     -.3515E-02,      .4702E-02,
     +       .5890E-02,      .4702E-02,      .3297E-01,      .1161E-02,
     +       .0000E+00,      .0000E+00,     -.4030E-02,      .5170E-02,
     +       .6310E-02,      .5170E-02,      .3603E-01,      .1272E-02/
        DATA ((CALC(I,K,21),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.4580E-02,      .5672E-02,
     +       .6764E-02,      .5672E-02,      .3932E-01,      .1390E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,22),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1320E-02,      .4396E-03,
     +       .2199E-02,      .4396E-03,      .5278E-02,      .1552E-03,
     +       .0000E+00,      .0000E+00,      .1175E-02,      .6052E-03,
     +       .2385E-02,      .6052E-03,      .6411E-02,      .1643E-03,
     +       .0000E+00,      .0000E+00,      .1005E-02,      .7844E-03,
     +       .2573E-02,      .7844E-03,      .7618E-02,      .1812E-03,
     +       .0000E+00,      .0000E+00,      .8101E-03,      .9775E-03,
     +       .2765E-02,      .9775E-03,      .8903E-02,      .2048E-03,
     +       .0000E+00,      .0000E+00,      .5915E-03,      .1185E-02,
     +       .2961E-02,      .1185E-02,      .1027E-01,      .2344E-03,
     +       .0000E+00,      .0000E+00,      .3494E-03,      .1407E-02,
     +       .3164E-02,      .1407E-02,      .1173E-01,      .2694E-03,
     +       .0000E+00,      .0000E+00,      .8390E-04,      .1645E-02,
     +       .3375E-02,      .1645E-02,      .1328E-01,      .3092E-03,
     +       .0000E+00,      .0000E+00,     -.2047E-03,      .1900E-02,
     +       .3595E-02,      .1900E-02,      .1493E-01,      .3535E-03,
     +       .0000E+00,      .0000E+00,     -.5165E-03,      .2172E-02,
     +       .3827E-02,      .2172E-02,      .1669E-01,      .4018E-03/
        DATA ((CALC(I,K,22),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.8517E-03,      .2462E-02,
     +       .4072E-02,      .2462E-02,      .1857E-01,      .4541E-03,
     +       .0000E+00,      .0000E+00,     -.1211E-02,      .2772E-02,
     +       .4333E-02,      .2772E-02,      .2057E-01,      .5102E-03,
     +       .0000E+00,      .0000E+00,     -.1594E-02,      .3102E-02,
     +       .4611E-02,      .3102E-02,      .2271E-01,      .5701E-03,
     +       .0000E+00,      .0000E+00,     -.2002E-02,      .3455E-02,
     +       .4908E-02,      .3455E-02,      .2499E-01,      .6337E-03,
     +       .0000E+00,      .0000E+00,     -.2437E-02,      .3832E-02,
     +       .5227E-02,      .3832E-02,      .2742E-01,      .7014E-03,
     +       .0000E+00,      .0000E+00,     -.2898E-02,      .4235E-02,
     +       .5571E-02,      .4235E-02,      .3003E-01,      .7732E-03,
     +       .0000E+00,      .0000E+00,     -.3389E-02,      .4665E-02,
     +       .5941E-02,      .4665E-02,      .3282E-01,      .8494E-03,
     +       .0000E+00,      .0000E+00,     -.3910E-02,      .5125E-02,
     +       .6341E-02,      .5125E-02,      .3581E-01,      .9304E-03,
     +       .0000E+00,      .0000E+00,     -.4463E-02,      .5618E-02,
     +       .6773E-02,      .5618E-02,      .3902E-01,      .1017E-02/
        DATA ((CALC(I,K,22),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.5051E-02,      .6146E-02,
     +       .7240E-02,      .6146E-02,      .4246E-01,      .1108E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,23),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1609E-02,      .5367E-03,
     +       .2681E-02,      .5367E-03,      .6436E-02,      .1366E-03,
     +       .0000E+00,      .0000E+00,      .1415E-02,      .7238E-03,
     +       .2862E-02,      .7238E-03,      .7676E-02,      .1424E-03,
     +       .0000E+00,      .0000E+00,      .1195E-02,      .9246E-03,
     +       .3043E-02,      .9246E-03,      .8989E-02,      .1550E-03,
     +       .0000E+00,      .0000E+00,      .9500E-03,      .1139E-02,
     +       .3228E-02,      .1139E-02,      .1038E-01,      .1732E-03,
     +       .0000E+00,      .0000E+00,      .6808E-03,      .1368E-02,
     +       .3416E-02,      .1368E-02,      .1185E-01,      .1964E-03,
     +       .0000E+00,      .0000E+00,      .3884E-03,      .1612E-02,
     +       .3612E-02,      .1612E-02,      .1341E-01,      .2239E-03,
     +       .0000E+00,      .0000E+00,      .7339E-04,      .1871E-02,
     +       .3815E-02,      .1871E-02,      .1507E-01,      .2552E-03,
     +       .0000E+00,      .0000E+00,     -.2637E-03,      .2147E-02,
     +       .4029E-02,      .2147E-02,      .1682E-01,      .2898E-03,
     +       .0000E+00,      .0000E+00,     -.6228E-03,      .2439E-02,
     +       .4255E-02,      .2439E-02,      .1869E-01,      .3275E-03/
        DATA ((CALC(I,K,23),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.1004E-02,      .2750E-02,
     +       .4496E-02,      .2750E-02,      .2067E-01,      .3680E-03,
     +       .0000E+00,      .0000E+00,     -.1407E-02,      .3080E-02,
     +       .4753E-02,      .3080E-02,      .2277E-01,      .4113E-03,
     +       .0000E+00,      .0000E+00,     -.1833E-02,      .3431E-02,
     +       .5029E-02,      .3431E-02,      .2501E-01,      .4573E-03,
     +       .0000E+00,      .0000E+00,     -.2283E-02,      .3805E-02,
     +       .5326E-02,      .3805E-02,      .2740E-01,      .5061E-03,
     +       .0000E+00,      .0000E+00,     -.2757E-02,      .4202E-02,
     +       .5647E-02,      .4202E-02,      .2995E-01,      .5578E-03,
     +       .0000E+00,      .0000E+00,     -.3258E-02,      .4626E-02,
     +       .5993E-02,      .4626E-02,      .3267E-01,      .6125E-03,
     +       .0000E+00,      .0000E+00,     -.3785E-02,      .5077E-02,
     +       .6369E-02,      .5077E-02,      .3558E-01,      .6705E-03,
     +       .0000E+00,      .0000E+00,     -.4342E-02,      .5559E-02,
     +       .6776E-02,      .5559E-02,      .3870E-01,      .7319E-03,
     +       .0000E+00,      .0000E+00,     -.4931E-02,      .6074E-02,
     +       .7217E-02,      .6074E-02,      .4203E-01,      .7972E-03/
        DATA ((CALC(I,K,23),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.5553E-02,      .6625E-02,
     +       .7696E-02,      .6625E-02,      .4561E-01,      .8667E-03,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,24),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1935E-02,      .6449E-03,
     +       .3226E-02,      .6449E-03,      .7742E-02,      .1184E-03,
     +       .0000E+00,      .0000E+00,      .1677E-02,      .8565E-03,
     +       .3390E-02,      .8565E-03,      .9090E-02,      .1217E-03,
     +       .0000E+00,      .0000E+00,      .1393E-02,      .1081E-02,
     +       .3555E-02,      .1081E-02,      .1051E-01,      .1308E-03,
     +       .0000E+00,      .0000E+00,      .1085E-02,      .1319E-02,
     +       .3723E-02,      .1319E-02,      .1200E-01,      .1446E-03,
     +       .0000E+00,      .0000E+00,      .7550E-03,      .1571E-02,
     +       .3896E-02,      .1571E-02,      .1357E-01,      .1623E-03,
     +       .0000E+00,      .0000E+00,      .4038E-03,      .1836E-02,
     +       .4076E-02,      .1836E-02,      .1523E-01,      .1834E-03,
     +       .0000E+00,      .0000E+00,      .3232E-04,      .2117E-02,
     +       .4265E-02,      .2117E-02,      .1698E-01,      .2073E-03,
     +       .0000E+00,      .0000E+00,     -.3586E-03,      .2412E-02,
     +       .4466E-02,      .2412E-02,      .1882E-01,      .2337E-03,
     +       .0000E+00,      .0000E+00,     -.7687E-03,      .2725E-02,
     +       .4681E-02,      .2725E-02,      .2078E-01,      .2622E-03/
        DATA ((CALC(I,K,24),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.1198E-02,      .3055E-02,
     +       .4911E-02,      .3055E-02,      .2284E-01,      .2928E-03,
     +       .0000E+00,      .0000E+00,     -.1647E-02,      .3404E-02,
     +       .5160E-02,      .3404E-02,      .2504E-01,      .3253E-03,
     +       .0000E+00,      .0000E+00,     -.2115E-02,      .3773E-02,
     +       .5430E-02,      .3773E-02,      .2737E-01,      .3597E-03,
     +       .0000E+00,      .0000E+00,     -.2605E-02,      .4164E-02,
     +       .5722E-02,      .4164E-02,      .2984E-01,      .3959E-03,
     +       .0000E+00,      .0000E+00,     -.3117E-02,      .4579E-02,
     +       .6041E-02,      .4579E-02,      .3248E-01,      .4342E-03,
     +       .0000E+00,      .0000E+00,     -.3652E-02,      .5019E-02,
     +       .6387E-02,      .5019E-02,      .3529E-01,      .4747E-03,
     +       .0000E+00,      .0000E+00,     -.4212E-02,      .5488E-02,
     +       .6764E-02,      .5488E-02,      .3830E-01,      .5174E-03,
     +       .0000E+00,      .0000E+00,     -.4800E-02,      .5987E-02,
     +       .7174E-02,      .5987E-02,      .4151E-01,      .5627E-03,
     +       .0000E+00,      .0000E+00,     -.5417E-02,      .6519E-02,
     +       .7622E-02,      .6519E-02,      .4494E-01,      .6108E-03/
        DATA ((CALC(I,K,24),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.6067E-02,      .7088E-02,
     +       .8109E-02,      .7088E-02,      .4863E-01,      .6619E-03,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,25),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .2294E-02,      .7649E-03,
     +       .3823E-02,      .7649E-03,      .9174E-02,      .1007E-03,
     +       .0000E+00,      .0000E+00,      .1953E-02,      .1003E-02,
     +       .3959E-02,      .1003E-02,      .1063E-01,      .1021E-03,
     +       .0000E+00,      .0000E+00,      .1589E-02,      .1254E-02,
     +       .4096E-02,      .1254E-02,      .1215E-01,      .1084E-03,
     +       .0000E+00,      .0000E+00,      .1206E-02,      .1516E-02,
     +       .4237E-02,      .1516E-02,      .1373E-01,      .1185E-03,
     +       .0000E+00,      .0000E+00,      .8039E-03,      .1790E-02,
     +       .4384E-02,      .1790E-02,      .1539E-01,      .1317E-03,
     +       .0000E+00,      .0000E+00,      .3856E-03,      .2077E-02,
     +       .4540E-02,      .2077E-02,      .1713E-01,      .1473E-03,
     +       .0000E+00,      .0000E+00,     -.4818E-04,      .2378E-02,
     +       .4707E-02,      .2378E-02,      .1896E-01,      .1650E-03,
     +       .0000E+00,      .0000E+00,     -.4968E-03,      .2692E-02,
     +       .4888E-02,      .2692E-02,      .2088E-01,      .1845E-03,
     +       .0000E+00,      .0000E+00,     -.9598E-03,      .3022E-02,
     +       .5085E-02,      .3022E-02,      .2290E-01,      .2054E-03/
        DATA ((CALC(I,K,25),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.1437E-02,      .3369E-02,
     +       .5300E-02,      .3369E-02,      .2503E-01,      .2276E-03,
     +       .0000E+00,      .0000E+00,     -.1930E-02,      .3733E-02,
     +       .5535E-02,      .3733E-02,      .2729E-01,      .2511E-03,
     +       .0000E+00,      .0000E+00,     -.2438E-02,      .4116E-02,
     +       .5794E-02,      .4116E-02,      .2968E-01,      .2759E-03,
     +       .0000E+00,      .0000E+00,     -.2963E-02,      .4521E-02,
     +       .6078E-02,      .4521E-02,      .3222E-01,      .3018E-03,
     +       .0000E+00,      .0000E+00,     -.3507E-02,      .4948E-02,
     +       .6389E-02,      .4948E-02,      .3491E-01,      .3292E-03,
     +       .0000E+00,      .0000E+00,     -.4070E-02,      .5401E-02,
     +       .6731E-02,      .5401E-02,      .3778E-01,      .3580E-03,
     +       .0000E+00,      .0000E+00,     -.4656E-02,      .5881E-02,
     +       .7106E-02,      .5881E-02,      .4085E-01,      .3883E-03,
     +       .0000E+00,      .0000E+00,     -.5267E-02,      .6392E-02,
     +       .7517E-02,      .6392E-02,      .4412E-01,      .4205E-03,
     +       .0000E+00,      .0000E+00,     -.5904E-02,      .6935E-02,
     +       .7966E-02,      .6935E-02,      .4762E-01,      .4545E-03/
        DATA ((CALC(I,K,25),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.6573E-02,      .7515E-02,
     +       .8457E-02,      .7515E-02,      .5136E-01,      .4907E-03,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,26),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .2676E-02,      .8925E-03,
     +       .4461E-02,      .8925E-03,      .1071E-01,      .8338E-04,
     +       .0000E+00,      .0000E+00,      .2232E-02,      .1161E-02,
     +       .4553E-02,      .1161E-02,      .1226E-01,      .8346E-04,
     +       .0000E+00,      .0000E+00,      .1772E-02,      .1438E-02,
     +       .4648E-02,      .1438E-02,      .1387E-01,      .8758E-04,
     +       .0000E+00,      .0000E+00,      .1299E-02,      .1726E-02,
     +       .4749E-02,      .1726E-02,      .1554E-01,      .9470E-04,
     +       .0000E+00,      .0000E+00,      .8150E-03,      .2023E-02,
     +       .4860E-02,      .2023E-02,      .1727E-01,      .1041E-03,
     +       .0000E+00,      .0000E+00,      .3226E-03,      .2330E-02,
     +       .4983E-02,      .2330E-02,      .1907E-01,      .1153E-03,
     +       .0000E+00,      .0000E+00,     -.1779E-03,      .2649E-02,
     +       .5120E-02,      .2649E-02,      .2096E-01,      .1280E-03,
     +       .0000E+00,      .0000E+00,     -.6858E-03,      .2980E-02,
     +       .5274E-02,      .2980E-02,      .2293E-01,      .1417E-03,
     +       .0000E+00,      .0000E+00,     -.1201E-02,      .3324E-02,
     +       .5447E-02,      .3324E-02,      .2499E-01,      .1563E-03/
        DATA ((CALC(I,K,26),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.1724E-02,      .3683E-02,
     +       .5641E-02,      .3683E-02,      .2716E-01,      .1718E-03,
     +       .0000E+00,      .0000E+00,     -.2256E-02,      .4058E-02,
     +       .5858E-02,      .4058E-02,      .2945E-01,      .1880E-03,
     +       .0000E+00,      .0000E+00,     -.2798E-02,      .4450E-02,
     +       .6102E-02,      .4450E-02,      .3187E-01,      .2050E-03,
     +       .0000E+00,      .0000E+00,     -.3352E-02,      .4863E-02,
     +       .6373E-02,      .4863E-02,      .3443E-01,      .2227E-03,
     +       .0000E+00,      .0000E+00,     -.3919E-02,      .5297E-02,
     +       .6674E-02,      .5297E-02,      .3715E-01,      .2413E-03,
     +       .0000E+00,      .0000E+00,     -.4502E-02,      .5755E-02,
     +       .7008E-02,      .5755E-02,      .4004E-01,      .2608E-03,
     +       .0000E+00,      .0000E+00,     -.5103E-02,      .6240E-02,
     +       .7377E-02,      .6240E-02,      .4312E-01,      .2814E-03,
     +       .0000E+00,      .0000E+00,     -.5725E-02,      .6755E-02,
     +       .7784E-02,      .6755E-02,      .4641E-01,      .3031E-03,
     +       .0000E+00,      .0000E+00,     -.6372E-02,      .7302E-02,
     +       .8231E-02,      .7302E-02,      .4992E-01,      .3261E-03/
        DATA ((CALC(I,K,26),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.7046E-02,      .7884E-02,
     +       .8722E-02,      .7884E-02,      .5368E-01,      .3505E-03,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,27),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .3076E-02,      .1026E-02,
     +       .5127E-02,      .1026E-02,      .1230E-01,      .6658E-04,
     +       .0000E+00,      .0000E+00,      .2503E-02,      .1327E-02,
     +       .5156E-02,      .1327E-02,      .1395E-01,      .6586E-04,
     +       .0000E+00,      .0000E+00,      .1926E-02,      .1634E-02,
     +       .5193E-02,      .1634E-02,      .1564E-01,      .6839E-04,
     +       .0000E+00,      .0000E+00,      .1349E-02,      .1947E-02,
     +       .5242E-02,      .1947E-02,      .1737E-01,      .7318E-04,
     +       .0000E+00,      .0000E+00,      .7736E-03,      .2266E-02,
     +       .5305E-02,      .2266E-02,      .1916E-01,      .7961E-04,
     +       .0000E+00,      .0000E+00,      .2012E-03,      .2592E-02,
     +       .5385E-02,      .2592E-02,      .2100E-01,      .8725E-04,
     +       .0000E+00,      .0000E+00,     -.3680E-03,      .2926E-02,
     +       .5484E-02,      .2926E-02,      .2292E-01,      .9577E-04,
     +       .0000E+00,      .0000E+00,     -.9343E-03,      .3270E-02,
     +       .5605E-02,      .3270E-02,      .2491E-01,      .1049E-03,
     +       .0000E+00,      .0000E+00,     -.1498E-02,      .3623E-02,
     +       .5748E-02,      .3623E-02,      .2699E-01,      .1146E-03/
        DATA ((CALC(I,K,27),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.2061E-02,      .3989E-02,
     +       .5917E-02,      .3989E-02,      .2917E-01,      .1247E-03,
     +       .0000E+00,      .0000E+00,     -.2625E-02,      .4369E-02,
     +       .6113E-02,      .4369E-02,      .3145E-01,      .1353E-03,
     +       .0000E+00,      .0000E+00,     -.3192E-02,      .4765E-02,
     +       .6338E-02,      .4765E-02,      .3386E-01,      .1462E-03,
     +       .0000E+00,      .0000E+00,     -.3763E-02,      .5178E-02,
     +       .6593E-02,      .5178E-02,      .3641E-01,      .1575E-03,
     +       .0000E+00,      .0000E+00,     -.4342E-02,      .5611E-02,
     +       .6881E-02,      .5611E-02,      .3910E-01,      .1694E-03,
     +       .0000E+00,      .0000E+00,     -.4931E-02,      .6067E-02,
     +       .7204E-02,      .6067E-02,      .4197E-01,      .1818E-03,
     +       .0000E+00,      .0000E+00,     -.5535E-02,      .6549E-02,
     +       .7563E-02,      .6549E-02,      .4501E-01,      .1948E-03,
     +       .0000E+00,      .0000E+00,     -.6156E-02,      .7059E-02,
     +       .7962E-02,      .7059E-02,      .4826E-01,      .2086E-03,
     +       .0000E+00,      .0000E+00,     -.6797E-02,      .7600E-02,
     +       .8402E-02,      .7600E-02,      .5173E-01,      .2231E-03/
        DATA ((CALC(I,K,27),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.7464E-02,      .8175E-02,
     +       .8886E-02,      .8175E-02,      .5545E-01,      .2386E-03,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,28),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .3485E-02,      .1161E-02,
     +       .5807E-02,      .1161E-02,      .1394E-01,      .5057E-04,
     +       .0000E+00,      .0000E+00,      .2750E-02,      .1500E-02,
     +       .5751E-02,      .1500E-02,      .1567E-01,      .4947E-04,
     +       .0000E+00,      .0000E+00,      .2034E-02,      .1839E-02,
     +       .5712E-02,      .1839E-02,      .1743E-01,      .5088E-04,
     +       .0000E+00,      .0000E+00,      .1337E-02,      .2178E-02,
     +       .5693E-02,      .2178E-02,      .1921E-01,      .5392E-04,
     +       .0000E+00,      .0000E+00,      .6608E-03,      .2518E-02,
     +       .5697E-02,      .2518E-02,      .2103E-01,      .5805E-04,
     +       .0000E+00,      .0000E+00,      .4482E-05,      .2861E-02,
     +       .5726E-02,      .2861E-02,      .2289E-01,      .6291E-04,
     +       .0000E+00,      .0000E+00,     -.6330E-03,      .3207E-02,
     +       .5780E-02,      .3207E-02,      .2481E-01,      .6827E-04,
     +       .0000E+00,      .0000E+00,     -.1253E-02,      .3558E-02,
     +       .5862E-02,      .3558E-02,      .2679E-01,      .7394E-04,
     +       .0000E+00,      .0000E+00,     -.1859E-02,      .3916E-02,
     +       .5973E-02,      .3916E-02,      .2885E-01,      .7985E-04/
        DATA ((CALC(I,K,28),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.2452E-02,      .4283E-02,
     +       .6114E-02,      .4283E-02,      .3099E-01,      .8593E-04,
     +       .0000E+00,      .0000E+00,     -.3035E-02,      .4660E-02,
     +       .6285E-02,      .4660E-02,      .3324E-01,      .9218E-04,
     +       .0000E+00,      .0000E+00,     -.3613E-02,      .5051E-02,
     +       .6489E-02,      .5051E-02,      .3559E-01,      .9862E-04,
     +       .0000E+00,      .0000E+00,     -.4188E-02,      .5457E-02,
     +       .6726E-02,      .5457E-02,      .3807E-01,      .1053E-03,
     +       .0000E+00,      .0000E+00,     -.4764E-02,      .5881E-02,
     +       .6999E-02,      .5881E-02,      .4070E-01,      .1122E-03,
     +       .0000E+00,      .0000E+00,     -.5345E-02,      .6326E-02,
     +       .7307E-02,      .6326E-02,      .4348E-01,      .1194E-03,
     +       .0000E+00,      .0000E+00,     -.5935E-02,      .6795E-02,
     +       .7654E-02,      .6795E-02,      .4644E-01,      .1269E-03,
     +       .0000E+00,      .0000E+00,     -.6539E-02,      .7289E-02,
     +       .8040E-02,      .7289E-02,      .4960E-01,      .1349E-03,
     +       .0000E+00,      .0000E+00,     -.7160E-02,      .7814E-02,
     +       .8468E-02,      .7814E-02,      .5296E-01,      .1433E-03/
        DATA ((CALC(I,K,28),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.7803E-02,      .8371E-02,
     +       .8940E-02,      .8371E-02,      .5657E-01,      .1523E-03,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,29),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .3891E-02,      .1298E-02,
     +       .6486E-02,      .1298E-02,      .1557E-01,      .3566E-04,
     +       .0000E+00,      .0000E+00,      .2953E-02,      .1682E-02,
     +       .6317E-02,      .1682E-02,      .1739E-01,      .3452E-04,
     +       .0000E+00,      .0000E+00,      .2068E-02,      .2057E-02,
     +       .6182E-02,      .2057E-02,      .1921E-01,      .3523E-04,
     +       .0000E+00,      .0000E+00,      .1235E-02,      .2424E-02,
     +       .6082E-02,      .2424E-02,      .2103E-01,      .3703E-04,
     +       .0000E+00,      .0000E+00,      .4491E-03,      .2784E-02,
     +       .6017E-02,      .2784E-02,      .2287E-01,      .3946E-04,
     +       .0000E+00,      .0000E+00,     -.2920E-03,      .3140E-02,
     +       .5987E-02,      .3140E-02,      .2473E-01,      .4228E-04,
     +       .0000E+00,      .0000E+00,     -.9929E-03,      .3493E-02,
     +       .5993E-02,      .3493E-02,      .2662E-01,      .4531E-04,
     +       .0000E+00,      .0000E+00,     -.1658E-02,      .3846E-02,
     +       .6034E-02,      .3846E-02,      .2856E-01,      .4845E-04,
     +       .0000E+00,      .0000E+00,     -.2292E-02,      .4202E-02,
     +       .6111E-02,      .4202E-02,      .3056E-01,      .5164E-04/
        DATA ((CALC(I,K,29),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.2901E-02,      .4562E-02,
     +       .6222E-02,      .4562E-02,      .3263E-01,      .5487E-04,
     +       .0000E+00,      .0000E+00,     -.3488E-02,      .4929E-02,
     +       .6370E-02,      .4929E-02,      .3478E-01,      .5813E-04,
     +       .0000E+00,      .0000E+00,     -.4060E-02,      .5306E-02,
     +       .6552E-02,      .5306E-02,      .3704E-01,      .6145E-04,
     +       .0000E+00,      .0000E+00,     -.4621E-02,      .5696E-02,
     +       .6771E-02,      .5696E-02,      .3941E-01,      .6485E-04,
     +       .0000E+00,      .0000E+00,     -.5176E-02,      .6101E-02,
     +       .7026E-02,      .6101E-02,      .4191E-01,      .6835E-04,
     +       .0000E+00,      .0000E+00,     -.5731E-02,      .6524E-02,
     +       .7318E-02,      .6524E-02,      .4455E-01,      .7200E-04,
     +       .0000E+00,      .0000E+00,     -.6290E-02,      .6969E-02,
     +       .7648E-02,      .6969E-02,      .4737E-01,      .7583E-04,
     +       .0000E+00,      .0000E+00,     -.6858E-02,      .7438E-02,
     +       .8018E-02,      .7438E-02,      .5036E-01,      .7988E-04,
     +       .0000E+00,      .0000E+00,     -.7441E-02,      .7935E-02,
     +       .8428E-02,      .7935E-02,      .5356E-01,      .8417E-04/
        DATA ((CALC(I,K,29),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.8043E-02,      .8462E-02,
     +       .8881E-02,      .8462E-02,      .5697E-01,      .8876E-04,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,30),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .4302E-02,      .1433E-02,
     +       .7170E-02,      .1433E-02,      .1721E-01,      .2230E-04,
     +       .0000E+00,      .0000E+00,      .3094E-02,      .1879E-02,
     +       .6853E-02,      .1879E-02,      .1916E-01,      .2138E-04,
     +       .0000E+00,      .0000E+00,      .1999E-02,      .2299E-02,
     +       .6598E-02,      .2299E-02,      .2106E-01,      .2171E-04,
     +       .0000E+00,      .0000E+00,      .1004E-02,      .2697E-02,
     +       .6400E-02,      .2697E-02,      .2292E-01,      .2268E-04,
     +       .0000E+00,      .0000E+00,      .9942E-04,      .3078E-02,
     +       .6256E-02,      .3078E-02,      .2476E-01,      .2394E-04,
     +       .0000E+00,      .0000E+00,     -.7262E-03,      .3445E-02,
     +       .6163E-02,      .3445E-02,      .2659E-01,      .2536E-04,
     +       .0000E+00,      .0000E+00,     -.1483E-02,      .3801E-02,
     +       .6119E-02,      .3801E-02,      .2843E-01,      .2681E-04,
     +       .0000E+00,      .0000E+00,     -.2179E-02,      .4149E-02,
     +       .6120E-02,      .4149E-02,      .3029E-01,      .2826E-04,
     +       .0000E+00,      .0000E+00,     -.2825E-02,      .4495E-02,
     +       .6164E-02,      .4495E-02,      .3219E-01,      .2967E-04/
        DATA ((CALC(I,K,30),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.3429E-02,      .4839E-02,
     +       .6249E-02,      .4839E-02,      .3414E-01,      .3105E-04,
     +       .0000E+00,      .0000E+00,     -.4000E-02,      .5187E-02,
     +       .6374E-02,      .5187E-02,      .3616E-01,      .3241E-04,
     +       .0000E+00,      .0000E+00,     -.4543E-02,      .5540E-02,
     +       .6537E-02,      .5540E-02,      .3827E-01,      .3377E-04,
     +       .0000E+00,      .0000E+00,     -.5068E-02,      .5903E-02,
     +       .6738E-02,      .5903E-02,      .4047E-01,      .3514E-04,
     +       .0000E+00,      .0000E+00,     -.5581E-02,      .6278E-02,
     +       .6975E-02,      .6278E-02,      .4278E-01,      .3655E-04,
     +       .0000E+00,      .0000E+00,     -.6088E-02,      .6669E-02,
     +       .7249E-02,      .6669E-02,      .4523E-01,      .3802E-04,
     +       .0000E+00,      .0000E+00,     -.6596E-02,      .7077E-02,
     +       .7559E-02,      .7077E-02,      .4783E-01,      .3956E-04,
     +       .0000E+00,      .0000E+00,     -.7109E-02,      .7508E-02,
     +       .7907E-02,      .7508E-02,      .5059E-01,      .4120E-04,
     +       .0000E+00,      .0000E+00,     -.7634E-02,      .7964E-02,
     +       .8294E-02,      .7964E-02,      .5353E-01,      .4295E-04/
        DATA ((CALC(I,K,30),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.8176E-02,      .8448E-02,
     +       .8719E-02,      .8448E-02,      .5668E-01,      .4483E-04,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,31),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .4756E-02,      .1585E-02,
     +       .7925E-02,      .1585E-02,      .1902E-01,      .1098E-04,
     +       .0000E+00,      .0000E+00,      .3138E-02,      .2130E-02,
     +       .7397E-02,      .2130E-02,      .2122E-01,      .1045E-04,
     +       .0000E+00,      .0000E+00,      .1739E-02,      .2621E-02,
     +       .6980E-02,      .2621E-02,      .2329E-01,      .1064E-04,
     +       .0000E+00,      .0000E+00,      .5274E-03,      .3067E-02,
     +       .6660E-02,      .3067E-02,      .2524E-01,      .1112E-04,
     +       .0000E+00,      .0000E+00,     -.5225E-03,      .3475E-02,
     +       .6427E-02,      .3475E-02,      .2710E-01,      .1164E-04,
     +       .0000E+00,      .0000E+00,     -.1436E-02,      .3852E-02,
     +       .6269E-02,      .3852E-02,      .2891E-01,      .1217E-04,
     +       .0000E+00,      .0000E+00,     -.2234E-02,      .4206E-02,
     +       .6178E-02,      .4206E-02,      .3067E-01,      .1268E-04,
     +       .0000E+00,      .0000E+00,     -.2938E-02,      .4542E-02,
     +       .6146E-02,      .4542E-02,      .3242E-01,      .1313E-04,
     +       .0000E+00,      .0000E+00,     -.3565E-02,      .4866E-02,
     +       .6167E-02,      .4866E-02,      .3417E-01,      .1354E-04/
        DATA ((CALC(I,K,31),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.4130E-02,      .5182E-02,
     +       .6234E-02,      .5182E-02,      .3595E-01,      .1391E-04,
     +       .0000E+00,      .0000E+00,     -.4648E-02,      .5496E-02,
     +       .6344E-02,      .5496E-02,      .3777E-01,      .1426E-04,
     +       .0000E+00,      .0000E+00,     -.5129E-02,      .5811E-02,
     +       .6493E-02,      .5811E-02,      .3965E-01,      .1459E-04,
     +       .0000E+00,      .0000E+00,     -.5584E-02,      .6132E-02,
     +       .6679E-02,      .6132E-02,      .4161E-01,      .1492E-04,
     +       .0000E+00,      .0000E+00,     -.6023E-02,      .6461E-02,
     +       .6898E-02,      .6461E-02,      .4366E-01,      .1526E-04,
     +       .0000E+00,      .0000E+00,     -.6453E-02,      .6802E-02,
     +       .7152E-02,      .6802E-02,      .4582E-01,      .1562E-04,
     +       .0000E+00,      .0000E+00,     -.6881E-02,      .7159E-02,
     +       .7437E-02,      .7159E-02,      .4810E-01,      .1600E-04,
     +       .0000E+00,      .0000E+00,     -.7314E-02,      .7535E-02,
     +       .7756E-02,      .7535E-02,      .5053E-01,      .1641E-04,
     +       .0000E+00,      .0000E+00,     -.7758E-02,      .7933E-02,
     +       .8108E-02,      .7933E-02,      .5312E-01,      .1686E-04/
        DATA ((CALC(I,K,31),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.8217E-02,      .8355E-02,
     +       .8493E-02,      .8355E-02,      .5588E-01,      .1736E-04,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CALC(I,K,32),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .5261E-02,      .1754E-02,
     +       .8769E-02,      .1754E-02,      .2104E-01,      .2781E-05,
     +       .0000E+00,      .0000E+00,      .2862E-02,      .2523E-02,
     +       .7907E-02,      .2523E-02,      .2400E-01,      .2638E-05,
     +       .0000E+00,      .0000E+00,      .9884E-03,      .3148E-02,
     +       .7284E-02,      .3148E-02,      .2650E-01,      .2723E-05,
     +       .0000E+00,      .0000E+00,     -.4935E-03,      .3666E-02,
     +       .6839E-02,      .3666E-02,      .2867E-01,      .2872E-05,
     +       .0000E+00,      .0000E+00,     -.1678E-02,      .4106E-02,
     +       .6534E-02,      .4106E-02,      .3061E-01,      .2974E-05,
     +       .0000E+00,      .0000E+00,     -.2630E-02,      .4485E-02,
     +       .6340E-02,      .4485E-02,      .3237E-01,      .3051E-05,
     +       .0000E+00,      .0000E+00,     -.3405E-02,      .4819E-02,
     +       .6234E-02,      .4819E-02,      .3402E-01,      .3123E-05,
     +       .0000E+00,      .0000E+00,     -.4046E-02,      .5122E-02,
     +       .6198E-02,      .5122E-02,      .3558E-01,      .3170E-05,
     +       .0000E+00,      .0000E+00,     -.4586E-02,      .5403E-02,
     +       .6220E-02,      .5403E-02,      .3711E-01,      .3193E-05/
        DATA ((CALC(I,K,32),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,     -.5052E-02,      .5671E-02,
     +       .6290E-02,      .5671E-02,      .3863E-01,      .3206E-05,
     +       .0000E+00,      .0000E+00,     -.5463E-02,      .5931E-02,
     +       .6399E-02,      .5931E-02,      .4016E-01,      .3214E-05,
     +       .0000E+00,      .0000E+00,     -.5836E-02,      .6189E-02,
     +       .6542E-02,      .6189E-02,      .4173E-01,      .3217E-05,
     +       .0000E+00,      .0000E+00,     -.6184E-02,      .6450E-02,
     +       .6715E-02,      .6450E-02,      .4335E-01,      .3218E-05,
     +       .0000E+00,      .0000E+00,     -.6517E-02,      .6717E-02,
     +       .6916E-02,      .6717E-02,      .4504E-01,      .3221E-05,
     +       .0000E+00,      .0000E+00,     -.6844E-02,      .6993E-02,
     +       .7142E-02,      .6993E-02,      .4682E-01,      .3228E-05,
     +       .0000E+00,      .0000E+00,     -.7171E-02,      .7282E-02,
     +       .7394E-02,      .7282E-02,      .4870E-01,      .3238E-05,
     +       .0000E+00,      .0000E+00,     -.7504E-02,      .7587E-02,
     +       .7670E-02,      .7587E-02,      .5069E-01,      .3255E-05,
     +       .0000E+00,      .0000E+00,     -.7848E-02,      .7909E-02,
     +       .7971E-02,      .7909E-02,      .5281E-01,      .3279E-05/
        DATA ((CALC(I,K,32),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,     -.8207E-02,      .8253E-02,
     +       .8298E-02,      .8253E-02,      .5508E-01,      .3309E-05,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA (PAR2(I),I=1,30) / 
     +       .2000E+00,      .4800E+00,      .8500E+00,      .1000E+01,
     +       .1000E+01,      .1000E+01,      .1200E+01,      .7500E+01,
     +       .1987E+01,      .1900E+01,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .1000E+01,
     +       .0000E+00,      .1000E+01,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .4000E+01,      .0000E+00,      .1000E+01,      .1000E+01,
     +       .8000E-01,      .2000E+01/
        DATA ((CELC(I,K,1 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1515E-02,     -.4584E-03,
     +       .5980E-03,     -.4584E-03,      .6059E-02,      .6289E-02,
     +       .0000E+00,      .0000E+00,      .1514E-02,     -.4567E-03,
     +       .6009E-03,     -.4567E-03,      .6839E-02,      .9576E-02,
     +       .0000E+00,      .0000E+00,      .1514E-02,     -.4550E-03,
     +       .6038E-03,     -.4550E-03,      .7744E-02,      .1330E-01,
     +       .0000E+00,      .0000E+00,      .1513E-02,     -.4533E-03,
     +       .6068E-03,     -.4533E-03,      .8782E-02,      .1746E-01,
     +       .0000E+00,      .0000E+00,      .1513E-02,     -.4515E-03,
     +       .6098E-03,     -.4515E-03,      .9957E-02,      .2207E-01,
     +       .0000E+00,      .0000E+00,      .1512E-02,     -.4497E-03,
     +       .6128E-03,     -.4497E-03,      .1128E-01,      .2712E-01,
     +       .0000E+00,      .0000E+00,      .1511E-02,     -.4478E-03,
     +       .6158E-03,     -.4478E-03,      .1275E-01,      .3260E-01,
     +       .0000E+00,      .0000E+00,      .1511E-02,     -.4458E-03,
     +       .6189E-03,     -.4458E-03,      .1437E-01,      .3852E-01,
     +       .0000E+00,      .0000E+00,      .1510E-02,     -.4439E-03,
     +       .6220E-03,     -.4439E-03,      .1616E-01,      .4485E-01/
        DATA ((CELC(I,K,1 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .1509E-02,     -.4418E-03,
     +       .6252E-03,     -.4418E-03,      .1811E-01,      .5157E-01,
     +       .0000E+00,      .0000E+00,      .1508E-02,     -.4397E-03,
     +       .6283E-03,     -.4397E-03,      .2023E-01,      .5866E-01,
     +       .0000E+00,      .0000E+00,      .1507E-02,     -.4376E-03,
     +       .6315E-03,     -.4376E-03,      .2251E-01,      .6609E-01,
     +       .0000E+00,      .0000E+00,      .1505E-02,     -.4353E-03,
     +       .6348E-03,     -.4353E-03,      .2497E-01,      .7384E-01,
     +       .0000E+00,      .0000E+00,      .1504E-02,     -.4331E-03,
     +       .6380E-03,     -.4331E-03,      .2761E-01,      .8187E-01,
     +       .0000E+00,      .0000E+00,      .1503E-02,     -.4307E-03,
     +       .6413E-03,     -.4307E-03,      .3041E-01,      .9013E-01,
     +       .0000E+00,      .0000E+00,      .1501E-02,     -.4283E-03,
     +       .6446E-03,     -.4283E-03,      .3338E-01,      .9860E-01,
     +       .0000E+00,      .0000E+00,      .1500E-02,     -.4259E-03,
     +       .6479E-03,     -.4259E-03,      .3652E-01,      .1072E+00,
     +       .0000E+00,      .0000E+00,      .1498E-02,     -.4234E-03,
     +       .6512E-03,     -.4234E-03,      .3982E-01,      .1160E+00/
        DATA ((CELC(I,K,1 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .1496E-02,     -.4208E-03,
     +       .6546E-03,     -.4208E-03,      .4328E-01,      .1248E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,2 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1537E-02,     -.4096E-03,
     +       .7179E-03,     -.4096E-03,      .6148E-02,      .6219E-02,
     +       .0000E+00,      .0000E+00,      .1534E-02,     -.4053E-03,
     +       .7231E-03,     -.4053E-03,      .6640E-02,      .8229E-02,
     +       .0000E+00,      .0000E+00,      .1530E-02,     -.4009E-03,
     +       .7283E-03,     -.4009E-03,      .7175E-02,      .1032E-01,
     +       .0000E+00,      .0000E+00,      .1526E-02,     -.3964E-03,
     +       .7335E-03,     -.3964E-03,      .7748E-02,      .1247E-01,
     +       .0000E+00,      .0000E+00,      .1522E-02,     -.3918E-03,
     +       .7387E-03,     -.3918E-03,      .8358E-02,      .1466E-01,
     +       .0000E+00,      .0000E+00,      .1518E-02,     -.3872E-03,
     +       .7438E-03,     -.3872E-03,      .9000E-02,      .1686E-01,
     +       .0000E+00,      .0000E+00,      .1514E-02,     -.3825E-03,
     +       .7488E-03,     -.3825E-03,      .9670E-02,      .1906E-01,
     +       .0000E+00,      .0000E+00,      .1509E-02,     -.3777E-03,
     +       .7539E-03,     -.3777E-03,      .1036E-01,      .2123E-01,
     +       .0000E+00,      .0000E+00,      .1504E-02,     -.3728E-03,
     +       .7589E-03,     -.3728E-03,      .1108E-01,      .2335E-01/
        DATA ((CELC(I,K,2 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .1500E-02,     -.3679E-03,
     +       .7638E-03,     -.3679E-03,      .1180E-01,      .2540E-01,
     +       .0000E+00,      .0000E+00,      .1494E-02,     -.3628E-03,
     +       .7687E-03,     -.3628E-03,      .1253E-01,      .2734E-01,
     +       .0000E+00,      .0000E+00,      .1489E-02,     -.3577E-03,
     +       .7736E-03,     -.3577E-03,      .1326E-01,      .2917E-01,
     +       .0000E+00,      .0000E+00,      .1483E-02,     -.3525E-03,
     +       .7784E-03,     -.3525E-03,      .1399E-01,      .3086E-01,
     +       .0000E+00,      .0000E+00,      .1478E-02,     -.3473E-03,
     +       .7831E-03,     -.3473E-03,      .1470E-01,      .3239E-01,
     +       .0000E+00,      .0000E+00,      .1472E-02,     -.3420E-03,
     +       .7877E-03,     -.3420E-03,      .1540E-01,      .3374E-01,
     +       .0000E+00,      .0000E+00,      .1465E-02,     -.3366E-03,
     +       .7923E-03,     -.3366E-03,      .1606E-01,      .3490E-01,
     +       .0000E+00,      .0000E+00,      .1459E-02,     -.3311E-03,
     +       .7968E-03,     -.3311E-03,      .1669E-01,      .3584E-01,
     +       .0000E+00,      .0000E+00,      .1452E-02,     -.3256E-03,
     +       .8013E-03,     -.3256E-03,      .1728E-01,      .3656E-01/
        DATA ((CELC(I,K,2 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .1445E-02,     -.3199E-03,
     +       .8056E-03,     -.3199E-03,      .1781E-01,      .3705E-01,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,3 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1512E-02,     -.3476E-03,
     +       .8173E-03,     -.3476E-03,      .6050E-02,      .6096E-02,
     +       .0000E+00,      .0000E+00,      .1504E-02,     -.3410E-03,
     +       .8225E-03,     -.3410E-03,      .6398E-02,      .7474E-02,
     +       .0000E+00,      .0000E+00,      .1496E-02,     -.3343E-03,
     +       .8276E-03,     -.3343E-03,      .6766E-02,      .8854E-02,
     +       .0000E+00,      .0000E+00,      .1488E-02,     -.3275E-03,
     +       .8326E-03,     -.3275E-03,      .7151E-02,      .1022E-01,
     +       .0000E+00,      .0000E+00,      .1479E-02,     -.3208E-03,
     +       .8374E-03,     -.3208E-03,      .7552E-02,      .1157E-01,
     +       .0000E+00,      .0000E+00,      .1470E-02,     -.3140E-03,
     +       .8421E-03,     -.3140E-03,      .7966E-02,      .1289E-01,
     +       .0000E+00,      .0000E+00,      .1461E-02,     -.3071E-03,
     +       .8467E-03,     -.3071E-03,      .8391E-02,      .1417E-01,
     +       .0000E+00,      .0000E+00,      .1452E-02,     -.3003E-03,
     +       .8511E-03,     -.3003E-03,      .8826E-02,      .1541E-01,
     +       .0000E+00,      .0000E+00,      .1442E-02,     -.2934E-03,
     +       .8553E-03,     -.2934E-03,      .9268E-02,      .1660E-01/
        DATA ((CELC(I,K,3 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .1432E-02,     -.2865E-03,
     +       .8594E-03,     -.2865E-03,      .9715E-02,      .1772E-01,
     +       .0000E+00,      .0000E+00,      .1422E-02,     -.2795E-03,
     +       .8633E-03,     -.2795E-03,      .1016E-01,      .1879E-01,
     +       .0000E+00,      .0000E+00,      .1412E-02,     -.2725E-03,
     +       .8671E-03,     -.2725E-03,      .1062E-01,      .1978E-01,
     +       .0000E+00,      .0000E+00,      .1402E-02,     -.2656E-03,
     +       .8707E-03,     -.2656E-03,      .1106E-01,      .2071E-01,
     +       .0000E+00,      .0000E+00,      .1391E-02,     -.2586E-03,
     +       .8741E-03,     -.2586E-03,      .1151E-01,      .2156E-01,
     +       .0000E+00,      .0000E+00,      .1380E-02,     -.2516E-03,
     +       .8773E-03,     -.2516E-03,      .1195E-01,      .2235E-01,
     +       .0000E+00,      .0000E+00,      .1369E-02,     -.2445E-03,
     +       .8803E-03,     -.2445E-03,      .1239E-01,      .2305E-01,
     +       .0000E+00,      .0000E+00,      .1358E-02,     -.2375E-03,
     +       .8832E-03,     -.2375E-03,      .1282E-01,      .2368E-01,
     +       .0000E+00,      .0000E+00,      .1347E-02,     -.2305E-03,
     +       .8858E-03,     -.2305E-03,      .1324E-01,      .2424E-01/
        DATA ((CELC(I,K,3 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .1335E-02,     -.2235E-03,
     +       .8882E-03,     -.2235E-03,      .1365E-01,      .2474E-01,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,4 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1450E-02,     -.2759E-03,
     +       .8984E-03,     -.2759E-03,      .5801E-02,      .5921E-02,
     +       .0000E+00,      .0000E+00,      .1438E-02,     -.2676E-03,
     +       .9028E-03,     -.2676E-03,      .6052E-02,      .6886E-02,
     +       .0000E+00,      .0000E+00,      .1425E-02,     -.2592E-03,
     +       .9070E-03,     -.2592E-03,      .6310E-02,      .7817E-02,
     +       .0000E+00,      .0000E+00,      .1413E-02,     -.2509E-03,
     +       .9110E-03,     -.2509E-03,      .6574E-02,      .8708E-02,
     +       .0000E+00,      .0000E+00,      .1400E-02,     -.2426E-03,
     +       .9148E-03,     -.2426E-03,      .6841E-02,      .9554E-02,
     +       .0000E+00,      .0000E+00,      .1387E-02,     -.2344E-03,
     +       .9183E-03,     -.2344E-03,      .7111E-02,      .1035E-01,
     +       .0000E+00,      .0000E+00,      .1374E-02,     -.2262E-03,
     +       .9216E-03,     -.2262E-03,      .7381E-02,      .1109E-01,
     +       .0000E+00,      .0000E+00,      .1361E-02,     -.2181E-03,
     +       .9246E-03,     -.2181E-03,      .7649E-02,      .1178E-01,
     +       .0000E+00,      .0000E+00,      .1347E-02,     -.2100E-03,
     +       .9275E-03,     -.2100E-03,      .7915E-02,      .1241E-01/
        DATA ((CELC(I,K,4 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .1334E-02,     -.2020E-03,
     +       .9300E-03,     -.2020E-03,      .8177E-02,      .1297E-01,
     +       .0000E+00,      .0000E+00,      .1320E-02,     -.1940E-03,
     +       .9323E-03,     -.1940E-03,      .8433E-02,      .1348E-01,
     +       .0000E+00,      .0000E+00,      .1307E-02,     -.1861E-03,
     +       .9343E-03,     -.1861E-03,      .8682E-02,      .1392E-01,
     +       .0000E+00,      .0000E+00,      .1293E-02,     -.1782E-03,
     +       .9361E-03,     -.1782E-03,      .8923E-02,      .1430E-01,
     +       .0000E+00,      .0000E+00,      .1279E-02,     -.1705E-03,
     +       .9376E-03,     -.1705E-03,      .9154E-02,      .1462E-01,
     +       .0000E+00,      .0000E+00,      .1264E-02,     -.1628E-03,
     +       .9389E-03,     -.1628E-03,      .9374E-02,      .1487E-01,
     +       .0000E+00,      .0000E+00,      .1250E-02,     -.1552E-03,
     +       .9398E-03,     -.1552E-03,      .9582E-02,      .1507E-01,
     +       .0000E+00,      .0000E+00,      .1236E-02,     -.1476E-03,
     +       .9405E-03,     -.1476E-03,      .9778E-02,      .1521E-01,
     +       .0000E+00,      .0000E+00,      .1221E-02,     -.1402E-03,
     +       .9408E-03,     -.1402E-03,      .9960E-02,      .1529E-01/
        DATA ((CELC(I,K,4 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .1207E-02,     -.1328E-03,
     +       .9409E-03,     -.1328E-03,      .1013E-01,      .1532E-01,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,5 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1362E-02,     -.1989E-03,
     +       .9640E-03,     -.1989E-03,      .5447E-02,      .5699E-02,
     +       .0000E+00,      .0000E+00,      .1346E-02,     -.1896E-03,
     +       .9671E-03,     -.1896E-03,      .5628E-02,      .6368E-02,
     +       .0000E+00,      .0000E+00,      .1331E-02,     -.1805E-03,
     +       .9698E-03,     -.1805E-03,      .5809E-02,      .6992E-02,
     +       .0000E+00,      .0000E+00,      .1315E-02,     -.1715E-03,
     +       .9723E-03,     -.1715E-03,      .5989E-02,      .7567E-02,
     +       .0000E+00,      .0000E+00,      .1300E-02,     -.1626E-03,
     +       .9745E-03,     -.1626E-03,      .6167E-02,      .8090E-02,
     +       .0000E+00,      .0000E+00,      .1284E-02,     -.1538E-03,
     +       .9763E-03,     -.1538E-03,      .6342E-02,      .8563E-02,
     +       .0000E+00,      .0000E+00,      .1268E-02,     -.1451E-03,
     +       .9778E-03,     -.1451E-03,      .6512E-02,      .8982E-02,
     +       .0000E+00,      .0000E+00,      .1252E-02,     -.1367E-03,
     +       .9790E-03,     -.1367E-03,      .6677E-02,      .9349E-02,
     +       .0000E+00,      .0000E+00,      .1236E-02,     -.1283E-03,
     +       .9798E-03,     -.1283E-03,      .6835E-02,      .9664E-02/
        DATA ((CELC(I,K,5 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .1221E-02,     -.1201E-03,
     +       .9804E-03,     -.1201E-03,      .6986E-02,      .9927E-02,
     +       .0000E+00,      .0000E+00,      .1205E-02,     -.1120E-03,
     +       .9805E-03,     -.1120E-03,      .7129E-02,      .1014E-01,
     +       .0000E+00,      .0000E+00,      .1189E-02,     -.1041E-03,
     +       .9804E-03,     -.1041E-03,      .7263E-02,      .1030E-01,
     +       .0000E+00,      .0000E+00,      .1173E-02,     -.9636E-04,
     +       .9799E-03,     -.9636E-04,      .7387E-02,      .1042E-01,
     +       .0000E+00,      .0000E+00,      .1157E-02,     -.8876E-04,
     +       .9790E-03,     -.8876E-04,      .7501E-02,      .1049E-01,
     +       .0000E+00,      .0000E+00,      .1140E-02,     -.8132E-04,
     +       .9778E-03,     -.8132E-04,      .7605E-02,      .1052E-01,
     +       .0000E+00,      .0000E+00,      .1124E-02,     -.7404E-04,
     +       .9762E-03,     -.7404E-04,      .7698E-02,      .1051E-01,
     +       .0000E+00,      .0000E+00,      .1108E-02,     -.6693E-04,
     +       .9743E-03,     -.6693E-04,      .7780E-02,      .1047E-01,
     +       .0000E+00,      .0000E+00,      .1092E-02,     -.6000E-04,
     +       .9720E-03,     -.6000E-04,      .7850E-02,      .1039E-01/
        DATA ((CELC(I,K,5 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .1076E-02,     -.5324E-04,
     +       .9694E-03,     -.5324E-04,      .7908E-02,      .1028E-01,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,6 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1259E-02,     -.1212E-03,
     +       .1017E-02,     -.1212E-03,      .5038E-02,      .5434E-02,
     +       .0000E+00,      .0000E+00,      .1242E-02,     -.1118E-03,
     +       .1018E-02,     -.1118E-03,      .5166E-02,      .5883E-02,
     +       .0000E+00,      .0000E+00,      .1225E-02,     -.1027E-03,
     +       .1019E-02,     -.1027E-03,      .5291E-02,      .6285E-02,
     +       .0000E+00,      .0000E+00,      .1208E-02,     -.9380E-04,
     +       .1020E-02,     -.9380E-04,      .5412E-02,      .6638E-02,
     +       .0000E+00,      .0000E+00,      .1190E-02,     -.8512E-04,
     +       .1020E-02,     -.8512E-04,      .5528E-02,      .6944E-02,
     +       .0000E+00,      .0000E+00,      .1173E-02,     -.7666E-04,
     +       .1020E-02,     -.7666E-04,      .5638E-02,      .7202E-02,
     +       .0000E+00,      .0000E+00,      .1156E-02,     -.6842E-04,
     +       .1019E-02,     -.6842E-04,      .5742E-02,      .7414E-02,
     +       .0000E+00,      .0000E+00,      .1139E-02,     -.6041E-04,
     +       .1018E-02,     -.6041E-04,      .5838E-02,      .7582E-02,
     +       .0000E+00,      .0000E+00,      .1122E-02,     -.5262E-04,
     +       .1017E-02,     -.5262E-04,      .5927E-02,      .7708E-02/
        DATA ((CELC(I,K,6 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .1105E-02,     -.4505E-04,
     +       .1015E-02,     -.4505E-04,      .6008E-02,      .7793E-02,
     +       .0000E+00,      .0000E+00,      .1088E-02,     -.3771E-04,
     +       .1013E-02,     -.3771E-04,      .6080E-02,      .7839E-02,
     +       .0000E+00,      .0000E+00,      .1071E-02,     -.3059E-04,
     +       .1010E-02,     -.3059E-04,      .6144E-02,      .7851E-02,
     +       .0000E+00,      .0000E+00,      .1054E-02,     -.2369E-04,
     +       .1007E-02,     -.2369E-04,      .6198E-02,      .7829E-02,
     +       .0000E+00,      .0000E+00,      .1037E-02,     -.1703E-04,
     +       .1003E-02,     -.1703E-04,      .6244E-02,      .7776E-02,
     +       .0000E+00,      .0000E+00,      .1021E-02,     -.1059E-04,
     +       .9995E-03,     -.1059E-04,      .6280E-02,      .7696E-02,
     +       .0000E+00,      .0000E+00,      .1004E-02,     -.4384E-05,
     +       .9952E-03,     -.4384E-05,      .6307E-02,      .7591E-02,
     +       .0000E+00,      .0000E+00,      .9872E-03,      .1594E-05,
     +       .9904E-03,      .1594E-05,      .6325E-02,      .7464E-02,
     +       .0000E+00,      .0000E+00,      .9706E-03,      .7342E-05,
     +       .9853E-03,      .7342E-05,      .6333E-02,      .7316E-02/
        DATA ((CELC(I,K,6 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .9540E-03,      .1286E-04,
     +       .9797E-03,      .1286E-04,      .6333E-02,      .7152E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,7 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1154E-02,     -.4682E-04,
     +       .1061E-02,     -.4682E-04,      .4617E-02,      .5131E-02,
     +       .0000E+00,      .0000E+00,      .1136E-02,     -.3821E-04,
     +       .1060E-02,     -.3821E-04,      .4707E-02,      .5414E-02,
     +       .0000E+00,      .0000E+00,      .1118E-02,     -.2990E-04,
     +       .1059E-02,     -.2990E-04,      .4791E-02,      .5651E-02,
     +       .0000E+00,      .0000E+00,      .1101E-02,     -.2189E-04,
     +       .1057E-02,     -.2189E-04,      .4870E-02,      .5845E-02,
     +       .0000E+00,      .0000E+00,      .1083E-02,     -.1416E-04,
     +       .1055E-02,     -.1416E-04,      .4942E-02,      .5997E-02,
     +       .0000E+00,      .0000E+00,      .1066E-02,     -.6730E-05,
     +       .1052E-02,     -.6730E-05,      .5008E-02,      .6110E-02,
     +       .0000E+00,      .0000E+00,      .1048E-02,      .4163E-06,
     +       .1049E-02,      .4163E-06,      .5066E-02,      .6185E-02,
     +       .0000E+00,      .0000E+00,      .1031E-02,      .7279E-05,
     +       .1046E-02,      .7279E-05,      .5117E-02,      .6225E-02,
     +       .0000E+00,      .0000E+00,      .1014E-02,      .1386E-04,
     +       .1041E-02,      .1386E-04,      .5160E-02,      .6233E-02/
        DATA ((CELC(I,K,7 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .9967E-03,      .2016E-04,
     +       .1037E-02,      .2016E-04,      .5196E-02,      .6211E-02,
     +       .0000E+00,      .0000E+00,      .9796E-03,      .2619E-04,
     +       .1032E-02,      .2619E-04,      .5223E-02,      .6162E-02,
     +       .0000E+00,      .0000E+00,      .9627E-03,      .3193E-04,
     +       .1027E-02,      .3193E-04,      .5243E-02,      .6088E-02,
     +       .0000E+00,      .0000E+00,      .9459E-03,      .3741E-04,
     +       .1021E-02,      .3741E-04,      .5255E-02,      .5992E-02,
     +       .0000E+00,      .0000E+00,      .9291E-03,      .4261E-04,
     +       .1014E-02,      .4261E-04,      .5259E-02,      .5877E-02,
     +       .0000E+00,      .0000E+00,      .9124E-03,      .4755E-04,
     +       .1008E-02,      .4755E-04,      .5255E-02,      .5746E-02,
     +       .0000E+00,      .0000E+00,      .8958E-03,      .5222E-04,
     +       .1000E-02,      .5222E-04,      .5244E-02,      .5600E-02,
     +       .0000E+00,      .0000E+00,      .8793E-03,      .5663E-04,
     +       .9926E-03,      .5663E-04,      .5226E-02,      .5442E-02,
     +       .0000E+00,      .0000E+00,      .8629E-03,      .6078E-04,
     +       .9844E-03,      .6078E-04,      .5201E-02,      .5274E-02/
        DATA ((CELC(I,K,7 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .8465E-03,      .6467E-04,
     +       .9759E-03,      .6467E-04,      .5169E-02,      .5098E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,8 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1055E-02,      .2064E-04,
     +       .1096E-02,      .2064E-04,      .4221E-02,      .4798E-02,
     +       .0000E+00,      .0000E+00,      .1038E-02,      .2789E-04,
     +       .1093E-02,      .2789E-04,      .4282E-02,      .4952E-02,
     +       .0000E+00,      .0000E+00,      .1020E-02,      .3480E-04,
     +       .1090E-02,      .3480E-04,      .4337E-02,      .5066E-02,
     +       .0000E+00,      .0000E+00,      .1003E-02,      .4136E-04,
     +       .1085E-02,      .4136E-04,      .4385E-02,      .5144E-02,
     +       .0000E+00,      .0000E+00,      .9854E-03,      .4758E-04,
     +       .1081E-02,      .4758E-04,      .4426E-02,      .5188E-02,
     +       .0000E+00,      .0000E+00,      .9683E-03,      .5348E-04,
     +       .1075E-02,      .5348E-04,      .4460E-02,      .5201E-02,
     +       .0000E+00,      .0000E+00,      .9513E-03,      .5904E-04,
     +       .1069E-02,      .5904E-04,      .4487E-02,      .5185E-02,
     +       .0000E+00,      .0000E+00,      .9344E-03,      .6430E-04,
     +       .1063E-02,      .6430E-04,      .4507E-02,      .5143E-02,
     +       .0000E+00,      .0000E+00,      .9176E-03,      .6923E-04,
     +       .1056E-02,      .6923E-04,      .4520E-02,      .5077E-02/
        DATA ((CELC(I,K,8 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .9009E-03,      .7386E-04,
     +       .1049E-02,      .7386E-04,      .4526E-02,      .4991E-02,
     +       .0000E+00,      .0000E+00,      .8844E-03,      .7819E-04,
     +       .1041E-02,      .7819E-04,      .4525E-02,      .4888E-02,
     +       .0000E+00,      .0000E+00,      .8679E-03,      .8222E-04,
     +       .1032E-02,      .8222E-04,      .4517E-02,      .4768E-02,
     +       .0000E+00,      .0000E+00,      .8515E-03,      .8597E-04,
     +       .1023E-02,      .8597E-04,      .4502E-02,      .4636E-02,
     +       .0000E+00,      .0000E+00,      .8352E-03,      .8942E-04,
     +       .1014E-02,      .8942E-04,      .4481E-02,      .4493E-02,
     +       .0000E+00,      .0000E+00,      .8190E-03,      .9260E-04,
     +       .1004E-02,      .9260E-04,      .4454E-02,      .4342E-02,
     +       .0000E+00,      .0000E+00,      .8028E-03,      .9550E-04,
     +       .9938E-03,      .9550E-04,      .4421E-02,      .4184E-02,
     +       .0000E+00,      .0000E+00,      .7868E-03,      .9814E-04,
     +       .9831E-03,      .9814E-04,      .4382E-02,      .4021E-02,
     +       .0000E+00,      .0000E+00,      .7708E-03,      .1005E-03,
     +       .9719E-03,      .1005E-03,      .4339E-02,      .3855E-02/
        DATA ((CELC(I,K,8 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .7550E-03,      .1026E-03,
     +       .9603E-03,      .1026E-03,      .4290E-02,      .3687E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,9 ),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .9683E-03,      .7884E-04,
     +       .1126E-02,      .7884E-04,      .3873E-02,      .4441E-02,
     +       .0000E+00,      .0000E+00,      .9514E-03,      .8432E-04,
     +       .1120E-02,      .8432E-04,      .3912E-02,      .4496E-02,
     +       .0000E+00,      .0000E+00,      .9346E-03,      .8942E-04,
     +       .1113E-02,      .8942E-04,      .3945E-02,      .4519E-02,
     +       .0000E+00,      .0000E+00,      .9179E-03,      .9417E-04,
     +       .1106E-02,      .9417E-04,      .3970E-02,      .4513E-02,
     +       .0000E+00,      .0000E+00,      .9013E-03,      .9856E-04,
     +       .1098E-02,      .9856E-04,      .3988E-02,      .4480E-02,
     +       .0000E+00,      .0000E+00,      .8849E-03,      .1026E-03,
     +       .1090E-02,      .1026E-03,      .4000E-02,      .4425E-02,
     +       .0000E+00,      .0000E+00,      .8685E-03,      .1063E-03,
     +       .1081E-02,      .1063E-03,      .4005E-02,      .4348E-02,
     +       .0000E+00,      .0000E+00,      .8522E-03,      .1097E-03,
     +       .1072E-02,      .1097E-03,      .4003E-02,      .4254E-02,
     +       .0000E+00,      .0000E+00,      .8360E-03,      .1128E-03,
     +       .1062E-02,      .1128E-03,      .3995E-02,      .4145E-02/
        DATA ((CELC(I,K,9 ),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .8199E-03,      .1156E-03,
     +       .1051E-02,      .1156E-03,      .3981E-02,      .4024E-02,
     +       .0000E+00,      .0000E+00,      .8039E-03,      .1180E-03,
     +       .1040E-02,      .1180E-03,      .3960E-02,      .3891E-02,
     +       .0000E+00,      .0000E+00,      .7879E-03,      .1202E-03,
     +       .1028E-02,      .1202E-03,      .3934E-02,      .3751E-02,
     +       .0000E+00,      .0000E+00,      .7720E-03,      .1221E-03,
     +       .1016E-02,      .1221E-03,      .3903E-02,      .3604E-02,
     +       .0000E+00,      .0000E+00,      .7562E-03,      .1237E-03,
     +       .1004E-02,      .1237E-03,      .3866E-02,      .3453E-02,
     +       .0000E+00,      .0000E+00,      .7405E-03,      .1251E-03,
     +       .9906E-03,      .1251E-03,      .3825E-02,      .3300E-02,
     +       .0000E+00,      .0000E+00,      .7248E-03,      .1262E-03,
     +       .9772E-03,      .1262E-03,      .3779E-02,      .3145E-02,
     +       .0000E+00,      .0000E+00,      .7092E-03,      .1271E-03,
     +       .9633E-03,      .1271E-03,      .3728E-02,      .2991E-02,
     +       .0000E+00,      .0000E+00,      .6936E-03,      .1277E-03,
     +       .9490E-03,      .1277E-03,      .3674E-02,      .2838E-02/
        DATA ((CELC(I,K,9 ),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .6782E-03,      .1281E-03,
     +       .9344E-03,      .1281E-03,      .3617E-02,      .2687E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,10),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .8965E-03,      .1265E-03,
     +       .1150E-02,      .1265E-03,      .3586E-02,      .4066E-02,
     +       .0000E+00,      .0000E+00,      .8803E-03,      .1300E-03,
     +       .1140E-02,      .1300E-03,      .3607E-02,      .4047E-02,
     +       .0000E+00,      .0000E+00,      .8642E-03,      .1331E-03,
     +       .1130E-02,      .1331E-03,      .3621E-02,      .4002E-02,
     +       .0000E+00,      .0000E+00,      .8482E-03,      .1359E-03,
     +       .1120E-02,      .1359E-03,      .3628E-02,      .3936E-02,
     +       .0000E+00,      .0000E+00,      .8322E-03,      .1383E-03,
     +       .1109E-02,      .1383E-03,      .3629E-02,      .3851E-02,
     +       .0000E+00,      .0000E+00,      .8163E-03,      .1404E-03,
     +       .1097E-02,      .1404E-03,      .3623E-02,      .3751E-02,
     +       .0000E+00,      .0000E+00,      .8004E-03,      .1422E-03,
     +       .1085E-02,      .1422E-03,      .3611E-02,      .3637E-02,
     +       .0000E+00,      .0000E+00,      .7846E-03,      .1436E-03,
     +       .1072E-02,      .1436E-03,      .3593E-02,      .3512E-02,
     +       .0000E+00,      .0000E+00,      .7688E-03,      .1448E-03,
     +       .1058E-02,      .1448E-03,      .3570E-02,      .3379E-02/
        DATA ((CELC(I,K,10),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .7530E-03,      .1457E-03,
     +       .1044E-02,      .1457E-03,      .3541E-02,      .3240E-02,
     +       .0000E+00,      .0000E+00,      .7374E-03,      .1463E-03,
     +       .1030E-02,      .1463E-03,      .3507E-02,      .3097E-02,
     +       .0000E+00,      .0000E+00,      .7217E-03,      .1467E-03,
     +       .1015E-02,      .1467E-03,      .3469E-02,      .2950E-02,
     +       .0000E+00,      .0000E+00,      .7061E-03,      .1468E-03,
     +       .9997E-03,      .1468E-03,      .3426E-02,      .2803E-02,
     +       .0000E+00,      .0000E+00,      .6905E-03,      .1467E-03,
     +       .9839E-03,      .1467E-03,      .3379E-02,      .2656E-02,
     +       .0000E+00,      .0000E+00,      .6750E-03,      .1463E-03,
     +       .9676E-03,      .1463E-03,      .3328E-02,      .2511E-02,
     +       .0000E+00,      .0000E+00,      .6596E-03,      .1457E-03,
     +       .9510E-03,      .1457E-03,      .3274E-02,      .2368E-02,
     +       .0000E+00,      .0000E+00,      .6442E-03,      .1449E-03,
     +       .9341E-03,      .1449E-03,      .3217E-02,      .2228E-02,
     +       .0000E+00,      .0000E+00,      .6288E-03,      .1440E-03,
     +       .9168E-03,      .1440E-03,      .3156E-02,      .2093E-02/
        DATA ((CELC(I,K,10),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .6136E-03,      .1428E-03,
     +       .8992E-03,      .1428E-03,      .3094E-02,      .1962E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,11),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .8398E-03,      .1635E-03,
     +       .1167E-02,      .1635E-03,      .3359E-02,      .3682E-02,
     +       .0000E+00,      .0000E+00,      .8240E-03,      .1649E-03,
     +       .1154E-02,      .1649E-03,      .3364E-02,      .3607E-02,
     +       .0000E+00,      .0000E+00,      .8082E-03,      .1660E-03,
     +       .1140E-02,      .1660E-03,      .3362E-02,      .3515E-02,
     +       .0000E+00,      .0000E+00,      .7925E-03,      .1668E-03,
     +       .1126E-02,      .1668E-03,      .3354E-02,      .3407E-02,
     +       .0000E+00,      .0000E+00,      .7767E-03,      .1672E-03,
     +       .1111E-02,      .1672E-03,      .3340E-02,      .3289E-02,
     +       .0000E+00,      .0000E+00,      .7610E-03,      .1674E-03,
     +       .1096E-02,      .1674E-03,      .3319E-02,      .3160E-02,
     +       .0000E+00,      .0000E+00,      .7452E-03,      .1673E-03,
     +       .1080E-02,      .1673E-03,      .3294E-02,      .3025E-02,
     +       .0000E+00,      .0000E+00,      .7295E-03,      .1669E-03,
     +       .1063E-02,      .1669E-03,      .3263E-02,      .2885E-02,
     +       .0000E+00,      .0000E+00,      .7137E-03,      .1663E-03,
     +       .1046E-02,      .1663E-03,      .3227E-02,      .2742E-02/
        DATA ((CELC(I,K,11),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .6980E-03,      .1654E-03,
     +       .1029E-02,      .1654E-03,      .3187E-02,      .2598E-02,
     +       .0000E+00,      .0000E+00,      .6823E-03,      .1643E-03,
     +       .1011E-02,      .1643E-03,      .3143E-02,      .2454E-02,
     +       .0000E+00,      .0000E+00,      .6666E-03,      .1630E-03,
     +       .9926E-03,      .1630E-03,      .3095E-02,      .2312E-02,
     +       .0000E+00,      .0000E+00,      .6509E-03,      .1615E-03,
     +       .9739E-03,      .1615E-03,      .3043E-02,      .2172E-02,
     +       .0000E+00,      .0000E+00,      .6353E-03,      .1598E-03,
     +       .9549E-03,      .1598E-03,      .2988E-02,      .2036E-02,
     +       .0000E+00,      .0000E+00,      .6197E-03,      .1579E-03,
     +       .9355E-03,      .1579E-03,      .2931E-02,      .1904E-02,
     +       .0000E+00,      .0000E+00,      .6041E-03,      .1559E-03,
     +       .9158E-03,      .1559E-03,      .2871E-02,      .1777E-02,
     +       .0000E+00,      .0000E+00,      .5886E-03,      .1536E-03,
     +       .8959E-03,      .1536E-03,      .2809E-02,      .1655E-02,
     +       .0000E+00,      .0000E+00,      .5732E-03,      .1513E-03,
     +       .8758E-03,      .1513E-03,      .2745E-02,      .1539E-02/
        DATA ((CELC(I,K,11),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .5579E-03,      .1488E-03,
     +       .8555E-03,      .1488E-03,      .2680E-02,      .1429E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,12),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .7960E-03,      .1902E-03,
     +       .1176E-02,      .1902E-03,      .3184E-02,      .3295E-02,
     +       .0000E+00,      .0000E+00,      .7801E-03,      .1897E-03,
     +       .1160E-02,      .1897E-03,      .3174E-02,      .3181E-02,
     +       .0000E+00,      .0000E+00,      .7642E-03,      .1889E-03,
     +       .1142E-02,      .1889E-03,      .3157E-02,      .3056E-02,
     +       .0000E+00,      .0000E+00,      .7482E-03,      .1878E-03,
     +       .1124E-02,      .1878E-03,      .3134E-02,      .2923E-02,
     +       .0000E+00,      .0000E+00,      .7321E-03,      .1864E-03,
     +       .1105E-02,      .1864E-03,      .3106E-02,      .2783E-02,
     +       .0000E+00,      .0000E+00,      .7161E-03,      .1848E-03,
     +       .1086E-02,      .1848E-03,      .3073E-02,      .2641E-02,
     +       .0000E+00,      .0000E+00,      .7000E-03,      .1830E-03,
     +       .1066E-02,      .1830E-03,      .3035E-02,      .2496E-02,
     +       .0000E+00,      .0000E+00,      .6838E-03,      .1809E-03,
     +       .1046E-02,      .1809E-03,      .2993E-02,      .2352E-02,
     +       .0000E+00,      .0000E+00,      .6677E-03,      .1787E-03,
     +       .1025E-02,      .1787E-03,      .2947E-02,      .2209E-02/
        DATA ((CELC(I,K,12),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .6515E-03,      .1762E-03,
     +       .1004E-02,      .1762E-03,      .2897E-02,      .2068E-02,
     +       .0000E+00,      .0000E+00,      .6354E-03,      .1736E-03,
     +       .9827E-03,      .1736E-03,      .2844E-02,      .1932E-02,
     +       .0000E+00,      .0000E+00,      .6193E-03,      .1709E-03,
     +       .9610E-03,      .1709E-03,      .2788E-02,      .1799E-02,
     +       .0000E+00,      .0000E+00,      .6032E-03,      .1679E-03,
     +       .9391E-03,      .1679E-03,      .2729E-02,      .1672E-02,
     +       .0000E+00,      .0000E+00,      .5871E-03,      .1649E-03,
     +       .9169E-03,      .1649E-03,      .2669E-02,      .1550E-02,
     +       .0000E+00,      .0000E+00,      .5712E-03,      .1617E-03,
     +       .8946E-03,      .1617E-03,      .2606E-02,      .1435E-02,
     +       .0000E+00,      .0000E+00,      .5552E-03,      .1584E-03,
     +       .8721E-03,      .1584E-03,      .2542E-02,      .1325E-02,
     +       .0000E+00,      .0000E+00,      .5394E-03,      .1550E-03,
     +       .8495E-03,      .1550E-03,      .2476E-02,      .1222E-02,
     +       .0000E+00,      .0000E+00,      .5237E-03,      .1516E-03,
     +       .8268E-03,      .1516E-03,      .2409E-02,      .1125E-02/
        DATA ((CELC(I,K,12),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .5081E-03,      .1480E-03,
     +       .8041E-03,      .1480E-03,      .2342E-02,      .1035E-02,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,13),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .7620E-03,      .2079E-03,
     +       .1178E-02,      .2079E-03,      .3048E-02,      .2912E-02,
     +       .0000E+00,      .0000E+00,      .7454E-03,      .2055E-03,
     +       .1156E-02,      .2055E-03,      .3022E-02,      .2772E-02,
     +       .0000E+00,      .0000E+00,      .7286E-03,      .2030E-03,
     +       .1135E-02,      .2030E-03,      .2991E-02,      .2627E-02,
     +       .0000E+00,      .0000E+00,      .7118E-03,      .2002E-03,
     +       .1112E-02,      .2002E-03,      .2955E-02,      .2479E-02,
     +       .0000E+00,      .0000E+00,      .6950E-03,      .1972E-03,
     +       .1089E-02,      .1972E-03,      .2913E-02,      .2331E-02,
     +       .0000E+00,      .0000E+00,      .6781E-03,      .1940E-03,
     +       .1066E-02,      .1940E-03,      .2868E-02,      .2184E-02,
     +       .0000E+00,      .0000E+00,      .6611E-03,      .1906E-03,
     +       .1042E-02,      .1906E-03,      .2819E-02,      .2039E-02,
     +       .0000E+00,      .0000E+00,      .6442E-03,      .1871E-03,
     +       .1018E-02,      .1871E-03,      .2766E-02,      .1898E-02,
     +       .0000E+00,      .0000E+00,      .6272E-03,      .1835E-03,
     +       .9942E-03,      .1835E-03,      .2710E-02,      .1762E-02/
        DATA ((CELC(I,K,13),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .6103E-03,      .1797E-03,
     +       .9698E-03,      .1797E-03,      .2652E-02,      .1631E-02,
     +       .0000E+00,      .0000E+00,      .5934E-03,      .1759E-03,
     +       .9451E-03,      .1759E-03,      .2591E-02,      .1506E-02,
     +       .0000E+00,      .0000E+00,      .5766E-03,      .1719E-03,
     +       .9203E-03,      .1719E-03,      .2528E-02,      .1387E-02,
     +       .0000E+00,      .0000E+00,      .5598E-03,      .1678E-03,
     +       .8954E-03,      .1678E-03,      .2464E-02,      .1275E-02,
     +       .0000E+00,      .0000E+00,      .5431E-03,      .1637E-03,
     +       .8705E-03,      .1637E-03,      .2398E-02,      .1169E-02,
     +       .0000E+00,      .0000E+00,      .5266E-03,      .1595E-03,
     +       .8455E-03,      .1595E-03,      .2331E-02,      .1071E-02,
     +       .0000E+00,      .0000E+00,      .5101E-03,      .1552E-03,
     +       .8205E-03,      .1552E-03,      .2263E-02,      .9791E-03,
     +       .0000E+00,      .0000E+00,      .4938E-03,      .1509E-03,
     +       .7957E-03,      .1509E-03,      .2195E-02,      .8939E-03,
     +       .0000E+00,      .0000E+00,      .4777E-03,      .1466E-03,
     +       .7709E-03,      .1466E-03,      .2126E-02,      .8151E-03/
        DATA ((CELC(I,K,13),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .4617E-03,      .1423E-03,
     +       .7462E-03,      .1423E-03,      .2057E-02,      .7425E-03,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,14),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .7339E-03,      .2177E-03,
     +       .1169E-02,      .2177E-03,      .2935E-02,      .2540E-02,
     +       .0000E+00,      .0000E+00,      .7159E-03,      .2138E-03,
     +       .1143E-02,      .2138E-03,      .2894E-02,      .2385E-02,
     +       .0000E+00,      .0000E+00,      .6979E-03,      .2097E-03,
     +       .1117E-02,      .2097E-03,      .2849E-02,      .2230E-02,
     +       .0000E+00,      .0000E+00,      .6798E-03,      .2054E-03,
     +       .1091E-02,      .2054E-03,      .2799E-02,      .2078E-02,
     +       .0000E+00,      .0000E+00,      .6617E-03,      .2010E-03,
     +       .1064E-02,      .2010E-03,      .2745E-02,      .1929E-02,
     +       .0000E+00,      .0000E+00,      .6435E-03,      .1965E-03,
     +       .1036E-02,      .1965E-03,      .2688E-02,      .1784E-02,
     +       .0000E+00,      .0000E+00,      .6254E-03,      .1918E-03,
     +       .1009E-02,      .1918E-03,      .2628E-02,      .1646E-02,
     +       .0000E+00,      .0000E+00,      .6074E-03,      .1871E-03,
     +       .9816E-03,      .1871E-03,      .2566E-02,      .1514E-02,
     +       .0000E+00,      .0000E+00,      .5894E-03,      .1823E-03,
     +       .9540E-03,      .1823E-03,      .2501E-02,      .1388E-02/
        DATA ((CELC(I,K,14),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .5714E-03,      .1775E-03,
     +       .9263E-03,      .1775E-03,      .2435E-02,      .1270E-02,
     +       .0000E+00,      .0000E+00,      .5536E-03,      .1726E-03,
     +       .8987E-03,      .1726E-03,      .2367E-02,      .1159E-02,
     +       .0000E+00,      .0000E+00,      .5359E-03,      .1676E-03,
     +       .8711E-03,      .1676E-03,      .2299E-02,      .1056E-02,
     +       .0000E+00,      .0000E+00,      .5183E-03,      .1627E-03,
     +       .8436E-03,      .1627E-03,      .2229E-02,      .9600E-03,
     +       .0000E+00,      .0000E+00,      .5009E-03,      .1577E-03,
     +       .8162E-03,      .1577E-03,      .2159E-02,      .8712E-03,
     +       .0000E+00,      .0000E+00,      .4837E-03,      .1527E-03,
     +       .7891E-03,      .1527E-03,      .2088E-02,      .7894E-03,
     +       .0000E+00,      .0000E+00,      .4666E-03,      .1477E-03,
     +       .7621E-03,      .1477E-03,      .2018E-02,      .7144E-03,
     +       .0000E+00,      .0000E+00,      .4498E-03,      .1428E-03,
     +       .7354E-03,      .1428E-03,      .1947E-02,      .6457E-03,
     +       .0000E+00,      .0000E+00,      .4333E-03,      .1379E-03,
     +       .7090E-03,      .1379E-03,      .1877E-02,      .5831E-03/
        DATA ((CELC(I,K,14),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .4170E-03,      .1330E-03,
     +       .6830E-03,      .1330E-03,      .1808E-02,      .5261E-03,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,15),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .7080E-03,      .2212E-03,
     +       .1150E-02,      .2212E-03,      .2832E-02,      .2183E-02,
     +       .0000E+00,      .0000E+00,      .6883E-03,      .2158E-03,
     +       .1120E-02,      .2158E-03,      .2776E-02,      .2023E-02,
     +       .0000E+00,      .0000E+00,      .6686E-03,      .2104E-03,
     +       .1089E-02,      .2104E-03,      .2716E-02,      .1867E-02,
     +       .0000E+00,      .0000E+00,      .6489E-03,      .2049E-03,
     +       .1059E-02,      .2049E-03,      .2653E-02,      .1717E-02,
     +       .0000E+00,      .0000E+00,      .6292E-03,      .1993E-03,
     +       .1028E-02,      .1993E-03,      .2588E-02,      .1573E-02,
     +       .0000E+00,      .0000E+00,      .6097E-03,      .1936E-03,
     +       .9969E-03,      .1936E-03,      .2520E-02,      .1437E-02,
     +       .0000E+00,      .0000E+00,      .5902E-03,      .1879E-03,
     +       .9660E-03,      .1879E-03,      .2450E-02,      .1310E-02,
     +       .0000E+00,      .0000E+00,      .5708E-03,      .1822E-03,
     +       .9353E-03,      .1822E-03,      .2379E-02,      .1190E-02,
     +       .0000E+00,      .0000E+00,      .5516E-03,      .1765E-03,
     +       .9047E-03,      .1765E-03,      .2307E-02,      .1078E-02/
        DATA ((CELC(I,K,15),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .5326E-03,      .1708E-03,
     +       .8742E-03,      .1708E-03,      .2234E-02,      .9749E-03,
     +       .0000E+00,      .0000E+00,      .5138E-03,      .1651E-03,
     +       .8440E-03,      .1651E-03,      .2161E-02,      .8796E-03,
     +       .0000E+00,      .0000E+00,      .4952E-03,      .1594E-03,
     +       .8141E-03,      .1594E-03,      .2087E-02,      .7921E-03,
     +       .0000E+00,      .0000E+00,      .4769E-03,      .1538E-03,
     +       .7845E-03,      .1538E-03,      .2013E-02,      .7121E-03,
     +       .0000E+00,      .0000E+00,      .4588E-03,      .1482E-03,
     +       .7553E-03,      .1482E-03,      .1939E-02,      .6393E-03,
     +       .0000E+00,      .0000E+00,      .4410E-03,      .1427E-03,
     +       .7264E-03,      .1427E-03,      .1866E-02,      .5731E-03,
     +       .0000E+00,      .0000E+00,      .4235E-03,      .1373E-03,
     +       .6981E-03,      .1373E-03,      .1794E-02,      .5133E-03,
     +       .0000E+00,      .0000E+00,      .4063E-03,      .1319E-03,
     +       .6702E-03,      .1319E-03,      .1723E-02,      .4593E-03,
     +       .0000E+00,      .0000E+00,      .3895E-03,      .1266E-03,
     +       .6428E-03,      .1266E-03,      .1652E-02,      .4107E-03/
        DATA ((CELC(I,K,15),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .3731E-03,      .1214E-03,
     +       .6159E-03,      .1214E-03,      .1583E-02,      .3671E-03,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,16),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .6814E-03,      .2195E-03,
     +       .1120E-02,      .2195E-03,      .2725E-02,      .1848E-02,
     +       .0000E+00,      .0000E+00,      .6597E-03,      .2129E-03,
     +       .1085E-02,      .2129E-03,      .2655E-02,      .1689E-02,
     +       .0000E+00,      .0000E+00,      .6381E-03,      .2063E-03,
     +       .1051E-02,      .2063E-03,      .2582E-02,      .1538E-02,
     +       .0000E+00,      .0000E+00,      .6167E-03,      .1998E-03,
     +       .1016E-02,      .1998E-03,      .2508E-02,      .1396E-02,
     +       .0000E+00,      .0000E+00,      .5954E-03,      .1932E-03,
     +       .9818E-03,      .1932E-03,      .2431E-02,      .1263E-02,
     +       .0000E+00,      .0000E+00,      .5743E-03,      .1866E-03,
     +       .9476E-03,      .1866E-03,      .2354E-02,      .1139E-02,
     +       .0000E+00,      .0000E+00,      .5535E-03,      .1801E-03,
     +       .9137E-03,      .1801E-03,      .2276E-02,      .1025E-02,
     +       .0000E+00,      .0000E+00,      .5329E-03,      .1737E-03,
     +       .8802E-03,      .1737E-03,      .2197E-02,      .9197E-03,
     +       .0000E+00,      .0000E+00,      .5126E-03,      .1672E-03,
     +       .8470E-03,      .1672E-03,      .2119E-02,      .8234E-03/
        DATA ((CELC(I,K,16),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .4925E-03,      .1609E-03,
     +       .8144E-03,      .1609E-03,      .2040E-02,      .7356E-03,
     +       .0000E+00,      .0000E+00,      .4729E-03,      .1546E-03,
     +       .7822E-03,      .1546E-03,      .1962E-02,      .6559E-03,
     +       .0000E+00,      .0000E+00,      .4535E-03,      .1485E-03,
     +       .7505E-03,      .1485E-03,      .1884E-02,      .5839E-03,
     +       .0000E+00,      .0000E+00,      .4346E-03,      .1424E-03,
     +       .7194E-03,      .1424E-03,      .1808E-02,      .5190E-03,
     +       .0000E+00,      .0000E+00,      .4160E-03,      .1365E-03,
     +       .6889E-03,      .1365E-03,      .1732E-02,      .4608E-03,
     +       .0000E+00,      .0000E+00,      .3979E-03,      .1306E-03,
     +       .6591E-03,      .1306E-03,      .1658E-02,      .4086E-03,
     +       .0000E+00,      .0000E+00,      .3801E-03,      .1249E-03,
     +       .6299E-03,      .1249E-03,      .1585E-02,      .3622E-03,
     +       .0000E+00,      .0000E+00,      .3628E-03,      .1193E-03,
     +       .6015E-03,      .1193E-03,      .1514E-02,      .3208E-03,
     +       .0000E+00,      .0000E+00,      .3460E-03,      .1139E-03,
     +       .5737E-03,      .1139E-03,      .1444E-02,      .2840E-03/
        DATA ((CELC(I,K,16),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .3296E-03,      .1085E-03,
     +       .5467E-03,      .1085E-03,      .1376E-02,      .2515E-03,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,17),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .6519E-03,      .2136E-03,
     +       .1079E-02,      .2136E-03,      .2608E-02,      .1538E-02,
     +       .0000E+00,      .0000E+00,      .6282E-03,      .2060E-03,
     +       .1040E-02,      .2060E-03,      .2524E-02,      .1386E-02,
     +       .0000E+00,      .0000E+00,      .6047E-03,      .1985E-03,
     +       .1002E-02,      .1985E-03,      .2440E-02,      .1246E-02,
     +       .0000E+00,      .0000E+00,      .5816E-03,      .1911E-03,
     +       .9638E-03,      .1911E-03,      .2354E-02,      .1115E-02,
     +       .0000E+00,      .0000E+00,      .5588E-03,      .1838E-03,
     +       .9263E-03,      .1838E-03,      .2269E-02,      .9958E-03,
     +       .0000E+00,      .0000E+00,      .5363E-03,      .1765E-03,
     +       .8894E-03,      .1765E-03,      .2184E-02,      .8866E-03,
     +       .0000E+00,      .0000E+00,      .5143E-03,      .1694E-03,
     +       .8530E-03,      .1694E-03,      .2098E-02,      .7874E-03,
     +       .0000E+00,      .0000E+00,      .4926E-03,      .1624E-03,
     +       .8173E-03,      .1624E-03,      .2014E-02,      .6976E-03,
     +       .0000E+00,      .0000E+00,      .4714E-03,      .1555E-03,
     +       .7823E-03,      .1555E-03,      .1930E-02,      .6167E-03/
        DATA ((CELC(I,K,17),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .4506E-03,      .1487E-03,
     +       .7480E-03,      .1487E-03,      .1848E-02,      .5442E-03,
     +       .0000E+00,      .0000E+00,      .4303E-03,      .1421E-03,
     +       .7145E-03,      .1421E-03,      .1767E-02,      .4794E-03,
     +       .0000E+00,      .0000E+00,      .4105E-03,      .1356E-03,
     +       .6817E-03,      .1356E-03,      .1687E-02,      .4217E-03,
     +       .0000E+00,      .0000E+00,      .3912E-03,      .1293E-03,
     +       .6498E-03,      .1293E-03,      .1609E-02,      .3705E-03,
     +       .0000E+00,      .0000E+00,      .3724E-03,      .1232E-03,
     +       .6188E-03,      .1232E-03,      .1533E-02,      .3252E-03,
     +       .0000E+00,      .0000E+00,      .3542E-03,      .1172E-03,
     +       .5886E-03,      .1172E-03,      .1459E-02,      .2853E-03,
     +       .0000E+00,      .0000E+00,      .3366E-03,      .1114E-03,
     +       .5594E-03,      .1114E-03,      .1386E-02,      .2502E-03,
     +       .0000E+00,      .0000E+00,      .3194E-03,      .1058E-03,
     +       .5310E-03,      .1058E-03,      .1316E-02,      .2193E-03,
     +       .0000E+00,      .0000E+00,      .3029E-03,      .1003E-03,
     +       .5036E-03,      .1003E-03,      .1248E-02,      .1923E-03/
        DATA ((CELC(I,K,17),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .2869E-03,      .9507E-04,
     +       .4771E-03,      .9507E-04,      .1182E-02,      .1686E-03,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,18),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .6183E-03,      .2044E-03,
     +       .1027E-02,      .2044E-03,      .2473E-02,      .1256E-02,
     +       .0000E+00,      .0000E+00,      .5927E-03,      .1961E-03,
     +       .9848E-03,      .1961E-03,      .2378E-02,      .1116E-02,
     +       .0000E+00,      .0000E+00,      .5676E-03,      .1878E-03,
     +       .9432E-03,      .1878E-03,      .2284E-02,      .9891E-03,
     +       .0000E+00,      .0000E+00,      .5429E-03,      .1798E-03,
     +       .9024E-03,      .1798E-03,      .2190E-02,      .8736E-03,
     +       .0000E+00,      .0000E+00,      .5188E-03,      .1718E-03,
     +       .8625E-03,      .1718E-03,      .2097E-02,      .7693E-03,
     +       .0000E+00,      .0000E+00,      .4952E-03,      .1641E-03,
     +       .8234E-03,      .1641E-03,      .2006E-02,      .6757E-03,
     +       .0000E+00,      .0000E+00,      .4722E-03,      .1565E-03,
     +       .7853E-03,      .1565E-03,      .1916E-02,      .5921E-03,
     +       .0000E+00,      .0000E+00,      .4498E-03,      .1491E-03,
     +       .7481E-03,      .1491E-03,      .1827E-02,      .5177E-03,
     +       .0000E+00,      .0000E+00,      .4280E-03,      .1420E-03,
     +       .7119E-03,      .1420E-03,      .1740E-02,      .4518E-03/
        DATA ((CELC(I,K,18),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .4068E-03,      .1350E-03,
     +       .6767E-03,      .1350E-03,      .1656E-02,      .3936E-03,
     +       .0000E+00,      .0000E+00,      .3862E-03,      .1282E-03,
     +       .6426E-03,      .1282E-03,      .1573E-02,      .3424E-03,
     +       .0000E+00,      .0000E+00,      .3663E-03,      .1216E-03,
     +       .6095E-03,      .1216E-03,      .1493E-02,      .2975E-03,
     +       .0000E+00,      .0000E+00,      .3470E-03,      .1152E-03,
     +       .5775E-03,      .1152E-03,      .1415E-02,      .2583E-03,
     +       .0000E+00,      .0000E+00,      .3284E-03,      .1091E-03,
     +       .5466E-03,      .1091E-03,      .1340E-02,      .2241E-03,
     +       .0000E+00,      .0000E+00,      .3105E-03,      .1031E-03,
     +       .5168E-03,      .1031E-03,      .1267E-02,      .1944E-03,
     +       .0000E+00,      .0000E+00,      .2932E-03,      .9743E-04,
     +       .4881E-03,      .9743E-04,      .1197E-02,      .1686E-03,
     +       .0000E+00,      .0000E+00,      .2766E-03,      .9193E-04,
     +       .4605E-03,      .9193E-04,      .1129E-02,      .1463E-03,
     +       .0000E+00,      .0000E+00,      .2607E-03,      .8665E-04,
     +       .4340E-03,      .8665E-04,      .1064E-02,      .1270E-03/
        DATA ((CELC(I,K,18),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .2454E-03,      .8159E-04,
     +       .4086E-03,      .8159E-04,      .1002E-02,      .1103E-03,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,19),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .5800E-03,      .1926E-03,
     +       .9653E-03,      .1926E-03,      .2320E-02,      .1005E-02,
     +       .0000E+00,      .0000E+00,      .5528E-03,      .1837E-03,
     +       .9201E-03,      .1837E-03,      .2216E-02,      .8800E-03,
     +       .0000E+00,      .0000E+00,      .5263E-03,      .1749E-03,
     +       .8761E-03,      .1749E-03,      .2114E-02,      .7684E-03,
     +       .0000E+00,      .0000E+00,      .5005E-03,      .1663E-03,
     +       .8332E-03,      .1663E-03,      .2014E-02,      .6689E-03,
     +       .0000E+00,      .0000E+00,      .4754E-03,      .1580E-03,
     +       .7915E-03,      .1580E-03,      .1916E-02,      .5807E-03,
     +       .0000E+00,      .0000E+00,      .4511E-03,      .1500E-03,
     +       .7511E-03,      .1500E-03,      .1820E-02,      .5029E-03,
     +       .0000E+00,      .0000E+00,      .4276E-03,      .1422E-03,
     +       .7119E-03,      .1422E-03,      .1727E-02,      .4345E-03,
     +       .0000E+00,      .0000E+00,      .4048E-03,      .1346E-03,
     +       .6740E-03,      .1346E-03,      .1636E-02,      .3747E-03,
     +       .0000E+00,      .0000E+00,      .3828E-03,      .1273E-03,
     +       .6374E-03,      .1273E-03,      .1549E-02,      .3226E-03/
        DATA ((CELC(I,K,19),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .3616E-03,      .1203E-03,
     +       .6022E-03,      .1203E-03,      .1464E-02,      .2773E-03,
     +       .0000E+00,      .0000E+00,      .3412E-03,      .1135E-03,
     +       .5682E-03,      .1135E-03,      .1382E-02,      .2382E-03,
     +       .0000E+00,      .0000E+00,      .3215E-03,      .1070E-03,
     +       .5355E-03,      .1070E-03,      .1303E-02,      .2043E-03,
     +       .0000E+00,      .0000E+00,      .3027E-03,      .1007E-03,
     +       .5042E-03,      .1007E-03,      .1227E-02,      .1752E-03,
     +       .0000E+00,      .0000E+00,      .2846E-03,      .9473E-04,
     +       .4741E-03,      .9473E-04,      .1154E-02,      .1502E-03,
     +       .0000E+00,      .0000E+00,      .2674E-03,      .8899E-04,
     +       .4454E-03,      .8899E-04,      .1084E-02,      .1288E-03,
     +       .0000E+00,      .0000E+00,      .2509E-03,      .8351E-04,
     +       .4179E-03,      .8351E-04,      .1017E-02,      .1105E-03,
     +       .0000E+00,      .0000E+00,      .2351E-03,      .7827E-04,
     +       .3917E-03,      .7827E-04,      .9535E-03,      .9488E-04,
     +       .0000E+00,      .0000E+00,      .2201E-03,      .7328E-04,
     +       .3667E-03,      .7328E-04,      .8927E-03,      .8153E-04/
        DATA ((CELC(I,K,19),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .2058E-03,      .6853E-04,
     +       .3429E-03,      .6853E-04,      .8348E-03,      .7015E-04,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,20),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .5371E-03,      .1788E-03,
     +       .8947E-03,      .1788E-03,      .2149E-02,      .7852E-03,
     +       .0000E+00,      .0000E+00,      .5087E-03,      .1694E-03,
     +       .8474E-03,      .1694E-03,      .2038E-02,      .6771E-03,
     +       .0000E+00,      .0000E+00,      .4813E-03,      .1602E-03,
     +       .8017E-03,      .1602E-03,      .1930E-02,      .5822E-03,
     +       .0000E+00,      .0000E+00,      .4548E-03,      .1514E-03,
     +       .7576E-03,      .1514E-03,      .1826E-02,      .4992E-03,
     +       .0000E+00,      .0000E+00,      .4292E-03,      .1429E-03,
     +       .7151E-03,      .1429E-03,      .1725E-02,      .4269E-03,
     +       .0000E+00,      .0000E+00,      .4046E-03,      .1347E-03,
     +       .6741E-03,      .1347E-03,      .1628E-02,      .3642E-03,
     +       .0000E+00,      .0000E+00,      .3810E-03,      .1269E-03,
     +       .6347E-03,      .1269E-03,      .1534E-02,      .3101E-03,
     +       .0000E+00,      .0000E+00,      .3583E-03,      .1193E-03,
     +       .5970E-03,      .1193E-03,      .1443E-02,      .2636E-03,
     +       .0000E+00,      .0000E+00,      .3366E-03,      .1121E-03,
     +       .5608E-03,      .1121E-03,      .1356E-02,      .2237E-03/
        DATA ((CELC(I,K,20),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .3158E-03,      .1052E-03,
     +       .5262E-03,      .1052E-03,      .1273E-02,      .1897E-03,
     +       .0000E+00,      .0000E+00,      .2960E-03,      .9858E-04,
     +       .4931E-03,      .9858E-04,      .1194E-02,      .1607E-03,
     +       .0000E+00,      .0000E+00,      .2770E-03,      .9228E-04,
     +       .4616E-03,      .9228E-04,      .1118E-02,      .1361E-03,
     +       .0000E+00,      .0000E+00,      .2590E-03,      .8628E-04,
     +       .4316E-03,      .8628E-04,      .1045E-02,      .1152E-03,
     +       .0000E+00,      .0000E+00,      .2419E-03,      .8058E-04,
     +       .4031E-03,      .8058E-04,      .9761E-03,      .9756E-04,
     +       .0000E+00,      .0000E+00,      .2256E-03,      .7517E-04,
     +       .3760E-03,      .7517E-04,      .9105E-03,      .8267E-04,
     +       .0000E+00,      .0000E+00,      .2102E-03,      .7003E-04,
     +       .3503E-03,      .7003E-04,      .8484E-03,      .7012E-04,
     +       .0000E+00,      .0000E+00,      .1956E-03,      .6518E-04,
     +       .3260E-03,      .6518E-04,      .7896E-03,      .5955E-04,
     +       .0000E+00,      .0000E+00,      .1819E-03,      .6059E-04,
     +       .3030E-03,      .6059E-04,      .7339E-03,      .5066E-04/
        DATA ((CELC(I,K,20),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .1688E-03,      .5626E-04,
     +       .2814E-03,      .5626E-04,      .6814E-03,      .4317E-04,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,21),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .4902E-03,      .1633E-03,
     +       .8168E-03,      .1633E-03,      .1961E-02,      .5975E-03,
     +       .0000E+00,      .0000E+00,      .4611E-03,      .1536E-03,
     +       .7683E-03,      .1536E-03,      .1846E-02,      .5068E-03,
     +       .0000E+00,      .0000E+00,      .4332E-03,      .1443E-03,
     +       .7219E-03,      .1443E-03,      .1736E-02,      .4287E-03,
     +       .0000E+00,      .0000E+00,      .4065E-03,      .1354E-03,
     +       .6774E-03,      .1354E-03,      .1630E-02,      .3617E-03,
     +       .0000E+00,      .0000E+00,      .3810E-03,      .1269E-03,
     +       .6348E-03,      .1269E-03,      .1529E-02,      .3044E-03,
     +       .0000E+00,      .0000E+00,      .3566E-03,      .1188E-03,
     +       .5942E-03,      .1188E-03,      .1432E-02,      .2556E-03,
     +       .0000E+00,      .0000E+00,      .3334E-03,      .1111E-03,
     +       .5556E-03,      .1111E-03,      .1339E-02,      .2143E-03,
     +       .0000E+00,      .0000E+00,      .3113E-03,      .1037E-03,
     +       .5187E-03,      .1037E-03,      .1251E-02,      .1794E-03,
     +       .0000E+00,      .0000E+00,      .2903E-03,      .9674E-04,
     +       .4838E-03,      .9674E-04,      .1167E-02,      .1500E-03/
        DATA ((CELC(I,K,21),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .2704E-03,      .9011E-04,
     +       .4506E-03,      .9011E-04,      .1087E-02,      .1253E-03,
     +       .0000E+00,      .0000E+00,      .2515E-03,      .8383E-04,
     +       .4192E-03,      .8383E-04,      .1011E-02,      .1046E-03,
     +       .0000E+00,      .0000E+00,      .2337E-03,      .7789E-04,
     +       .3895E-03,      .7789E-04,      .9398E-03,      .8739E-04,
     +       .0000E+00,      .0000E+00,      .2169E-03,      .7228E-04,
     +       .3615E-03,      .7228E-04,      .8722E-03,      .7301E-04,
     +       .0000E+00,      .0000E+00,      .2010E-03,      .6700E-04,
     +       .3350E-03,      .6700E-04,      .8085E-03,      .6105E-04,
     +       .0000E+00,      .0000E+00,      .1861E-03,      .6202E-04,
     +       .3102E-03,      .6202E-04,      .7485E-03,      .5111E-04,
     +       .0000E+00,      .0000E+00,      .1721E-03,      .5735E-04,
     +       .2868E-03,      .5735E-04,      .6921E-03,      .4285E-04,
     +       .0000E+00,      .0000E+00,      .1589E-03,      .5296E-04,
     +       .2648E-03,      .5296E-04,      .6392E-03,      .3600E-04,
     +       .0000E+00,      .0000E+00,      .1466E-03,      .4885E-04,
     +       .2443E-03,      .4885E-04,      .5896E-03,      .3031E-04/
        DATA ((CELC(I,K,21),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .1351E-03,      .4501E-04,
     +       .2251E-03,      .4501E-04,      .5432E-03,      .2558E-04,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,22),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .4400E-03,      .1466E-03,
     +       .7332E-03,      .1466E-03,      .1760E-02,      .4409E-03,
     +       .0000E+00,      .0000E+00,      .4107E-03,      .1369E-03,
     +       .6845E-03,      .1369E-03,      .1644E-02,      .3674E-03,
     +       .0000E+00,      .0000E+00,      .3830E-03,      .1276E-03,
     +       .6382E-03,      .1276E-03,      .1533E-02,      .3054E-03,
     +       .0000E+00,      .0000E+00,      .3566E-03,      .1189E-03,
     +       .5943E-03,      .1189E-03,      .1429E-02,      .2532E-03,
     +       .0000E+00,      .0000E+00,      .3317E-03,      .1105E-03,
     +       .5527E-03,      .1105E-03,      .1329E-02,      .2095E-03,
     +       .0000E+00,      .0000E+00,      .3080E-03,      .1027E-03,
     +       .5134E-03,      .1027E-03,      .1235E-02,      .1729E-03,
     +       .0000E+00,      .0000E+00,      .2857E-03,      .9524E-04,
     +       .4762E-03,      .9524E-04,      .1146E-02,      .1426E-03,
     +       .0000E+00,      .0000E+00,      .2647E-03,      .8823E-04,
     +       .4412E-03,      .8823E-04,      .1062E-02,      .1174E-03,
     +       .0000E+00,      .0000E+00,      .2449E-03,      .8163E-04,
     +       .4082E-03,      .8163E-04,      .9824E-03,      .9661E-04/
        DATA ((CELC(I,K,22),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .2263E-03,      .7543E-04,
     +       .3772E-03,      .7543E-04,      .9079E-03,      .7947E-04,
     +       .0000E+00,      .0000E+00,      .2088E-03,      .6961E-04,
     +       .3481E-03,      .6961E-04,      .8379E-03,      .6538E-04,
     +       .0000E+00,      .0000E+00,      .1925E-03,      .6416E-04,
     +       .3208E-03,      .6416E-04,      .7723E-03,      .5382E-04,
     +       .0000E+00,      .0000E+00,      .1772E-03,      .5905E-04,
     +       .2953E-03,      .5905E-04,      .7110E-03,      .4434E-04,
     +       .0000E+00,      .0000E+00,      .1629E-03,      .5429E-04,
     +       .2715E-03,      .5429E-04,      .6536E-03,      .3659E-04,
     +       .0000E+00,      .0000E+00,      .1495E-03,      .4985E-04,
     +       .2492E-03,      .4985E-04,      .6001E-03,      .3025E-04,
     +       .0000E+00,      .0000E+00,      .1371E-03,      .4571E-04,
     +       .2286E-03,      .4571E-04,      .5503E-03,      .2507E-04,
     +       .0000E+00,      .0000E+00,      .1256E-03,      .4186E-04,
     +       .2093E-03,      .4186E-04,      .5040E-03,      .2083E-04,
     +       .0000E+00,      .0000E+00,      .1149E-03,      .3829E-04,
     +       .1915E-03,      .3829E-04,      .4610E-03,      .1736E-04/
        DATA ((CELC(I,K,22),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .1050E-03,      .3498E-04,
     +       .1749E-03,      .3498E-04,      .4212E-03,      .1451E-04,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,23),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .3874E-03,      .1291E-03,
     +       .6457E-03,      .1291E-03,      .1550E-02,      .3138E-03,
     +       .0000E+00,      .0000E+00,      .3587E-03,      .1196E-03,
     +       .5978E-03,      .1196E-03,      .1435E-02,      .2564E-03,
     +       .0000E+00,      .0000E+00,      .3317E-03,      .1105E-03,
     +       .5527E-03,      .1105E-03,      .1327E-02,      .2092E-03,
     +       .0000E+00,      .0000E+00,      .3062E-03,      .1021E-03,
     +       .5104E-03,      .1021E-03,      .1226E-02,      .1702E-03,
     +       .0000E+00,      .0000E+00,      .2824E-03,      .9413E-04,
     +       .4706E-03,      .9413E-04,      .1131E-02,      .1382E-03,
     +       .0000E+00,      .0000E+00,      .2600E-03,      .8668E-04,
     +       .4334E-03,      .8668E-04,      .1041E-02,      .1120E-03,
     +       .0000E+00,      .0000E+00,      .2391E-03,      .7971E-04,
     +       .3986E-03,      .7971E-04,      .9578E-03,      .9072E-04,
     +       .0000E+00,      .0000E+00,      .2196E-03,      .7321E-04,
     +       .3661E-03,      .7321E-04,      .8798E-03,      .7340E-04,
     +       .0000E+00,      .0000E+00,      .2014E-03,      .6714E-04,
     +       .3357E-03,      .6714E-04,      .8070E-03,      .5938E-04/
        DATA ((CELC(I,K,23),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .1845E-03,      .6150E-04,
     +       .3075E-03,      .6150E-04,      .7392E-03,      .4804E-04,
     +       .0000E+00,      .0000E+00,      .1688E-03,      .5625E-04,
     +       .2813E-03,      .5625E-04,      .6762E-03,      .3890E-04,
     +       .0000E+00,      .0000E+00,      .1542E-03,      .5139E-04,
     +       .2569E-03,      .5139E-04,      .6177E-03,      .3154E-04,
     +       .0000E+00,      .0000E+00,      .1406E-03,      .4688E-04,
     +       .2344E-03,      .4688E-04,      .5635E-03,      .2561E-04,
     +       .0000E+00,      .0000E+00,      .1281E-03,      .4271E-04,
     +       .2136E-03,      .4271E-04,      .5134E-03,      .2085E-04,
     +       .0000E+00,      .0000E+00,      .1166E-03,      .3886E-04,
     +       .1943E-03,      .3886E-04,      .4672E-03,      .1702E-04,
     +       .0000E+00,      .0000E+00,      .1059E-03,      .3531E-04,
     +       .1766E-03,      .3531E-04,      .4245E-03,      .1393E-04,
     +       .0000E+00,      .0000E+00,      .9614E-04,      .3205E-04,
     +       .1602E-03,      .3205E-04,      .3852E-03,      .1145E-04,
     +       .0000E+00,      .0000E+00,      .8713E-04,      .2904E-04,
     +       .1452E-03,      .2904E-04,      .3492E-03,      .9440E-05/
        DATA ((CELC(I,K,23),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .7887E-04,      .2629E-04,
     +       .1314E-03,      .2629E-04,      .3160E-03,      .7816E-05,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,24),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .3337E-03,      .1112E-03,
     +       .5562E-03,      .1112E-03,      .1335E-02,      .2139E-03,
     +       .0000E+00,      .0000E+00,      .3061E-03,      .1020E-03,
     +       .5102E-03,      .1020E-03,      .1225E-02,      .1711E-03,
     +       .0000E+00,      .0000E+00,      .2804E-03,      .9346E-04,
     +       .4673E-03,      .9346E-04,      .1122E-02,      .1367E-03,
     +       .0000E+00,      .0000E+00,      .2565E-03,      .8549E-04,
     +       .4274E-03,      .8549E-04,      .1026E-02,      .1089E-03,
     +       .0000E+00,      .0000E+00,      .2343E-03,      .7809E-04,
     +       .3904E-03,      .7809E-04,      .9375E-03,      .8668E-04,
     +       .0000E+00,      .0000E+00,      .2137E-03,      .7122E-04,
     +       .3561E-03,      .7122E-04,      .8552E-03,      .6888E-04,
     +       .0000E+00,      .0000E+00,      .1946E-03,      .6488E-04,
     +       .3244E-03,      .6488E-04,      .7790E-03,      .5470E-04,
     +       .0000E+00,      .0000E+00,      .1770E-03,      .5901E-04,
     +       .2950E-03,      .5901E-04,      .7086E-03,      .4343E-04,
     +       .0000E+00,      .0000E+00,      .1608E-03,      .5360E-04,
     +       .2680E-03,      .5360E-04,      .6436E-03,      .3449E-04/
        DATA ((CELC(I,K,24),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .1458E-03,      .4861E-04,
     +       .2431E-03,      .4861E-04,      .5838E-03,      .2741E-04,
     +       .0000E+00,      .0000E+00,      .1321E-03,      .4403E-04,
     +       .2202E-03,      .4403E-04,      .5288E-03,      .2183E-04,
     +       .0000E+00,      .0000E+00,      .1195E-03,      .3983E-04,
     +       .1991E-03,      .3983E-04,      .4783E-03,      .1741E-04,
     +       .0000E+00,      .0000E+00,      .1079E-03,      .3597E-04,
     +       .1799E-03,      .3597E-04,      .4320E-03,      .1393E-04,
     +       .0000E+00,      .0000E+00,      .9734E-04,      .3245E-04,
     +       .1622E-03,      .3245E-04,      .3897E-03,      .1118E-04,
     +       .0000E+00,      .0000E+00,      .8768E-04,      .2923E-04,
     +       .1461E-03,      .2923E-04,      .3510E-03,      .9003E-05,
     +       .0000E+00,      .0000E+00,      .7888E-04,      .2629E-04,
     +       .1315E-03,      .2629E-04,      .3158E-03,      .7282E-05,
     +       .0000E+00,      .0000E+00,      .7086E-04,      .2362E-04,
     +       .1181E-03,      .2362E-04,      .2837E-03,      .5915E-05,
     +       .0000E+00,      .0000E+00,      .6357E-04,      .2119E-04,
     +       .1059E-03,      .2119E-04,      .2545E-03,      .4828E-05/
        DATA ((CELC(I,K,24),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .5695E-04,      .1898E-04,
     +       .9492E-04,      .1898E-04,      .2280E-03,      .3959E-05,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,25),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .2800E-03,      .9332E-04,
     +       .4666E-03,      .9332E-04,      .1120E-02,      .1382E-03,
     +       .0000E+00,      .0000E+00,      .2541E-03,      .8470E-04,
     +       .4235E-03,      .8470E-04,      .1016E-02,      .1080E-03,
     +       .0000E+00,      .0000E+00,      .2303E-03,      .7677E-04,
     +       .3838E-03,      .7677E-04,      .9213E-03,      .8428E-04,
     +       .0000E+00,      .0000E+00,      .2084E-03,      .6948E-04,
     +       .3474E-03,      .6948E-04,      .8338E-03,      .6567E-04,
     +       .0000E+00,      .0000E+00,      .1884E-03,      .6279E-04,
     +       .3139E-03,      .6279E-04,      .7536E-03,      .5109E-04,
     +       .0000E+00,      .0000E+00,      .1700E-03,      .5666E-04,
     +       .2833E-03,      .5666E-04,      .6800E-03,      .3972E-04,
     +       .0000E+00,      .0000E+00,      .1532E-03,      .5105E-04,
     +       .2553E-03,      .5105E-04,      .6127E-03,      .3087E-04,
     +       .0000E+00,      .0000E+00,      .1378E-03,      .4593E-04,
     +       .2297E-03,      .4593E-04,      .5513E-03,      .2401E-04,
     +       .0000E+00,      .0000E+00,      .1238E-03,      .4127E-04,
     +       .2063E-03,      .4127E-04,      .4953E-03,      .1869E-04/
        DATA ((CELC(I,K,25),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .1111E-03,      .3702E-04,
     +       .1851E-03,      .3702E-04,      .4444E-03,      .1458E-04,
     +       .0000E+00,      .0000E+00,      .9948E-04,      .3316E-04,
     +       .1658E-03,      .3316E-04,      .3981E-03,      .1140E-04,
     +       .0000E+00,      .0000E+00,      .8899E-04,      .2966E-04,
     +       .1483E-03,      .2966E-04,      .3561E-03,      .8939E-05,
     +       .0000E+00,      .0000E+00,      .7948E-04,      .2649E-04,
     +       .1325E-03,      .2649E-04,      .3180E-03,      .7038E-05,
     +       .0000E+00,      .0000E+00,      .7089E-04,      .2363E-04,
     +       .1182E-03,      .2363E-04,      .2837E-03,      .5566E-05,
     +       .0000E+00,      .0000E+00,      .6314E-04,      .2105E-04,
     +       .1052E-03,      .2105E-04,      .2527E-03,      .4423E-05,
     +       .0000E+00,      .0000E+00,      .5616E-04,      .1872E-04,
     +       .9360E-04,      .1872E-04,      .2247E-03,      .3533E-05,
     +       .0000E+00,      .0000E+00,      .4988E-04,      .1663E-04,
     +       .8313E-04,      .1663E-04,      .1996E-03,      .2837E-05,
     +       .0000E+00,      .0000E+00,      .4424E-04,      .1475E-04,
     +       .7373E-04,      .1475E-04,      .1770E-03,      .2291E-05/
        DATA ((CELC(I,K,25),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .3918E-04,      .1306E-04,
     +       .6530E-04,      .1306E-04,      .1568E-03,      .1861E-05,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,26),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .2274E-03,      .7579E-04,
     +       .3789E-03,      .7579E-04,      .9094E-03,      .8359E-04,
     +       .0000E+00,      .0000E+00,      .2039E-03,      .6796E-04,
     +       .3398E-03,      .6796E-04,      .8155E-03,      .6354E-04,
     +       .0000E+00,      .0000E+00,      .1826E-03,      .6085E-04,
     +       .3043E-03,      .6085E-04,      .7302E-03,      .4831E-04,
     +       .0000E+00,      .0000E+00,      .1632E-03,      .5441E-04,
     +       .2720E-03,      .5441E-04,      .6529E-03,      .3670E-04,
     +       .0000E+00,      .0000E+00,      .1457E-03,      .4857E-04,
     +       .2428E-03,      .4857E-04,      .5828E-03,      .2784E-04,
     +       .0000E+00,      .0000E+00,      .1299E-03,      .4329E-04,
     +       .2165E-03,      .4329E-04,      .5195E-03,      .2112E-04,
     +       .0000E+00,      .0000E+00,      .1156E-03,      .3853E-04,
     +       .1926E-03,      .3853E-04,      .4624E-03,      .1603E-04,
     +       .0000E+00,      .0000E+00,      .1027E-03,      .3424E-04,
     +       .1712E-03,      .3424E-04,      .4109E-03,      .1218E-04,
     +       .0000E+00,      .0000E+00,      .9113E-04,      .3038E-04,
     +       .1519E-03,      .3038E-04,      .3645E-03,      .9282E-05/
        DATA ((CELC(I,K,26),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .8073E-04,      .2691E-04,
     +       .1346E-03,      .2691E-04,      .3230E-03,      .7092E-05,
     +       .0000E+00,      .0000E+00,      .7141E-04,      .2380E-04,
     +       .1190E-03,      .2380E-04,      .2857E-03,      .5439E-05,
     +       .0000E+00,      .0000E+00,      .6307E-04,      .2102E-04,
     +       .1051E-03,      .2102E-04,      .2523E-03,      .4190E-05,
     +       .0000E+00,      .0000E+00,      .5562E-04,      .1854E-04,
     +       .9271E-04,      .1854E-04,      .2225E-03,      .3245E-05,
     +       .0000E+00,      .0000E+00,      .4898E-04,      .1633E-04,
     +       .8163E-04,      .1633E-04,      .1959E-03,      .2527E-05,
     +       .0000E+00,      .0000E+00,      .4307E-04,      .1436E-04,
     +       .7178E-04,      .1436E-04,      .1723E-03,      .1981E-05,
     +       .0000E+00,      .0000E+00,      .3781E-04,      .1260E-04,
     +       .6302E-04,      .1260E-04,      .1513E-03,      .1562E-05,
     +       .0000E+00,      .0000E+00,      .3315E-04,      .1105E-04,
     +       .5525E-04,      .1105E-04,      .1326E-03,      .1240E-05,
     +       .0000E+00,      .0000E+00,      .2902E-04,      .9673E-05,
     +       .4837E-04,      .9673E-05,      .1161E-03,      .9909E-06/
        DATA ((CELC(I,K,26),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .2537E-04,      .8456E-05,
     +       .4228E-04,      .8456E-05,      .1015E-03,      .7967E-06,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,27),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1771E-03,      .5904E-04,
     +       .2952E-03,      .5904E-04,      .7085E-03,      .4632E-04,
     +       .0000E+00,      .0000E+00,      .1566E-03,      .5220E-04,
     +       .2610E-03,      .5220E-04,      .6264E-03,      .3411E-04,
     +       .0000E+00,      .0000E+00,      .1383E-03,      .4609E-04,
     +       .2304E-03,      .4609E-04,      .5530E-03,      .2517E-04,
     +       .0000E+00,      .0000E+00,      .1219E-03,      .4062E-04,
     +       .2031E-03,      .4062E-04,      .4875E-03,      .1857E-04,
     +       .0000E+00,      .0000E+00,      .1073E-03,      .3575E-04,
     +       .1788E-03,      .3575E-04,      .4290E-03,      .1369E-04,
     +       .0000E+00,      .0000E+00,      .9423E-04,      .3141E-04,
     +       .1571E-03,      .3141E-04,      .3769E-03,      .1010E-04,
     +       .0000E+00,      .0000E+00,      .8266E-04,      .2755E-04,
     +       .1378E-03,      .2755E-04,      .3306E-03,      .7468E-05,
     +       .0000E+00,      .0000E+00,      .7240E-04,      .2413E-04,
     +       .1207E-03,      .2413E-04,      .2896E-03,      .5534E-05,
     +       .0000E+00,      .0000E+00,      .6331E-04,      .2110E-04,
     +       .1055E-03,      .2110E-04,      .2532E-03,      .4116E-05/
        DATA ((CELC(I,K,27),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .5527E-04,      .1842E-04,
     +       .9212E-04,      .1842E-04,      .2211E-03,      .3075E-05,
     +       .0000E+00,      .0000E+00,      .4818E-04,      .1606E-04,
     +       .8030E-04,      .1606E-04,      .1927E-03,      .2310E-05,
     +       .0000E+00,      .0000E+00,      .4193E-04,      .1398E-04,
     +       .6988E-04,      .1398E-04,      .1677E-03,      .1746E-05,
     +       .0000E+00,      .0000E+00,      .3643E-04,      .1214E-04,
     +       .6072E-04,      .1214E-04,      .1457E-03,      .1329E-05,
     +       .0000E+00,      .0000E+00,      .3161E-04,      .1054E-04,
     +       .5268E-04,      .1054E-04,      .1264E-03,      .1019E-05,
     +       .0000E+00,      .0000E+00,      .2738E-04,      .9126E-05,
     +       .4563E-04,      .9126E-05,      .1095E-03,      .7875E-06,
     +       .0000E+00,      .0000E+00,      .2368E-04,      .7893E-05,
     +       .3947E-04,      .7893E-05,      .9472E-04,      .6131E-06,
     +       .0000E+00,      .0000E+00,      .2045E-04,      .6816E-05,
     +       .3408E-04,      .6816E-05,      .8180E-04,      .4810E-06,
     +       .0000E+00,      .0000E+00,      .1763E-04,      .5878E-05,
     +       .2939E-04,      .5878E-05,      .7053E-04,      .3800E-06/
        DATA ((CELC(I,K,27),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .1518E-04,      .5061E-05,
     +       .2530E-04,      .5061E-05,      .6073E-04,      .3022E-06,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,28),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .1305E-03,      .4350E-04,
     +       .2175E-03,      .4350E-04,      .5220E-03,      .2278E-04,
     +       .0000E+00,      .0000E+00,      .1134E-03,      .3781E-04,
     +       .1891E-03,      .3781E-04,      .4538E-03,      .1615E-04,
     +       .0000E+00,      .0000E+00,      .9847E-04,      .3282E-04,
     +       .1641E-03,      .3282E-04,      .3939E-03,      .1150E-04,
     +       .0000E+00,      .0000E+00,      .8533E-04,      .2844E-04,
     +       .1422E-03,      .2844E-04,      .3413E-03,      .8211E-05,
     +       .0000E+00,      .0000E+00,      .7382E-04,      .2461E-04,
     +       .1230E-03,      .2461E-04,      .2953E-03,      .5854E-05,
     +       .0000E+00,      .0000E+00,      .6375E-04,      .2125E-04,
     +       .1063E-03,      .2125E-04,      .2550E-03,      .4183E-05,
     +       .0000E+00,      .0000E+00,      .5497E-04,      .1832E-04,
     +       .9162E-04,      .1832E-04,      .2199E-03,      .3001E-05,
     +       .0000E+00,      .0000E+00,      .4732E-04,      .1577E-04,
     +       .7886E-04,      .1577E-04,      .1893E-03,      .2162E-05,
     +       .0000E+00,      .0000E+00,      .4066E-04,      .1355E-04,
     +       .6777E-04,      .1355E-04,      .1626E-03,      .1566E-05/
        DATA ((CELC(I,K,28),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .3488E-04,      .1163E-04,
     +       .5814E-04,      .1163E-04,      .1395E-03,      .1142E-05,
     +       .0000E+00,      .0000E+00,      .2988E-04,      .9959E-05,
     +       .4980E-04,      .9959E-05,      .1195E-03,      .8389E-06,
     +       .0000E+00,      .0000E+00,      .2555E-04,      .8516E-05,
     +       .4258E-04,      .8516E-05,      .1022E-03,      .6216E-06,
     +       .0000E+00,      .0000E+00,      .2181E-04,      .7270E-05,
     +       .3635E-04,      .7270E-05,      .8723E-04,      .4647E-06,
     +       .0000E+00,      .0000E+00,      .1859E-04,      .6196E-05,
     +       .3098E-04,      .6196E-05,      .7435E-04,      .3506E-06,
     +       .0000E+00,      .0000E+00,      .1582E-04,      .5272E-05,
     +       .2636E-04,      .5272E-05,      .6326E-04,      .2669E-06,
     +       .0000E+00,      .0000E+00,      .1344E-04,      .4479E-05,
     +       .2239E-04,      .4479E-05,      .5374E-04,      .2050E-06,
     +       .0000E+00,      .0000E+00,      .1140E-04,      .3799E-05,
     +       .1899E-04,      .3799E-05,      .4558E-04,      .1587E-06,
     +       .0000E+00,      .0000E+00,      .9651E-05,      .3217E-05,
     +       .1609E-04,      .3217E-05,      .3860E-04,      .1238E-06/
        DATA ((CELC(I,K,28),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .8160E-05,      .2720E-05,
     +       .1360E-04,      .2720E-05,      .3264E-04,      .9727E-07,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,29),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .8872E-04,      .2957E-04,
     +       .1479E-03,      .2957E-04,      .3549E-03,      .9408E-05,
     +       .0000E+00,      .0000E+00,      .7550E-04,      .2517E-04,
     +       .1258E-03,      .2517E-04,      .3020E-03,      .6361E-05,
     +       .0000E+00,      .0000E+00,      .6417E-04,      .2139E-04,
     +       .1069E-03,      .2139E-04,      .2567E-03,      .4341E-05,
     +       .0000E+00,      .0000E+00,      .5444E-04,      .1815E-04,
     +       .9073E-04,      .1815E-04,      .2178E-03,      .2981E-05,
     +       .0000E+00,      .0000E+00,      .4611E-04,      .1537E-04,
     +       .7684E-04,      .1537E-04,      .1844E-03,      .2042E-05,
     +       .0000E+00,      .0000E+00,      .3898E-04,      .1299E-04,
     +       .6496E-04,      .1299E-04,      .1559E-03,      .1405E-05,
     +       .0000E+00,      .0000E+00,      .3290E-04,      .1097E-04,
     +       .5483E-04,      .1097E-04,      .1316E-03,      .9737E-06,
     +       .0000E+00,      .0000E+00,      .2771E-04,      .9238E-05,
     +       .4619E-04,      .9238E-05,      .1108E-03,      .6792E-06,
     +       .0000E+00,      .0000E+00,      .2331E-04,      .7768E-05,
     +       .3884E-04,      .7768E-05,      .9322E-04,      .4776E-06/
        DATA ((CELC(I,K,29),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .1956E-04,      .6522E-05,
     +       .3261E-04,      .6522E-05,      .7826E-04,      .3392E-06,
     +       .0000E+00,      .0000E+00,      .1640E-04,      .5465E-05,
     +       .2733E-04,      .5465E-05,      .6558E-04,      .2433E-06,
     +       .0000E+00,      .0000E+00,      .1372E-04,      .4572E-05,
     +       .2286E-04,      .4572E-05,      .5486E-04,      .1765E-06,
     +       .0000E+00,      .0000E+00,      .1145E-04,      .3818E-05,
     +       .1909E-04,      .3818E-05,      .4582E-04,      .1295E-06,
     +       .0000E+00,      .0000E+00,      .9550E-05,      .3183E-05,
     +       .1592E-04,      .3183E-05,      .3820E-04,      .9600E-07,
     +       .0000E+00,      .0000E+00,      .7948E-05,      .2649E-05,
     +       .1325E-04,      .2649E-05,      .3179E-04,      .7192E-07,
     +       .0000E+00,      .0000E+00,      .6604E-05,      .2201E-05,
     +       .1101E-04,      .2201E-05,      .2642E-04,      .5440E-07,
     +       .0000E+00,      .0000E+00,      .5478E-05,      .1826E-05,
     +       .9130E-05,      .1826E-05,      .2191E-04,      .4149E-07,
     +       .0000E+00,      .0000E+00,      .4537E-05,      .1512E-05,
     +       .7561E-05,      .1512E-05,      .1815E-04,      .3188E-07/
        DATA ((CELC(I,K,29),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .3751E-05,      .1250E-05,
     +       .6251E-05,      .1250E-05,      .1500E-04,      .2465E-07,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,30),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .5304E-04,      .1768E-04,
     +       .8841E-04,      .1768E-04,      .2122E-03,      .2931E-05,
     +       .0000E+00,      .0000E+00,      .4390E-04,      .1463E-04,
     +       .7317E-04,      .1463E-04,      .1756E-03,      .1861E-05,
     +       .0000E+00,      .0000E+00,      .3629E-04,      .1210E-04,
     +       .6048E-04,      .1210E-04,      .1452E-03,      .1202E-05,
     +       .0000E+00,      .0000E+00,      .2994E-04,      .9981E-05,
     +       .4990E-04,      .9981E-05,      .1198E-03,      .7899E-06,
     +       .0000E+00,      .0000E+00,      .2466E-04,      .8219E-05,
     +       .4110E-04,      .8219E-05,      .9863E-04,      .5147E-06,
     +       .0000E+00,      .0000E+00,      .2027E-04,      .6756E-05,
     +       .3378E-04,      .6756E-05,      .8107E-04,      .3371E-06,
     +       .0000E+00,      .0000E+00,      .1663E-04,      .5543E-05,
     +       .2771E-04,      .5543E-05,      .6651E-04,      .2249E-06,
     +       .0000E+00,      .0000E+00,      .1362E-04,      .4539E-05,
     +       .2269E-04,      .4539E-05,      .5447E-04,      .1513E-06,
     +       .0000E+00,      .0000E+00,      .1113E-04,      .3710E-05,
     +       .1855E-04,      .3710E-05,      .4452E-04,      .1027E-06/
        DATA ((CELC(I,K,30),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .9081E-05,      .3027E-05,
     +       .1513E-04,      .3027E-05,      .3632E-04,      .7089E-07,
     +       .0000E+00,      .0000E+00,      .7395E-05,      .2465E-05,
     +       .1233E-04,      .2465E-05,      .2958E-04,      .4961E-07,
     +       .0000E+00,      .0000E+00,      .6011E-05,      .2004E-05,
     +       .1002E-04,      .2004E-05,      .2405E-04,      .3514E-07,
     +       .0000E+00,      .0000E+00,      .4878E-05,      .1626E-05,
     +       .8130E-05,      .1626E-05,      .1951E-04,      .2525E-07,
     +       .0000E+00,      .0000E+00,      .3951E-05,      .1317E-05,
     +       .6585E-05,      .1317E-05,      .1580E-04,      .1837E-07,
     +       .0000E+00,      .0000E+00,      .3194E-05,      .1065E-05,
     +       .5324E-05,      .1065E-05,      .1278E-04,      .1349E-07,
     +       .0000E+00,      .0000E+00,      .2578E-05,      .8594E-06,
     +       .4297E-05,      .8594E-06,      .1031E-04,      .1001E-07,
     +       .0000E+00,      .0000E+00,      .2077E-05,      .6924E-06,
     +       .3462E-05,      .6924E-06,      .8309E-05,      .7482E-08,
     +       .0000E+00,      .0000E+00,      .1671E-05,      .5569E-06,
     +       .2785E-05,      .5569E-06,      .6683E-05,      .5625E-08/
        DATA ((CELC(I,K,30),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .1342E-05,      .4472E-06,
     +       .2236E-05,      .4472E-06,      .5366E-05,      .4252E-08,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,31),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .2490E-04,      .8300E-05,
     +       .4150E-04,      .8300E-05,      .9960E-04,      .5345E-06,
     +       .0000E+00,      .0000E+00,      .1976E-04,      .6588E-05,
     +       .3294E-04,      .6588E-05,      .7906E-04,      .3091E-06,
     +       .0000E+00,      .0000E+00,      .1568E-04,      .5228E-05,
     +       .2614E-04,      .5228E-05,      .6273E-04,      .1851E-06,
     +       .0000E+00,      .0000E+00,      .1243E-04,      .4142E-05,
     +       .2071E-04,      .4142E-05,      .4970E-04,      .1160E-06,
     +       .0000E+00,      .0000E+00,      .9825E-05,      .3275E-05,
     +       .1638E-04,      .3275E-05,      .3930E-04,      .7050E-07,
     +       .0000E+00,      .0000E+00,      .7755E-05,      .2585E-05,
     +       .1293E-04,      .2585E-05,      .3102E-04,      .4259E-07,
     +       .0000E+00,      .0000E+00,      .6110E-05,      .2037E-05,
     +       .1018E-04,      .2037E-05,      .2444E-04,      .2736E-07,
     +       .0000E+00,      .0000E+00,      .4805E-05,      .1602E-05,
     +       .8009E-05,      .1602E-05,      .1922E-04,      .1788E-07,
     +       .0000E+00,      .0000E+00,      .3772E-05,      .1257E-05,
     +       .6287E-05,      .1257E-05,      .1509E-04,      .1149E-07/
        DATA ((CELC(I,K,31),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .2955E-05,      .9851E-06,
     +       .4925E-05,      .9851E-06,      .1182E-04,      .7633E-08,
     +       .0000E+00,      .0000E+00,      .2311E-05,      .7703E-06,
     +       .3852E-05,      .7703E-06,      .9244E-05,      .5271E-08,
     +       .0000E+00,      .0000E+00,      .1804E-05,      .6012E-06,
     +       .3006E-05,      .6012E-06,      .7215E-05,      .3627E-08,
     +       .0000E+00,      .0000E+00,      .1405E-05,      .4683E-06,
     +       .2342E-05,      .4683E-06,      .5620E-05,      .2519E-08,
     +       .0000E+00,      .0000E+00,      .1092E-05,      .3641E-06,
     +       .1821E-05,      .3641E-06,      .4369E-05,      .1796E-08,
     +       .0000E+00,      .0000E+00,      .8476E-06,      .2825E-06,
     +       .1413E-05,      .2825E-06,      .3390E-05,      .1284E-08,
     +       .0000E+00,      .0000E+00,      .6564E-06,      .2188E-06,
     +       .1094E-05,      .2188E-06,      .2625E-05,      .9189E-09,
     +       .0000E+00,      .0000E+00,      .5073E-06,      .1691E-06,
     +       .8455E-06,      .1691E-06,      .2029E-05,      .6668E-09,
     +       .0000E+00,      .0000E+00,      .3913E-06,      .1304E-06,
     +       .6522E-06,      .1304E-06,      .1565E-05,      .4847E-09/
        DATA ((CELC(I,K,31),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .3013E-06,      .1004E-06,
     +       .5021E-06,      .1004E-06,      .1205E-05,      .3507E-09,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
        DATA ((CELC(I,K,32),I=1,8), K=1,9) /   
     +       .0000E+00,      .0000E+00,      .6091E-05,      .2030E-05,
     +       .1015E-04,      .2030E-05,      .2436E-04,      .2282E-07,
     +       .0000E+00,      .0000E+00,      .4497E-05,      .1499E-05,
     +       .7496E-05,      .1499E-05,      .1799E-04,      .1070E-07,
     +       .0000E+00,      .0000E+00,      .3322E-05,      .1107E-05,
     +       .5537E-05,      .1107E-05,      .1329E-04,      .5779E-08,
     +       .0000E+00,      .0000E+00,      .2448E-05,      .8160E-06,
     +       .4080E-05,      .8160E-06,      .9792E-05,      .4083E-08,
     +       .0000E+00,      .0000E+00,      .1795E-05,      .5984E-06,
     +       .2992E-05,      .5984E-06,      .7181E-05,      .2368E-08,
     +       .0000E+00,      .0000E+00,      .1312E-05,      .4372E-06,
     +       .2186E-05,      .4372E-06,      .5247E-05,      .1090E-08,
     +       .0000E+00,      .0000E+00,      .9547E-06,      .3182E-06,
     +       .1591E-05,      .3182E-06,      .3819E-05,      .8345E-09,
     +       .0000E+00,      .0000E+00,      .6917E-06,      .2306E-06,
     +       .1153E-05,      .2306E-06,      .2767E-05,      .7180E-09,
     +       .0000E+00,      .0000E+00,      .4989E-06,      .1663E-06,
     +       .8314E-06,      .1663E-06,      .1995E-05,      .3660E-09/
        DATA ((CELC(I,K,32),I=1,8), K=10,18) / 
     +       .0000E+00,      .0000E+00,      .3580E-06,      .1193E-06,
     +       .5966E-06,      .1193E-06,      .1432E-05,      .1734E-09,
     +       .0000E+00,      .0000E+00,      .2555E-06,      .8516E-07,
     +       .4258E-06,      .8516E-07,      .1022E-05,      .1700E-09,
     +       .0000E+00,      .0000E+00,      .1813E-06,      .6042E-07,
     +       .3021E-06,      .6042E-07,      .7251E-06,      .1219E-09,
     +       .0000E+00,      .0000E+00,      .1278E-06,      .4261E-07,
     +       .2130E-06,      .4261E-07,      .5113E-06,      .4408E-10,
     +       .0000E+00,      .0000E+00,      .8952E-07,      .2984E-07,
     +       .1492E-06,      .2984E-07,      .3581E-06,      .2505E-10,
     +       .0000E+00,      .0000E+00,      .6223E-07,      .2074E-07,
     +       .1037E-06,      .2074E-07,      .2489E-06,      .2685E-10,
     +       .0000E+00,      .0000E+00,      .4291E-07,      .1430E-07,
     +       .7152E-07,      .1430E-07,      .1717E-06,      .1174E-10,
     +       .0000E+00,      .0000E+00,      .2933E-07,      .9777E-08,
     +       .4889E-07,      .9777E-08,      .1173E-06,      .6037E-12,
     +       .0000E+00,      .0000E+00,      .1985E-07,      .6618E-08,
     +       .3309E-07,      .6618E-08,      .7941E-07,      .1474E-11/
        DATA ((CELC(I,K,32),I=1,8), K=19,20) / 
     +       .0000E+00,      .0000E+00,      .1329E-07,      .4430E-08,
     +       .2215E-07,      .4430E-08,      .5316E-07,      .1234E-11,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00,
     +       .0000E+00,      .0000E+00,      .0000E+00,      .0000E+00/
C----------------------------------------------------------------------
       DATA ISTART/0/
       SAVE ISTART,OWLAM2,Q02,FLAV,KA, /W5051IA/, /W5051IB/
C
      IF (ISTART.EQ.0) THEN
        ISTART=1
        DO 10 K=1,32
        DO 10 I=1,20
        DO 10 M=1,8
        CALCO(M,I,K) = CALC(M,I,K)
   10   CELCO(M,I,K) = CELC(M,I,K)
           OWLAM=PAR(1)
           OWLAM2=OWLAM**2
           Q02=PAR(30)
           FLAV=PAR(25)
           DELTA=PAR(29)
           CALL WATE32
           KA=1.0
         ENDIF
C
      X = DX
      Q = DQ
      Q2 = Q*Q
      IDQ2=2
      SB=0.
      IF(Q2-Q02) 1,1,2
    2 IF(IDQ2-1) 1,1,3
    3 SB= LOG( LOG( MAX(Q02,Q2)/OWLAM2)/ LOG(Q02/OWLAM2))
    1 CONTINUE
      CALL AFGINT(8,0,X,SB,XPDF(7))
      CALL AFGINT(7,0,X,SB,SING)
      CALL AFGINT(4,0,X,SB,DPLUSNS)
      CALL AFGINT(3,0,X,SB,CPLUSNS)
      CALL AFGINT(5,0,X,SB,UPLUSNS)
      CALL AFGINT(6,0,X,SB,SPLUSNS)
      XPDF(3) = CPLUSNS
      XPDF(4) = DPLUSNS
      XPDF(5) = UPLUSNS
      XPDF(6) = SPLUSNS
      XPDF(1) = SING
C
      ADD = XPDF(1)/FLAV
      UPLUS= XPDF(5)+ADD
      DPLUS=-XPDF(4)+ADD
      SPLUS=-XPDF(6)+ADD
      CPLUS=-XPDF(3)+ADD
      SING=XPDF(1)
      GLU=XPDF(7)
      GL=GLU
*
      CALL AFGIN2(8,0,X,SB,XPDF(7))
      CALL AFGIN2(7,0,X,SB,SING)
      CALL AFGIN2(4,0,X,SB,DPLUSNS)
      CALL AFGIN2(3,0,X,SB,CPLUSNS)
      CALL AFGIN2(5,0,X,SB,UPLUSNS)
      CALL AFGIN2(6,0,X,SB,SPLUSNS)
      XPDF(3) = CPLUSNS
      XPDF(4) = DPLUSNS
      XPDF(5) = UPLUSNS
      XPDF(6) = SPLUSNS
      XPDF(1) = SING
C
      ADD2 = XPDF(1)/FLAV
      UPLU2= XPDF(5)+ADD2
      DPLU2=-XPDF(4)+ADD2
      SPLU2=-XPDF(6)+ADD2
      CPLU2=-XPDF(3)+ADD2
      SING2=XPDF(1)
      GLU2=XPDF(7)
      UB=UPLUS+UPLU2*KA
      UV=UB
      DB=DPLUS+DPLU2*KA
      DV=DB
      SB=SPLUS+SPLU2*KA
      CB=CPLUS+CPLU2*KA
      SING=SING+SING2*KA
      GL=GLU+GLU2*KA
*
      DUV=MAX(ZERO,UV)
      DDV=MAX(ZERO,DV)
      DUB=MAX(ZERO,UB)
      DDB=MAX(ZERO,DB)
      DSB=MAX(ZERO,SB)
      DCB=MAX(ZERO,CB)
      DGL=MAX(ZERO,GL)
C
      RETURN
      END
